Unit CGraph;

Interface
{$M 65000,1,655000}

Uses Dos;
Const
 ViewParallel=$01;
 ViewProspect=$02;
 MaxVrtPoly=3;
 MaxVrtObj=2100;
 MaxPolyObj=2500;

Type
 InfoType=Record
  VesaSign:Array [1..4] Of Char;
  VesaVers:Word;
  OEMStrPtr:Pointer;
  VesaCapab:Array [1..4] Of Byte;
  VideoPtr:Pointer;
  TotalMem:Word;
  Reserved:Array[1..236] Of Byte;
 End;

 InfoMode=Record
  ModeAttributes:Word;
  WinAAttributes:Byte;
  WinBAttributes:Byte;
  WinGranularity:Word;
  WinSize:Word;
  WinASegment:Word;
  WinBSegment:Word;
  WinFuncPtr:Pointer;
  BytesPerScanLine:Word;
  XResolution:Word;
  YResolution:Word;
  XCharSize:Byte;
  YCharSize:Byte;
  NumberOfPlanes:Byte;
  BitsPerPixel:Byte;
  NumberOfBanks:Byte;
  MemoryModel:Byte;
  BankSize:Byte;
  NumberOfImagePages:Byte;
  Reserved:Byte;
  RedMaskSize:Byte;
  RedFieldPosition:Byte;
  GreenMaskSize:Byte;
  GreenFieldPosition:Byte;
  BlueMaskSize:Byte;
  BlueFieldPosition:Byte;
  RsvdMaskSize:Byte;
  DirectColorModeInfo:Byte;
  ReservedL:Array[1..216] Of Byte;
 End;


 RGBPalette=Record
  R,G,B:Byte;
 End;

 Buffer=^BufferVal;
 BufferVal=Array[1..65535] Of Byte;

  XMSRec=Record
   Transfer:LongInt;
   Source:Word;
   OffSource:LongInt;
   Dest:Word;
   OffDest:LongInt;
  End;

 Tmouse=Record
  Esiste:Boolean;
  Mostra:Boolean;
  NButtons:Byte;
  Button:word;
  X,Y,Xp,Yp,St:Integer;
 End;

 Image=Word;
 ClpPo=Array[0..255] Of Word;
 Clips=^ClpPo;

 ChrType=Record
  Buf:Array[0..16000] Of Byte;
  WPtr:^Word;
  Data,InitChar,NChar:Integer;
  TBStart,WidthTbl,VecStart:Integer;
  Up,Down:Integer;
 End;
 TXTFont=^ChrType;


 Pixel32Type=Record
  R,G,B,H:Byte;
 End;


 FLIData=Record
  FliDelay:Integer;
  FliFile:File;
  FliHead:Array[1..128] Of Byte;
  FliFrames:Word;
  FliX,FliY:Word;
  FliPlay:Word;
  FliStartX,FliStartY:Integer;
  FliLoop:Boolean;
  FliStart:LongInt;
  FLIRGB:Array[0..255] Of RGBPalette;
 End;


 Colore16Bit=Word;


 Vertex=Record
  X,Y,Z:Single;
 End;

 Poly=Record
  V1,V2,V3:Word;
 End;

 Object3D=Record
  WorldPos:Vertex;
  LocalPos:Vertex;
  NVertex:Integer;
  LocalVertex:Array[1..MaxVrtObj] Of Vertex;
  GlobalVertex:Array[1..MaxVrtObj] Of Vertex;
  NPoly:Integer;
  ObjectPoly:Array[1..MaxPolyObj] Of Poly;
  ObjectName:String[80];
 End;


Const
 Code256Mode=0;
 Code32KMode=1;
 Code65KMode=2;
 Code16MMode24Bit=3;
 Code16MMode32Bit=4;
 CodeNoMode=5;


Var
 ExtraKey:Boolean;
 NoFliDelay:Boolean;

 VdePTR:Pointer;
 VgaInfoBlock:InfoType;
 NoVesa:Boolean;
 XMax,YMax:Word;
 ColorMax:String[3];
 VgaModeInfo:InfoMode;
 ColorMaxCode:Byte;
 AspectRatio:Double;

 FontSet:Array[0..255] Of Buffer;
 StrCol,StrOmb,StrSpc,StrMde,StrDX,StrDY:Integer;

 Font:TXTFont;
 ChrMX,ChrMY,ChrDX,ChrDY:Byte;


 VideoLine,Video16Ln:Array[0..4095] Of Byte;
 CodeLine:Array[0..4095] Of Byte;
 ColrLine:Array[0..1280] of Byte;
 Header:Array[0..15] Of Byte;

 Bit,Bit2:Array[1..256] of byte;
 SDrive:Array[0..25] Of Byte;
 Key:Char;
 PressKey:String[32];

 RGB:Array[0..255] Of RGBPalette;
 ColRGB:Array[0..255] Of Colore16Bit;
 Col16M:Array[0..255] Of Pixel32Type;
 ShadowColor:Array[0..255] Of Boolean;
 Pixel16M:Pixel32Type;
 VideoBuffer:Buffer;

 XStart,YStart,XEnd,YEnd,XCentre,YCentre:Word;
 XPos,YPos:Integer;
 SysCol,SfnCol:Byte;
 BitsPerPixel:Byte;
 PixelStep,PixelLengTh:Integer;
 CirclePrecision:Byte;
 RotateX,RotateY:Integer;
 RotateGrads:Double;

 VirtualXMax,VirtualYMax,VirtualXStart:Integer;
 VirtualYStart,VirtualXEnd,VirtualYEnd:Integer;
 VirtualDim:Boolean;

 FLIVideo:Array[1..8] Of FLIData;
 FliBuf:Buffer;
 FliRead:Word;
 FliN:Byte;

 XMS_Exist,XMS_Error,HMA_Exist:Boolean;
 XMS_Free,XMS_MaxBlk:Word;
 XMS_Point:Pointer;
 XMS_DBL,XMS_V,XMS_L:XMSRec;
 XMSData:XMSRec;

 XMSVerM,XMSVerE:Byte;
 VideoPage1,VideoPage2:Word;

 VirtualPageSize:LongInt;
 PageSizeInByte:LongInt;
 PageForScreen:Byte;

 Ms:TMouse;


 DMARegPage,DMARegAddr,DMARegLengTh,DMAControl:Word;
 DMAPage,DMAPage1,DMAPage2:Byte;
 DMAOffs,DMAOffs1,DMAOffs2:Word;
 DMAData:Word;
 DSPFile:File;
 DSPReadFile:Word;
 DSPBaseAddr:Word;
 DSPBuf1,DSPBuf2:Buffer;
 DSPErr:Boolean;
 IRQ,DMA:Byte;
 OldInt:Pointer;
 SampleRate:Word;
 BufferSize:Word;
 DataLoad1,DataLoad2:Word;
 MonoMode:Boolean;
 FullBuffer:Boolean;
 VocLoop:Boolean;
 VocSize:LongInt;
 VocFirstBlock:Boolean;
 VocPos:LongInt;
 VocBuffer1:Boolean;
 VocEnd:Boolean;

 FMRight,FMLeft,FMBoth:Boolean;
 FMRightPort,FMLeftPort,FMBothPort:Word;


 PIGreco,GradFat,RadFat:Double;

 SinTbl,CosTbl:Array[0..360] Of Double;

 PaletteMode:Boolean;


{Insieme di funzioni matematiche,di varia utilit e per la gestione delle
stringhe.}
{---------------------------------------------------------------------------}

Function Esiste(NomeFile:String):Boolean;
Procedure Errore(S:String);
Function KeyPressed:Boolean;
Function ReadKey:Char;
Procedure KeyOff;
Procedure KeyOn;
Procedure ClrScr;
Function MicroSecond(H,M,S,C:Word):LongInt;
Procedure Delay(Ms:Word);

Function Min(N1,N2:Real):Real;
Function Max(N1,N2:Real):Real;
Function Grad(Rd:Real):Real;
Function Rad(Gr:Real):Real;
Function Pot(N,Exp:Word):Word;
Function Seno(Gradi:Real):Real;
Function CoSeno(Gradi:Real):Real;
Procedure CreateSinCosTable;
Function Tangente(Grad:Real):Real;
Function RNum(N:Char):Word;
Function RStr(N:Byte):String;
Function BinStr(num:word):string;
Function DecStr(num:word):string;
Function IntStr(num:Integer):string;
Function HexStr(num:word):string;
Function StrBin(numer:string):word;
Function StrDec(numer:string):word;
Function StrHex(numer:string):word;
Function Maiusc(ch:char):char;
Function StrMaiusc(s:string):string;
Function GetStr(Xi,Yi:Integer):String;
Function Dist(x1,y1,x2,y2:integer):real;
Function Dval(val1,val2:real):real;
Procedure Bitc8(x:byte);
Procedure Bitc16(x:word);
Procedure BitcN(p:buffer;i,x:word);
Procedure Bits8(var x:byte);
Procedure Bits16(var x:word);
Procedure BitsN(var p:buffer;i,x:word);
Procedure TrasfBit;
Procedure VerificaTasti;
Procedure VerDrive;


Function  XMSGetVer:Word;
Function  GetXMS(Var XMS_Handle:Word;KByte:Word):Boolean;
Function  FreeXMS(Var XMS_Handle:Word):Boolean;
Function  SizeOfXMS(Var XMS_Handle:Word):Word;
Procedure MoveXMS;
Procedure InitXMS;
Procedure XMSInfoMem;
Procedure TransfertXMS(Lung:LongInt);
Procedure SetSourceOffs(Lung:LongInt);
Procedure SetDestOffs(Lung:LongInt);
Procedure ToXMS(Var Src;Var XMS_Handle:Word);
Procedure FromXMS(Var XMS_Handle:Word;Var Dst);


Procedure FreeIMG(Var P:Buffer);
Procedure CaricaFont(FileName:String);
Procedure ReleaseFont;
Procedure SetStringSpace(Space:Integer);
Procedure SetStringColor(Color:Integer);
Procedure SetStringOmbre(Color:Integer);
Procedure SetStringMode(Mode:Integer);
Procedure SetStringDXY(Dx,Dy:Integer);
Procedure PutChr(X,Y,Let:Integer);
Procedure PutStr(X,Y:Integer;St:String);
Procedure PutStrOmb(X,Y:Integer;St:String);
Procedure BufChr(X,Y,Let:Integer);
Procedure BufStr(X,Y:Integer;St:String);
Procedure SfnChr(X,Y,Let:Integer);
Procedure SfnStr(X,Y:Integer;St:String);

Procedure LoadCHRFont(Name:String);
Procedure ChrDim(X,Y:Integer);
Procedure ChrPutChar(X,Y:Integer;Ch:Byte);
Procedure ChrBufChar(X,Y:Integer;Ch:Byte);
Procedure ChrSfnChar(X,Y:Integer;Ch:Byte);
Procedure ChrPutStr(X,Y:Integer;St:String);
Procedure ChrBufStr(X,Y:Integer;St:String);
Procedure ChrSfnStr(X,Y:Integer;St:String);


Procedure SetVirtualDim;
Procedure ReSetVirtualDim;
Procedure SetVirtualY(Y:Integer);
Procedure SetVirtualYStart(Y:Integer);
Procedure SetVirtualYEnd(Y:Integer);
Procedure SetVirtualX(X:Integer);
Procedure SetVirtualXStart(X:Integer);
Procedure SetVirtualXEnd(X:Integer);
Function PageDim:LongInt;
Function PageDimKB:Word;
Procedure GetVesa;
Procedure Svga(Mode:String);
Procedure SetLineStart(X:Word);
Procedure SetScanLine(X:Word);
Procedure SetBlock(Blocco:Word);
Procedure VisualPage(Page:Word);
Procedure GetModeInfo(Mode:Word);
Procedure CloseSvga;
Procedure LoadVideoMemory(FileName:String);
Procedure StoreVideoMemory(FileName:String);
Procedure LoadVideoPage(FileName:String);
Procedure StoreVideoPage(FileName:String);
Procedure FastFill(Var X;Count:Word;val:byte);
Procedure FastMove(Var Xi;Vdi,Count:word);
Procedure FreeVideoMemory;
Procedure RefreshON;
Procedure RefreshOFF;
Procedure ClScreen;
Procedure FastClearVideoMem(Offs,Count:Word);
Procedure FastVideoFill(Offs,Count:Word;Col:Byte);
Procedure FastVideoMove(OffsDest,Count:Word;OffsSource:Word);
Procedure FastFill32Bit(X:Pointer;Count:Word;Val:Byte);
Procedure FastMove32Bit(XSource,XDestin:Pointer;Count:Word);
Procedure ClMemory;

Procedure SetRGB(Col,R,G,B:Byte);
Procedure GetRGB(Col:Byte;Var R,G,B:Byte);
Procedure SetPaletteModeOn;
Procedure SetPaletteModeOff;
Procedure LoadPal(Name:String);
Procedure SavePal(Name:String);
Procedure SetColorOn(Col:Byte);
Procedure SetColorOff(Col:Byte);
Procedure Addcol(r,g,b:word);
Procedure Dimcol(r,g,b:word);
Procedure Schiarisci(qx:word);
Procedure Oscura(qx:word);
Procedure Aggiungirosso(qx:word);
Procedure Aggiungiverde(qx:word);
Procedure Aggiungiblu(qx:word);
Procedure Aggiungiviola(qx:word);
Procedure Aggiungigiallo(qx:word);
Procedure Aggiungiazzurro(qx:word);
Procedure Diminuiscirosso(qx:word);
Procedure Diminuisciverde(qx:word);
Procedure Diminuisciblu(qx:word);
Procedure Diminuisciviola(qx:word);
Procedure Diminuiscigiallo(qx:word);
Procedure Diminuisciazzurro(qx:word);
Procedure Satura(qx:word);
Procedure Desatura(qx:word);
Procedure RendiGrigia;
Procedure RendiRossa;
Procedure RendiVerde;
Procedure RendiBlu;
Procedure RendiGialla;
Procedure RendiAzzurra;
Procedure RendiViola;
Procedure SostCol(xi,yi,xf,yf:word;col1,col2:byte);
Procedure ScambiaCol(xi,yi,xf,yf:word;col1,col2:byte);


Procedure SetDoubleBuffer;
Procedure VScreen;
Procedure LScreen;
Procedure PutVideoLine(Y:Integer);
Procedure PutVideoLineX(X,Y,Nx:Integer);
Procedure BufVideoLine(Y:Integer);
Procedure SfnVideoLine(Y:Integer);
Procedure BufVideoLineX(X,Y,Nx:Integer);
Procedure SfnVideoLineX(X,Y,Nx:Integer);
Procedure RPointR(Xi,Yi,Xc,Yc:Integer;Angle:Double;Var NewX,NewY:Integer);
Procedure RPointL(Xi,Yi,Xc,Yc:Integer;Angle:Double;Var NewX,NewY:Integer);
Procedure SetReferXY(X,Y:Integer);
Procedure SetRotateGrads(Gradi:Double);


Procedure SetColor(Col:Byte);
Procedure SetSfnColor(Col:Byte);

Procedure MoveABS(X,Y:Integer);
Procedure MoveREL(DX,DY:Integer);
Procedure LineABS(X,Y:Integer);
Procedure LineREL(DX,DY:Integer);


Function GetPixel(X,Y:Integer):Byte;
Procedure PutPixel(X,Y:Integer;Color:Byte);
Procedure PutRealPixel(X,Y:Integer;R,G,B,S:Byte);
Procedure BufPixel(X,Y:Integer;Color:Byte);
Procedure SfnPixel(X,Y:Integer;Color:Byte);
Procedure GetRealPixel(X,Y:Integer;Var R,G,B,S:Byte);
Function BufGetPixel256(X,Y:Integer):Byte;
Function SfnGetPixel256(X,Y:Integer):Byte;

Procedure LineSetSpace(Spc:Integer);
Procedure LineSetLengTh(Stp:Integer);

Procedure Line(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure BufLine(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure SfnLine(Xi,Yi,Xf,Yf:Integer;Col:Byte);

Procedure Quadrate(Xi,Yi,Lato:Integer;Col:byte);
Procedure BufQuadrate(Xi,Yi,Lato:Integer;Col:byte);
Procedure SfnQuadrate(Xi,Yi,Lato:Integer;Col:byte);
Procedure Triangle(X1,Y1,X2,Y2,X3,Y3:Integer;Col:Byte);
Procedure BufTriangle(X1,Y1,X2,Y2,X3,Y3:Integer;Col:Byte);
Procedure SfnTriangle(X1,Y1,X2,Y2,X3,Y3:Integer;Col:Byte);
Procedure Rectangle(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure BufRectangle(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure SfnRectangle(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure PutArea(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure BufArea(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure SfnArea(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Procedure AddRealPixel(X,Y:Integer;R,G,B:Byte);
Procedure SubRealPixel(X,Y:Integer;R,G,B:Byte);
Procedure Circle(Xi,Yi,Raggio:Integer;Col:Byte);
Procedure BufCircle(Xi,Yi,Raggio:Integer;Col:Byte);
Procedure SfnCircle(Xi,Yi,Raggio:Integer;Col:Byte);
Procedure RealCircle(Xi,Yi,Raggio:Integer;R,G,B:Byte);
Procedure SetCirclePrecision(Pr:Byte);
Procedure Ellipse(X,Y,Dx,Dy:Integer;Col:Byte);
Procedure BufEllipse(X,Y,Dx,Dy:Integer;Col:Byte);
Procedure SfnEllipse(X,Y,Dx,Dy:Integer;Col:Byte);
Procedure Fill(X,Y:Integer;Col:Byte);
Procedure Flood(X,Y:Integer;Col,Sfn:Byte);



Procedure PutPixelRotate(X,Y:Integer;Color:Byte);
Procedure BufPixelRotate(X,Y:Integer;Color:Byte);
Procedure SfnPixelRotate(X,Y:Integer;Color:Byte);

Procedure SizeOfImage(Var SizeX,SizeY:Integer;Var IM:Image);
Procedure PutIMGRotate(Xi,Yi:Integer;Var IM:Image;Gr:Double);
Procedure BufIMGRotate(Xi,Yi:Integer;Var IM:Image;Gr:Double);
Procedure SfnIMGRotate(Xi,Yi:Integer;Var IM:Image;Gr:Double);
Procedure PutIMG256(Xi,Yi:Integer;Var IM:Image);
Procedure BufIMG256(Xi,Yi:Integer;Var IM:Image);
Procedure SfnIMG256(Xi,Yi:Integer;Var IM:Image);
Procedure BufPixel16M(X,Y:Integer;Color:Byte);
Procedure SfnPixel16M(X,Y:Integer;Color:Byte);

Procedure GetImage256(Xi,Yi,Xf,Yf:Integer;Var IM:Image);
Procedure DeleteImage(Var IM:Image);
Procedure LoadImage256(Nome:String;Var IM:Image);
Procedure SaveImage256(Nome:String;Xi,Yi,Xf,Yf:Integer);

Procedure LoadBMP(Name:String;Xi,Yi:Integer);
Procedure PutBMP(Name:String;Xi,Yi:Integer);
Procedure BufBMP(Name:String;Xi,Yi:Integer);
Procedure SfnBMP(Name:String;Xi,Yi:Integer);

Procedure LoadPCX(Name:String;X,Y:Integer);
Procedure PutPCX(Name:String;X,Y:Integer);
Procedure BufPCX(Name:String;X,Y:Integer);
Procedure SfnPCX(Name:String;X,Y:Integer);

Procedure FliOpen(Name:String;X,Y:Integer;Fli:Byte);
Procedure FliClose(FLiN:Byte);
Procedure FliLoadFrame;
Procedure FliView(N:Byte);
Procedure SfnFliView(N:Byte);


Procedure MStat;
Procedure SetVel(xcor,ycor,bs:word);
Procedure SetMouseXY(X,Y:Word);
Procedure MouseOFF;
Procedure MouseON;
Procedure InitMouse;
Procedure SetYcor(ymin,ymax:word);
Procedure SetXCor(XMin,XMax:Word);




Procedure NewInt;Interrupt;
Procedure SetIRQ(IRQ:Byte);
Procedure ReSetIRQ(IRQ:Byte);
Procedure PICReset;

Function DSPRec:Byte;
Function DSPReset:Boolean;
Function DSPRead:Byte;
Procedure DSPWrite(Data:Byte);
Procedure DSPPlay(Data:Byte);

Function DMAEnd:Boolean;
Procedure DMASetLine(DM:Byte);
Procedure DMABusyAddresses;
Procedure DMAInit;
Procedure DMAReInit;
Procedure DMAInitPlay(P:Buffer;Data:Word);
Procedure DMAInitRecord(P:Buffer;Data:Word);
Procedure DMAStop;
Function DMACount:Word;


Procedure SBSpeakerOn;
Procedure SBSpeakerOff;
Procedure DSPDetectBase;
Procedure DSPSetRate(Rate:Word);
Procedure DSPDMARecord(Rate:Word;Data:Word);
Procedure DSPDMAPlay(Rate:Word;Data:Word);

Procedure InitBlaster(B:Word;I,D:Byte;Sz:Word);
Procedure CloseBlaster;
Procedure SBSetInt;
Procedure SBResetInt;
Procedure SBPlay(P:Buffer);
Procedure SBRecord(P:Buffer);
Procedure SBCreateBuffer(Size:Word);
Procedure SBDeleteBuffer(Size:Word);
Procedure SBSetRate(Rate:Word);
Procedure BufSwap(Var P1,P2:Buffer);

Function VocTimeConst(Rate:Word):Byte;
Function VocBusyRate(Time:Word):Word;
Procedure VocOpen(Name:String);
Procedure VocLoadBuf1;
Procedure VocLoadBuf2;
Procedure VocClose;
Procedure VocPlay;
Procedure VocSetLoop;
Procedure VocSetNoLoop;
Procedure LoadVoc(Voc:String);


Procedure FMSetRight;
Procedure FMSetNoRight;
Procedure FMSetLeft;
Procedure FMSetNoLeft;
Procedure FMRightCommand(C:Byte);
Procedure FMLeftCommand(C:Byte);
Procedure FMRightData(C:Byte);
Procedure FMLeftData(C:Byte);
Function FMGetRightState:Byte;
Function FMGetLeftState:Byte;
Procedure FMSetBoth;
Procedure FMSetNoBoth;
Procedure FMBothCommand(C:Byte);
Procedure FMBothData(C:Byte);
Function FMGetBothState:Byte;
Function FMDetect:Boolean;
Procedure FMReset;
Procedure FMBothCD(Com,Dat:Byte);
Procedure FMBothOn;
Procedure FMBothOff;
Function FMFreqCod(F:Real):Word;
Procedure FMSound(F:Real;O:Byte);



Procedure Load3DS(Name:String;Var Obj3D:Object3D);
Procedure OBJ3D_SetWorldPos(X,Y,Z:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_SetLocalPos(X,Y,Z:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_Move(X,Y,Z:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_ReDim(Scala:Single;Var Obj3D:Object3D);
Procedure OBJ3D_RotateX(Angolo:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_RotateY(Angolo:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_RotateZ(Angolo:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_Rotate(AngoloX,AngoloY,AngoloZ:Integer;Var Obj3D:Object3D);
Procedure OBJ3D_Transform(Var Obj3D:Object3D);
Procedure SetParallelView;
Procedure SetProspectView;
Procedure OBJ3D_PutVertex(Var Obj3D:Object3D);
Procedure OBJ3D_BufVertex(Var Obj3D:Object3D);
Procedure OBJ3D_SfnVertex(Var Obj3D:Object3D);
Procedure OBJ3D_PutInWireFrame(Var Obj3D:Object3D);
Procedure OBJ3D_BufInWireFrame(Var Obj3D:Object3D);
Procedure OBJ3D_SfnInWireFrame(Var Obj3D:Object3D);



Implementation
{Insieme di funzioni matematiche,di varia utilit e per la gestione delle
stringhe.}
{---------------------------------------------------------------------------}
Procedure Errore(S:String);
Begin
 WriteLn(S);
 Halt(1);
End;


Function Esiste(NomeFile:String):Boolean;
 Var F:File;
Begin
{$I-}
 Assign(f,NomeFile);
 Reset(f);
 Close(f);
{$I+}
 Esiste:=(IoResult=0) And (NomeFile <> '');
End;



Procedure ClrScr;Assembler;
Asm
 Mov AX,03H
 Int 10H
End;

Procedure KeyOFF;Assembler;
Asm
 In AL,21H
 Or AL,00000010B
 Out 21H,AL
End;

Procedure KeyON;Assembler;
Asm
 In AL,21H
 And AL,11111101B
 Out 21H,AL
End;

Function KeyPressed:Boolean;Assembler;
Asm
 Mov AH,01H
 Int 16H
 JZ @False
  Mov AL,True
  Ret
 @False:
  Xor AL,AL
End;

Function ReadKey:Char;Assembler;
Asm
 Mov ExtraKey,False
 @Ciclo:
  Mov AH,01H
  Int 16H
 JZ @Ciclo
 Mov AH,00H
 Int 16H
 CMP AL,00H
 Jne @NoSwap
  Mov ExtraKey,True
  Mov AL,AH
 @NoSwap:
End;

Function MicroSecond(H,M,S,C:Word):LongInt;
Begin
 MicroSecond:=C+(S*100)+(M*6000)+(H*360000);
End;

Procedure Delay(Ms:Word);
Var H,M,S,C:Word;
    Time1,Time2:LongInt;
Begin
 GetTime(H,M,S,C);
 Time1:=MicroSecond(H,M,S,C);
 GetTime(H,M,S,C);
 Time2:=MicroSecond(H,M,S,C);
 While Time2-Time1<Ms Do
  Begin
   GetTime(H,M,S,C);
   Time2:=MicroSecond(H,M,S,C);
  End;
End;







Function Min(N1,N2:Real):Real;
Begin
 If N1<N2 Then Min:=N1 Else Min:=N2;
End;

Function Max(N1,N2:Real):Real;
Begin
 If N1>N2 Then Max:=N1 Else Max:=N2;
End;


Function Grad(Rd:Real):Real;
Begin
 Grad:=(180 * Rd)/3.141592654;
End;

Function Rad(Gr:Real):Real;
Begin
 Rad:=(3.141592654 * Gr)/180;
End;


Function Pot(N,Exp:Word):Word;
Var C:Word;
Begin
 If Exp=0 Then Pot:=1 Else
  Begin
   C:=N;
   While Exp>1 Do
    Begin
     C:=C*N;
     Exp:=Exp-1;
    End;
   Pot:=C;
  End;
End;


Function Seno(Gradi:Real):Real;
Var
 Alfa,S,AlfaQuadro,Fat:Real;
 Segno:ShortInt;
 Exp:Byte;
Begin
 Alfa:=Rad(Gradi);
 AlfaQuadro:=Alfa*Alfa;
 Segno:=1;
 Exp:=1;
 Fat:=1;
 S:=Alfa;
 While Exp<21 Do
  Begin
   Alfa:=Alfa*AlfaQuadro;
   Fat:=Fat*(Exp+1)*(Exp+2);
   Exp:=Exp+2;
   Segno:=-Segno;
   S:=S+(Segno*(Alfa/Fat));
  End;
 Seno:=S;
End;

Function CoSeno(Gradi:Real):Real;
Var
 Alfa,S,AlfaQuadro,Fat:Real;
 Segno:ShortInt;
 Exp:Byte;
Begin
 Alfa:=Rad(Gradi);
 AlfaQuadro:=Alfa*Alfa;
 Exp:=2;
 Fat:=2;
 Alfa:=AlfaQuadro;
 Segno:=-1;
 S:=1-(Alfa/2);
 While Exp<22 Do
  Begin
   Alfa:=Alfa*AlfaQuadro;
   Fat:=Fat*(Exp+1)*(Exp+2);
   Exp:=Exp+2;
   Segno:=-Segno;
   S:=S+(Segno*(Alfa/Fat));
  End;
 CoSeno:=S;
End;


Procedure CreateSinCosTable;
Var I:Integer;
Begin
 For I:=0 To 360 Do
  Begin
   SinTbl[I]:=Sin(Rad(I));
   CosTbl[I]:=Cos(Rad(I));
  End;
End;



Function Tangente(Grad:Real):Real;
Begin
 Tangente:=Seno(Grad)/CoSeno(Grad);
End;


Function RStr(N:Byte):String;
Begin
 If (N>=0)And(N<=9) Then RStr:=Chr(48+N) Else RStr:=Chr(55+N);
End;

Function RNum(N:Char):Word;
Begin
 If (N>=#48)And(N<#58) Then RNum:=Ord(N)-48 Else RNum:=Ord(N)-55;
End;

Function  BinStr(Num:word):string;
Var
sapp,sapp2:string;
nv,nv2:word;
begin
sapp:='';
sapp2:='';
nv:=num;
while nv>=2 do
begin
nv2:=nv mod 2;
nv:=nv div 2;
sapp2:=rstr(nv2);
sapp:=sapp2+sapp;
end;
sapp2:=rstr(nv);
sapp:=sapp2+sapp;
binstr:=sapp;
end;

Function  DecStr(Num:Word):String;
Var
 Sapp,Sapp2:string;
 Nv,Nv2:word;
Begin
 Sapp:='';
 Sapp2:='';
 Nv:=Num;
 While Nv>=10 Do
  Begin
   Nv2:=Nv Mod 10;
   Nv:=Nv Div 10;
   Sapp2:=Rstr(Nv2);
   Sapp:=Sapp2+Sapp;
  End;
 Sapp2:=Rstr(Nv);
 Sapp:=Sapp2+Sapp;
 DecStr:=Sapp;
End;


Function  IntStr(num:Integer):string;
var
sapp,sapp2,Sign:string;
nv,nv2:word;
begin
if num<0 Then
 begin
  sign:='-';
  num:=-num;
 end else sign:='+';
sapp:='';
sapp2:='';
nv:=num;
while nv>=10 do
begin
nv2:=nv mod 10;
nv:=nv div 10;
sapp2:=rstr(nv2);
sapp:=sapp2+sapp;
end;
sapp2:=rstr(nv);
sapp:=sapp2+sapp;
Intstr:=sign+sapp;
end;


Function HexStr(num:word):string;
  Var app:string;
 Begin
  app:='';
  while num>=16 do
   begin
    num:=num shr 4;
    app:=rstr(num mod 16)+app;
   end;
  HexStr:=rstr(num mod 16)+app;;
 End;


Function  StrBin(numer:string):word;
var
i,x,y:word;
val,app:word;
begin
app:=0;
x:=Length(numer);
I:=0;
for y:=x Downto 1 do
begin
app:=app+(rnum(numer[y])*pot(2,i));
I:=I+1;
end;
strbin:=app;
end;


Function  StrDec(numer:string):word;
var
i,x,y:word;
val,app:word;
begin
app:=0;
x:=Length(numer);
I:=0;
for y:=x Downto 1 do
begin
app:=app+(rnum(numer[y])*pot(10,i));
I:=I+1;
end;
strdec:=app;
end;

Function  StrHex(numer:string):word;
var
i,x,y:word;
val,app:word;
begin
app:=0;
x:=Length(numer);
I:=0;
for y:=x Downto 1 do
begin
app:=app+(rnum(numer[y])*pot(16,i));
I:=I+1;
end;
strhex:=app;
end;


Function Maiusc(Ch:Char):Char;
Begin
 If (Ch>=#97)And(Ch<=#122) Then Maiusc:=Chr(Ord(Ch)-32) Else Maiusc:=Ch;
End;

Function StrMaiusc(S:String):String;
Var I:Word;
Begin
 For I:=1 To LengTh(S) Do
  Begin
   S[I]:=Maiusc(S[I]);
  End;
 Strmaiusc:=S;
End;

Procedure TrasfBit;
var
i:word;
begin
for i:=1 to 4096 do bit[i]:=bit2[i];
end;

Procedure Bitc8(X:byte);
begin
bit[8]:=x mod 2;
x:=x div 2;
bit[7]:=x mod 2;
x:=x div 2;
bit[6]:=x mod 2;
x:=x div 2;
bit[5]:=x mod 2;
x:=x div 2;
bit[4]:=x mod 2;
x:=x div 2;
bit[3]:=x mod 2;
x:=x div 2;
bit[2]:=x mod 2;
x:=x div 2;
bit[1]:=x mod 2;
end;

Procedure Bitc8p(x:byte;p:word);
begin
bit[p+8]:=x mod 2;
x:=x div 2;
bit[p+7]:=x mod 2;
x:=x div 2;
bit[p+6]:=x mod 2;
x:=x div 2;
bit[p+5]:=x mod 2;
x:=x div 2;
bit[p+4]:=x mod 2;
x:=x div 2;
bit[p+3]:=x mod 2;
x:=x div 2;
bit[p+2]:=x mod 2;
x:=x div 2;
bit[p+1]:=x mod 2;
end;

Procedure Bitc16(x:word);
begin
bit[16]:=x mod 2;
x:=x div 2;
bit[15]:=x mod 2;
x:=x div 2;
bit[14]:=x mod 2;
x:=x div 2;
bit[13]:=x mod 2;
x:=x div 2;
bit[12]:=x mod 2;
x:=x div 2;
bit[11]:=x mod 2;
x:=x div 2;
bit[10]:=x mod 2;
x:=x div 2;
bit[9]:=x mod 2;
x:=x div 2;
bit[8]:=x mod 2;
x:=x div 2;
bit[7]:=x mod 2;
x:=x div 2;
bit[6]:=x mod 2;
x:=x div 2;
bit[5]:=x mod 2;
x:=x div 2;
bit[4]:=x mod 2;
x:=x div 2;
bit[3]:=x mod 2;
x:=x div 2;
bit[2]:=x mod 2;
x:=x div 2;
bit[1]:=x mod 2;
end;

Procedure BitcN(p:buffer;i,x:word);
var
ic,i2:word;
begin
i2:=0;
for ic:=1 to x do
begin
bitc8p(p^[i],i2);
i:=i+1;
i2:=i2+8;
end;
end;

Procedure Bits8(var x:byte);
begin
x:=bit[1]*128+bit[2]*64+bit[3]*32+bit[4]*16+bit[5]*8+bit[6]*4+bit[7]*2+bit[8];
end;

Procedure Bits16(var x:word);
begin
x:=bit[1]*128+bit[2]*64+bit[3]*32+bit[4]*16+bit[5]*8+bit[6]*4+bit[7]*2+bit[8];
end;

Procedure Bits8p(var x:byte;p:word);
begin
x:=bit[p+1]*128+bit[p+2]*64+bit[p+3]*32+bit[p+4]*16+bit[p+5]*8+bit[p+6]*4+bit[p+7]*2+bit[p+8];
end;

Procedure BitsN(var p:buffer;i,x:word);
var
ic,i2:word;
begin
i2:=0;
for ic:=1 to x do
begin
bits8p(p^[i],i2);
i:=i+1;
i2:=i2+8;
end;
end;


Function GetStr(Xi,Yi:Integer):String;
Var
 Ln:Array[1..256] Of Char;
 Str:String;
 I,Pse:Word;
 Key:Char;

 i2:word;

Begin
 I:=0;
 Pse:=0;
 Str:='';
 Repeat
  Key:=#0;
  If keyPressed Then Key:=ReadKey;
  If Key=#8 Then
   Begin
    If I>0 Then
     Begin
      SetStringColor(SfnCol);
      PutStr(Xi+((I+1)*StrSpc),Yi,'_');
      PutStr(Xi+(I*StrSpc),Yi,Ln[I]);
      SetStringColor(SysCol);
      I:=I-1;
     End;
   End;
  If Key>=#32 Then
   Begin
    If I<256 Then
     Begin
      SetStringColor(SfnCol);
      PutStr(Xi+((I+1)*StrSpc),Yi,'_');
      SetStringColor(SysCol);
      I:=I+1;
      Ln[I]:=Key;
      PutStr(Xi+(I*StrSpc),Yi,Key);
     End;
   End;
  If Pse=2000 Then Pse:=0;
  Pse:=Pse+1;
  If Pse>1000 Then PutStr(Xi+((I+1)*StrSpc),Yi,'_') Else
   Begin
    SetStringColor(SfnCol);
    PutStr(Xi+((I+1)*StrSpc),Yi,'_');
    SetStringColor(SysCol);
   End;
 Until Key=#13;
 For I2:=1 To I Do Str:=Str+Ln[I2];
 GetStr:=Str;
End;

Function Dval(val1,val2:real):real;
begin
if val1>val2 then Dval:=val1-val2 else Dval:=val2-val1;
end;

Function Dist(x1,y1,x2,y2:Integer):Real;
Begin
 Dist:=sqrt(abs(sqr(x1-x2)+sqr(y1-y2)));
End;



Procedure VerificaTasti;
Var Ch:Char;
    Ch2:Byte;
Begin
 Key:=#1;
 PressKey:='Nessuno';
 If KeyPressed Then
  Begin
   ch:=readkey;
   if (ord(ch)>32) then
begin
ch2:=port[$60];
if ch2=71 then PressKey:='LeftUp' else
if ch2=72 then PressKey:='Up' else
if ch2=73 then PressKey:='RightUp' else
if ch2=75 then PressKey:='Left' else
if ch2=77 then PressKey:='Right' else
if ch2=79 then PressKey:='LeftDown' else
if ch2=80 then PressKey:='Down' else
if ch2=81 then PressKey:='RightDown' else
if ch2=82 then PressKey:='Insert' else
if ch2=83 then PressKey:='Cancel' else
if ch2=59 then PressKey:='F1' else
if ch2=60 then PressKey:='F2' else
if ch2=61 then PressKey:='F3' else
if ch2=62 then PressKey:='F4' else
if ch2=63 then PressKey:='F5' else
if ch2=64 then PressKey:='F6' else
if ch2=65 then PressKey:='F7' else
if ch2=66 then PressKey:='F8' else
if ch2=67 then PressKey:='F9' else
if ch2=68 then PressKey:='F10' else
 Begin
  Key:=#0;
  PressKey:=ch;
 End;
End Else
Begin
 Ch2:=Ord(Ch);
 if ch2=0  then PressKey:='Null'   else
 if ch2=1  then PressKey:='Soh'    else
 if ch2=2  then PressKey:='Stx'    else
 if ch2=3  then PressKey:='Etx'    else
 if ch2=4  then PressKey:='Eot'    else
 if ch2=5  then PressKey:='Enq'    else
 if ch2=6  then PressKey:='Ack'    else
 if ch2=7  then PressKey:='Bel'    else
 if ch2=8  then PressKey:='Bs'     else
 if ch2=9  then PressKey:='Ht'     else
 if ch2=10 then PressKey:='Lf'     else
 if ch2=11 then PressKey:='Vt'     else
 if ch2=12 then PressKey:='FF'     else
 if ch2=13 then PressKey:='Return' else
 if ch2=14 then PressKey:='S0'     else
 if ch2=15 then PressKey:='S1'     else
 if ch2=16 then PressKey:='Dle'    else
 if ch2=17 then PressKey:='Dc1'    else
 if ch2=18 then PressKey:='Dc2'    else
 if ch2=19 then PressKey:='Dc3'    else
 if ch2=20 then PressKey:='Dc4'    else
 if ch2=21 then PressKey:='Nak'    else
 if ch2=22 then PressKey:='Syn'    else
 if ch2=23 then PressKey:='Etb'    else
 if ch2=24 then PressKey:='Can'    else
 if ch2=25 then PressKey:='Em'     else
 if ch2=26 then PressKey:='Sub'    else
 if ch2=27 then PressKey:='Esc'    else
 if ch2=28 then PressKey:='Fs'     else
 if ch2=29 then PressKey:='Gs'     else
 if ch2=30 then PressKey:='Rs'     Else
 if ch2=31 then PressKey:='Us'     Else
 If ch2=32 then PressKey:='Space';
End;
End;
End;

Procedure VerDrive;
 Var i,i2:byte;
     s,s2:string;
begin
{$I-}
i2:=0;
getdir(0,s2);
for i:=65 to 90 do
begin
if i=66 then i:=i+1;
s:=chr(i)+':\';
chdir(s);
if ioresult<>15 then
begin
writeln(chr(i),':');
i2:=i2+1;
sdrive[i2]:=i;
end;
end;
{$I+}
sdrive[0]:=i2;
chdir(s2);
end;



{ Insieme di funzioni per la gestione e l'utilizzo per la memoria XMS.      }
{---------------------------------------------------------------------------}
Procedure InitXMS;Assembler;
Asm
 Mov AX,4300h
 Int 2Fh
 Cmp AL,80h
 Je @NoError
 Ret
 @NoError:
  Mov AX,4310h
  Int 2Fh
  Mov Word Ptr [XMS_Point],BX
  Mov Word Ptr [XMS_Point+2],ES
  Mov XMS_Exist,True
End;

Function XMSGetVer:Word;Assembler;
Asm
 Xor AH,AH
 Call [XMS_Point]
 Mov [HMA_Exist],DL
End;

Procedure XMSInfoMem;Assembler;
Asm
 Mov AH,08h
 Call [XMS_Point]
 Cmp AX,0000h
 Je @Error
 Mov XMS_Free,DX
 Mov XMS_MaxBlk,AX
 Ret
 @Error:
  Mov XMS_Error,True
End;

Function GetXMS(Var XMS_Handle:Word;KByte:Word):Boolean;Assembler;
Asm
 Mov AH,09h
 Mov DX,[KByte]
 Call [XMS_Point]
 Cmp AX,0000h
 Je @Error
 Les DI,XMS_Handle
 Mov ES:Word Ptr [DI],DX
 Mov AL,True
 Leave
 Ret
 @Error:
  Mov ES:Word Ptr [DI],AX
  Mov XMS_Error,True
End;


Function FreeXMS(Var XMS_Handle:Word):Boolean;Assembler;
Asm
 Les DI,XMS_Handle
 Mov AH,0Ah
 Mov DX,ES:Word Ptr [DI]
 Call [XMS_Point]
 Cmp AX,0000h
 Je @Error
 Mov ES:Word PTR [DI],0000h
 Mov AL,True
 Leave
 Ret
@Error:
 Mov XMS_Error,True
END;


Function  SizeOfXMS(Var XMS_Handle:Word):Word;Assembler;
Asm
 Les DI,XMS_Handle
 Mov AH,0Fh
 Mov DX,Word Ptr [DI]
 Call [XMS_Point]
 Cmp AX,0000h
 Je @Error
 Mov AX,DX
 Leave
 Ret
@Error:
 Mov XMS_Error,True
End;

Procedure MoveXMS;Assembler;
Asm
 Lea SI,XMSData
 Mov AH,0Bh
 Call [XMS_Point]
END;

Procedure TransfertXMS(Lung:LongInt);Assembler;
Asm
 Mov AX,Word PTR [Lung]
 Mov Word Ptr [XMSData.Transfer],AX
 Mov AX,Word PTR [Lung+2]
 Mov Word Ptr [XMSData.Transfer+2],AX
End;

Procedure SetSourceOffs(Lung:LongInt);Assembler;
Asm
 Mov AX,Word PTR [Lung]
 Mov Word Ptr [XMSData.OffSource],AX
 Mov AX,Word PTR [Lung+2]
 Mov Word Ptr [XMSData.OffSource+2],AX
End;

Procedure SetDestOffs(Lung:LongInt);Assembler;
Asm
 Mov AX,Word PTR [Lung]
 Mov Word Ptr [XMSData.OffDest],AX
 Mov AX,Word PTR [Lung+2]
 Mov Word Ptr [XMSData.OffDest+2],AX
End;


Procedure ToXMS(Var Src;Var XMS_Handle:Word);Assembler;
Asm
 Mov XMSData.Source,0000h
 Mov AX,Word Ptr [Src]
 Mov Word Ptr [XMSData.OffSource],AX
 Mov AX,Word Ptr [Src+2]
 Mov Word Ptr [XMSData.OffSource+2],AX
 Les DI,XMS_Handle
 Mov AX,ES:Word Ptr [DI]
 Mov Word Ptr [XMSData.Dest],AX
End;


Procedure FromXMS(Var XMS_Handle:Word;Var Dst);Assembler;
Asm
 Mov XMSData.Dest,0000h
 Mov AX,Word Ptr [Dst]
 Mov Word Ptr [XMSData.OffDest],AX
 Mov AX,Word Ptr [Dst+2]
 Mov Word Ptr [XMSData.OffDest+2],AX
 Les DI,XMS_Handle
 Mov AX,ES:Word Ptr [DI]
 Mov Word Ptr [XMSData.Source],AX
End;
{---------------------------------------------------------------------------}
{Insieme di funzioni per la scrittura in modalit grafica.
{---------------------------------------------------------------------------}

Procedure FreeIMG(Var P:Buffer);
Begin
 FreeMem(P,SizeOf(P^));
 P:=Nil;
End;

Procedure CaricaFont(FileName:String);
Var
 F:File;
 DimBlock,Count:Byte;
 C:Word;
Begin
 Assign(F,FileName);
 Reset(F,1);
 Seek(F,20);
 For Count:=1 To 255 Do
  Begin
   BlockRead(F,DimBlock,1,C);
   GetMem(FontSet[Count],DimBlock);
   BlockRead(F,FontSet[Count]^,DimBlock,C);
  End;
 Close(F);
End;

Procedure ReleaseFont;
Var I:Byte;
Begin
 For I:=0 to 255 do
  Begin
   FreeIMG(FontSet[I]);
  End;
End;


Procedure SetStringSpace(Space:Integer);
Begin
 StrSpc:=Space;
End;

Procedure SetStringColor(Color:Integer);
Begin
 StrCol:=Color;
End;

Procedure SetStringMode(Mode:Integer);
Begin
 StrMde:=Mode;
End;

Procedure SetStringDXY(Dx,Dy:Integer);
Begin
 StrDx:=Dx;
 StrDy:=Dy;
End;

Procedure SetStringOmbre(Color:Integer);
Begin
 StrOmb:=Color;
End;

Procedure PutStrOmb(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
 C:Byte;
Begin
 L:=LengTh(St);
 C:=StrCol;
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I])+1;
   SetStringColor(StrOmb);
   PutChr((X-1)+((I-1)*StrSpc),(Y-1)-1,Val);
   PutChr((X-1)+((I-1)*StrSpc),(Y-1)+1,Val);
   PutChr((X-1)+((I-1)*StrSpc)-1,(Y-1),Val);
   PutChr((X-1)+((I-1)*StrSpc)+1,(Y-1),Val);
   SetStringColor(C);
   PutChr((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;


Procedure PutChr(X,Y,Let:Integer);
Var
 Ic,Lc,Xc,Yc,Dx,Dy,Xf,Yf,Xapp:Integer;
 I,Ap:Word;
Begin
 Dx:=(FontSet[Let]^[4]*256)+(FontSet[Let]^[3]);
 Dy:=(FontSet[Let]^[6]*256)+(FontSet[Let]^[5]);
 Ic:=7;
 Yf:=Dy+Y-1;
 Xf:=Dx+X;
 For Yc:=Y to Yf do
  Begin
   Lc:=0;
   Xc:=X;
   While Lc<Dx do
    Begin
     Ap:=FontSet[Let]^[Ic];
     Lc:=Lc+Ap;
     Xc:=Xc+Ap;
     Ic:=Ic+1;
     Ap:=FontSet[Let]^[Ic];
     Lc:=Lc+Ap;
     If Ap>0 Then
      Begin
       Xapp:=Xc+Ap;
       For I:=1 To Ap Do PutPixel(Xc+I,Yc,StrCol);
      End;
     Xc:=Xapp;
     Ic:=Ic+Ap+1;
    End;
  End;
End;

Procedure BufChr(X,Y,Let:Integer);
Var
 Ic,Lc,Xc,Yc,Dx,Dy,Xf,Yf,Xapp:Integer;
 I,Ap:Word;
Begin
 Dx:=(FontSet[Let]^[4]*256)+(FontSet[Let]^[3]);
 Dy:=(FontSet[Let]^[6]*256)+(FontSet[Let]^[5]);
 Ic:=7;
 Yf:=Dy+Y-1;
 Xf:=Dx+X;
 For Yc:=Y to Yf do
  Begin
   Lc:=0;
   Xc:=X;
   While Lc<Dx do
    Begin
     Ap:=FontSet[Let]^[Ic];
     Lc:=Lc+Ap;
     Xc:=Xc+Ap;
     Ic:=Ic+1;
     Ap:=FontSet[Let]^[Ic];
     Lc:=Lc+Ap;
     If Ap>0 Then
      Begin
       Xapp:=Xc+Ap;
       For I:=1 To Ap Do BufPixel(Xc+I,Yc,StrCol);
      End;
     Xc:=Xapp;
     Ic:=Ic+Ap+1;
    End;
  End;
End;

Procedure SfnChr(X,Y,Let:Integer);
Var
 Ic,Lc,Xc,Yc,Dx,Dy,Xf,Yf,Xapp:Integer;
 I,Ap:Word;
Begin
 Dx:=(FontSet[Let]^[4]*256)+(FontSet[Let]^[3]);
 Dy:=(FontSet[Let]^[6]*256)+(FontSet[Let]^[5]);
 Ic:=7;
 Yf:=Dy+Y-1;
 Xf:=Dx+X;
 For Yc:=Y to Yf do
  Begin
   Lc:=0;
   Xc:=X;
   While Lc<Dx do
    Begin
     Ap:=FontSet[Let]^[Ic];
     Lc:=Lc+Ap;
     Xc:=Xc+Ap;
     Ic:=Ic+1;
     Ap:=FontSet[Let]^[Ic];
     Lc:=Lc+Ap;
     If Ap>0 Then
      Begin
       Xapp:=Xc+Ap;
       For I:=1 To Ap Do SfnPixel(Xc+I,Yc,StrCol);
      End;
     Xc:=Xapp;
     Ic:=Ic+Ap+1;
    End;
  End;
End;

Procedure PutStr(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
Begin
 L:=LengTh(St);
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I])+1;
   PutChr((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;

Procedure BufStr(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
Begin
 L:=LengTh(St);
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I])+1;
   BufChr((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;


Procedure SfnStr(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
Begin
 L:=LengTh(St);
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I])+1;
   SfnChr((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;



Procedure ChrPutChar(X,Y:Integer;Ch:Byte);
Var
 XVec,YVec,Func,GX,GY:Integer;
 I:Word;
Begin
 If (Ch>=Font^.InitChar) And (Ch<=Font^.InitChar+Font^.NChar-1) Then
  Begin
   With Font^ Do
    Begin
     I:=VecStart+Buf[TBStart+(Ch-InitChar)*2]+Buf[TBStart+(Ch-InitChar)*2+1]*256;
     Repeat
      XVec:=ShortInt(Buf[I]);
      YVec:=ShortInt(Buf[I+1]);
      I:=I+2;
      Func:=(XVec And $80) Shr 6+(YVec And $80) Shr 7;
      XVec:=XVec And $7F;
      YVec:=YVec And $7F;
      If XVec>=$40 Then XVec:=-128+XVec;
      If YVec>=$40 Then YVec:=-128+YVec;
      XVec:=XVec*ChrMX;
      XVec:=XVec Div ChrDX;
      YVec:=YVec*ChrMY;
      YVec:=YVec Div ChrDY;
      Case Func Of
       2:Begin
          GX:=X+XVec;
          GY:=Y+Up-YVec;
         End;
       3:Begin
          Line(X+XVec,Y+Up-YVec,GX,GY,StrCol);
          GX:=X+XVec;
          GY:=Up+Y-YVec;
         End;
        End;
      Until Func=0;
    End;
  End;
End;

Procedure ChrBufChar(X,Y:Integer;Ch:Byte);
Var
 XVec,YVec,Func,GX,GY:Integer;
 I:Word;
Begin
 If (Ch>=Font^.InitChar) And (Ch<=Font^.InitChar+Font^.NChar-1) Then
  Begin
   With Font^ Do
    Begin
     I:=VecStart+Buf[TBStart+(Ch-InitChar)*2]+Buf[TBStart+(Ch-InitChar)*2+1]*256;
     Repeat
      XVec:=ShortInt(Buf[I]);
      YVec:=ShortInt(Buf[I+1]);
      I:=I+2;
      Func:=(XVec And $80) Shr 6+(YVec And $80) Shr 7;
      XVec:=XVec And $7F;
      YVec:=YVec And $7F;
      If XVec>=$40 Then XVec:=-128+XVec;
      If YVec>=$40 Then YVec:=-128+YVec;
      XVec:=XVec*ChrMX;
      XVec:=XVec Div ChrDX;
      YVec:=YVec*ChrMY;
      YVec:=YVec Div ChrDY;
      Case Func Of
       2:Begin
          GX:=X+XVec;
          GY:=Y+Up-YVec;
         End;
       3:Begin
          BufLine(X+XVec,Y+Up-YVec,GX,GY,StrCol);
          GX:=X+XVec;
          GY:=Up+Y-YVec;
         End;
        End;
      Until Func=0;
    End;
  End;
End;

Procedure ChrSfnChar(X,Y:Integer;Ch:Byte);
Var
 XVec,YVec,Func,GX,GY:Integer;
 I:Word;
Begin
 If (Ch>=Font^.InitChar) And (Ch<=Font^.InitChar+Font^.NChar-1) Then
  Begin
   With Font^ Do
    Begin
     I:=VecStart+Buf[TBStart+(Ch-InitChar)*2]+Buf[TBStart+(Ch-InitChar)*2+1]*256;
     Repeat
      XVec:=ShortInt(Buf[I]);
      YVec:=ShortInt(Buf[I+1]);
      I:=I+2;
      Func:=(XVec And $80) Shr 6+(YVec And $80) Shr 7;
      XVec:=XVec And $7F;
      YVec:=YVec And $7F;
      If XVec>=$40 Then XVec:=-128+XVec;
      If YVec>=$40 Then YVec:=-128+YVec;
      XVec:=XVec*ChrMX;
      XVec:=XVec Div ChrDX;
      YVec:=YVec*ChrMY;
      YVec:=YVec Div ChrDY;
      Case Func Of
       2:Begin
          GX:=X+XVec;
          GY:=Y+Up-YVec;
         End;
       3:Begin
          SfnLine(X+XVec,Y+Up-YVec,GX,GY,StrCol);
          GX:=X+XVec;
          GY:=Up+Y-YVec;
         End;
        End;
      Until Func=0;
    End;
  End;
End;


Procedure LoadCHRFont(Name:String);
Var X:Integer;
    F:File;
    R:Word;
BEGIN
 If Font<>Nil Then Dispose(Font);
 Assign(F,Name);
 Reset(F,1);
 New(Font);
 BlockRead(F,Font^.Buf,FileSize(F),R);
 X:=0;
 While (X<128) And (Font^.Buf[X]<>26) Do Asm Inc X End;
 Asm Inc X End;
 Font^.Data:=(Font^.Buf[X+1]*256)+Font^.Buf[X];
 Font^.NChar:=Font^.Buf[Font^.Data+1];
 Font^.InitChar:=Font^.Buf[Font^.Data+4];
 Font^.Up:=Font^.Buf[Font^.Data+8];
 Font^.Down:=ShortInt(Font^.Buf[Font^.Data+$0A]);
 Font^.TBStart:=Font^.Data+$10;
 Font^.WidthTbl:=Font^.TBStart+(Font^.NChar * 2);
 Font^.WPtr:=@Font^.Buf[Font^.Data+5];
 Font^.VecStart:=Font^.WPtr^+Font^.Data;
 Close(F);
End;

Procedure ChrDim(X,Y:Integer);
Begin
 If X=0 Then
  Begin
   ChrMX:=1;
   ChrDX:=1;
  End Else
 If X<0 Then
  Begin
   ChrMX:=1;
   ChrDX:=Abs(X);
  End Else
  Begin
   ChrMX:=X;
   ChrDX:=1;
  End;
 If Y=0 Then
  Begin
   ChrMY:=1;
   ChrDY:=1;
  End Else
 If Y<0 Then
  Begin
   ChrMY:=1;
   ChrDY:=Abs(Y);
  End Else
  Begin
   ChrMY:=Y;
   ChrDY:=1;
  End;
End;


Procedure ChrPutStr(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
Begin
 L:=LengTh(St);
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I]);
   ChrPutChar((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;
Procedure ChrBufStr(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
Begin
 L:=LengTh(St);
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I]);
   ChrBufChar((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;

Procedure ChrSfnStr(X,Y:Integer;St:String);
Var
 L,I,Val:Word;
Begin
 L:=LengTh(St);
 For I:=1 To L Do
  Begin
   Val:=Ord(St[I]);
   ChrSfnChar((X-1)+((I-1)*StrSpc),(Y-1),Val);
  End;
End;






{---------------------------------------------------------------------------}
{Insieme di funzioni per l'utilizzo dello standard VESA.
{---------------------------------------------------------------------------}

Procedure SetBlock(Blocco:Word);Assembler;
Asm
 Mov AX,4f05h
 Xor BX,BX
 Mov DX,Blocco
 Int 10h
End;


Procedure SetScanLine(X:Word);Assembler;
Asm
 Mov AX,4f06h
 Xor BL,BL
 Mov CX,X
 Int 10h
End;

Procedure SetLineStart(X:Word);Assembler;
Asm
 Mov AX,4f07h
 Xor BX,BX
 Xor CX,CX
 Mov DX,X
 Int 10h
End;


Procedure VisualPage(Page:Word);
Begin
If Page>0 Then Page:=Page-1;
Asm
 Mov AX,Page
 Mov BX,Ymax
 Mul Bx
 Mov DX,AX
 Mov AX,4f07h
 Xor BX,BX
 Xor CX,CX
 Int 10h
End;
End;


Procedure GetVesa;Assembler;
Asm
 Mov AX,DS
 Mov ES,AX
 Lea DI,VgaInfoBlock
 Mov AH,4fh
 Mov AL,00h
 Int 10h
 Cmp AH,04fh
 Je @VTrue
 @VTrue:
  Mov NoVesa,000h
  Jmp @Fine
 @VFalse:
  Mov NoVesa,0ffh
 @Fine:
End;



Procedure GetModeInfo(Mode:Word);Assembler;
Asm
 Mov AX,DS
 Mov ES,AX
 Lea DI,VgaModeInfo
 Mov AH,4fh
 Mov AL,01h
 Mov CX,Mode
 Int 10h
End;


Procedure SetVirtualDim;Assembler;
Asm
 Mov VirtualDim,True
End;
Procedure ReSetVirtualDim;Assembler;
Asm
 Mov VirtualDim,False
End;

Procedure SetVirtualY(Y:Integer);Assembler;
Asm
 Mov AX,Y
 Mov VirtualYMax,AX
End;
Procedure SetVirtualYStart(Y:Integer);Assembler;
Asm
 Mov AX,Y
 Mov VirtualYStart,AX
End;
Procedure SetVirtualYEnd(Y:Integer);Assembler;
Asm
 Mov AX,Y
 Mov VirtualYEnd,AX
End;
Procedure SetVirtualX(X:Integer);Assembler;
Asm
 Mov AX,X
 Mov VirtualXMax,AX
End;
Procedure SetVirtualXStart(X:Integer);Assembler;
Asm
 Mov AX,X
 Mov VirtualXStart,AX
End;
Procedure SetVirtualXEnd(X:Integer);Assembler;
Asm
 Mov AX,X
 Mov VirtualXEnd,AX
End;


Function SvgaMode(Mode:String):Word;
Begin
 Asm
  Lea DI,VdePTR
  Mov Word PTR [DI],0000h
  Mov AX,0A000h
  Mov Word PTR [DI+2],AX
 End;
 If Mode='Mode320x200x256' Then SvgaMode:=$13 Else
 If Mode='Mode320x200x32K' Then SvgaMode:=$10D Else
 If Mode='Mode320x200x65K' Then SvgaMode:=$10E Else
 If Mode='Mode320x200x16M' Then SvgaMode:=$10F Else

 If Mode='Mode640x400x256' Then SvgaMode:=$100 Else
 If Mode='Mode640x480x256' Then SvgaMode:=$101 Else
 If Mode='Mode640x480x32K' Then SvgaMode:=$110 Else
 If Mode='Mode640x480x65K' Then SvgaMode:=$111 Else
 If Mode='Mode640x480x16M' Then SvgaMode:=$112 Else

 If Mode='Mode800x600x256' Then SvgaMode:=$103 Else
 If Mode='Mode800x600x32K' Then SvgaMode:=$113 Else
 If Mode='Mode800x600x65K' Then SvgaMode:=$114 Else
 If Mode='Mode800x600x16M' Then SvgaMode:=$115 Else

 If Mode='Mode1024x768x256' Then SvgaMode:=$105 Else
 If Mode='Mode1024x768x32K' Then SvgaMode:=$116 Else
 If Mode='Mode1024x768x65K' Then SvgaMode:=$117 Else
 If Mode='Mode1024x768x16M' Then SvgaMode:=$118 Else

 If Mode='Mode1280x1024x256' Then SvgaMode:=$107 Else
 If Mode='Mode1280x1024x32K' Then SvgaMode:=$119 Else
 If Mode='Mode1280x1024x65K' Then SvgaMode:=$11A Else
 If Mode='Mode1280x1024x16M' Then SvgaMode:=$11B Else

 Errore('Si  cercato di inizializzare in una modalit inesistente.');

End;



Procedure Svga(Mode:String);
Var S:String;
    L,Lx,Ly:Word;
    M:Word;
    D:Word;

    X,Y,FatDiv:LongInt;
Begin
 M:=SvgaMode(Mode);
Asm
 Mov AH,4fh
 Mov AL,02h
 Mov BX,M
 Int 10h
End;

 L:=LengTh(Mode);
 If L=15 Then
  Begin
   Lx:=3;
   Ly:=3;
  End Else
 If L=16 Then
  Begin
   Lx:=4;
   Ly:=3;
  End Else
  Begin
   Lx:=4;
   Ly:=4;
  End;

 If Esiste('NormFont.CGT') Then CaricaFont('NormFont.CGT') Else
  Begin
   Asm
    Mov AX,03h
    Int 10h
   End;
   Errore('File "NormFont.CGT" non trovato.');
  End;
 SetStringColor(30);
 SetStringSpace(8);

 S:=Copy(Mode,5,Lx);
 If S='320' Then XMax:=320 Else
 If S='640' Then XMax:=640 Else
 If S='800' Then XMax:=800 Else
 If S='1024' Then XMax:=1024 Else
 If S='1280' Then XMax:=1280 Else XMax:=0;

 S:=Copy(Mode,9+(Lx-3),Ly);
 If S='200' Then YMax:=200 Else
 If S='400' Then YMax:=400 Else
 If S='480' Then YMax:=480 Else
 If S='600' Then YMax:=600 Else
 If S='768' Then YMax:=768 Else
 If S='1024' Then YMax:=1024 Else YMax:=0;

 ColorMax:=Copy(Mode,13+(Lx-3)+(Ly-3),3);

 D:=PageDimKB;

 For D:=0 To 255 Do ShadowColor[D]:=False;

 For D:=0 To 255 Do
  Begin
   Col16M[D].R:=D;
   Col16M[D].G:=D;
   Col16M[D].B:=D;
   RGB[D].R:=(D Div 4)+(D Mod 4);
   RGB[D].G:=(D Div 4);
   RGB[D].B:=(D Div 4);
  End;

 XStart:=0;
 YStart:=0;
 XEnd:=XMax-1;
 YEnd:=YMax-1;
 XPos:=XMax Div 2;
 YPos:=YMax Div 2;
 SysCol:=0;
 SfnCol:=0;

 GetModeInfo(M);
 BitsPerPixel:=VgaModeInfo.BitsPerPixel;

 If ColorMax='256' Then ColorMaxCode:=0 Else
 If ColorMax='32K' Then ColorMaxCode:=1 Else
 If ColorMax='65K' Then ColorMaxCode:=2 Else
 If ColorMax='16M' Then
  Begin
   If BitsPerPixel=24 Then ColorMaxCode:=3 Else ColorMaxCode:=4;
  End Else ColorMaxCode:=5;

 FatDiv:=BitsPerPixel Div 8;
 If BitsPerPixel Mod 8<>0 Then FatDiv:=FatDiv+1;
 If VirtualDim Then
  Begin
   X:=VirtualXMax;
   Y:=VirtualYMax;
  End Else
  Begin
   X:=XMax;
   Y:=YMax;
  End;
 VirtualPageSize:=X*Y;
 VirtualPageSize:=VirtualPageSize*FatDiv;
 FatDiv:=65536;
 VirtualPageSize:=VirtualPageSize Div FatDiv;
 If (VirtualPageSize Mod FatDiv)<>0 Then
     VirtualPageSize:=VirtualPageSize+1;
 PageForScreen:=VirtualPageSize;
 FatDiv:=64;
 VirtualPageSize:=VirtualPageSize * FatDiv;


 If ((XMax=320)And(YMax=200))And(ColorMax='256') Then
  Begin
   VirtualPageSize:=64;
   PageForScreen:=1;
  End;

 If Not GetXMS(VideoPage1,VirtualPageSize) Then
  Begin
   Errore('Error during allocation of virtual pages.');
  End;
 If Not GetXMS(VideoPage2,VirtualPageSize) Then
  Begin
   Asm
    Mov AX,03h
    Int 10h
   End;
   Errore('Error during allocation of virtual pages.');
  End;

 FatDiv:=1024;
 VirtualPageSize:=VirtualPageSize * FatDiv;

 GetMem(VideoBuffer,65535);

 SetDoubleBuffer;
 XCentre:=XMax Div 2;
 YCentre:=YMax Div 2;
 AspectRatio:=XMax / YMax;
End;


Procedure CloseSvga;
Begin
 Asm
  Mov AX,03h
  Int 10h
 End;
 FreeVideoMemory;
End;


Function PageDim:LongInt;
Var X,Y:LongInt;
Begin
 X:=XMax;
 Y:=YMax;
 PageDim:=X*Y;
End;


Function PageDimKB:Word;
Var PD,X,Y:LongInt;
    RByte:Word;
Begin
 X:=XMax;
 Y:=YMax;
 PD:=X*Y;
 RByte:=(PD Mod 1024);
 If RByte>0 Then RByte:=1;
 PageDImKB:=(PD Div 1024)+RByte;
End;

Procedure LoadVideoMemory(FileName:String);
Var F:File;
    I:Byte;
    W:Word;
Begin
 Assign(F,FileName);
 ReSet(F,1);
 For I:=0 To 31 Do
  Begin
   SetBlock(I);
   BlockRead(F,Mem[$A000:0000],65535,W);
  End;
 Close(F);
End;

Procedure StoreVideoMemory(FileName:String);
Var F:File;
    I:Byte;
    W:Word;
Begin
 Assign(F,FileName);
 ReWrite(F,1);
 For I:=0 To 31 Do
  Begin
   SetBlock(I);
   BlockWrite(F,Mem[$A000:0000],65535,W);
  End;
 Close(F);
End;


Procedure LoadVideoPage(FileName:String);
Var F:File;
    I:Byte;
    W:Word;
Begin
 Assign(F,FileName);
 ReSet(F,1);
 For I:=0 To PageForScreen-1 Do
  Begin
   SetBlock(I);
   BlockRead(F,Mem[$A000:0000],65535,W);
  End;
 Close(F);
End;

Procedure StoreVideoPage(FileName:String);
Var F:File;
    I:Byte;
    W:Word;
Begin
 Assign(F,FileName);
 ReWrite(F,1);
 For I:=0 To PageForScreen-1 Do
  Begin
   SetBlock(I);
   BlockWrite(F,Mem[$A000:0000],65535,W);
  End;
 Close(F);
End;

Procedure FastFill(Var X;Count:Word;Val:Byte);Assembler;
Asm
 Cld
 Mov AL,Val
 Mov AH,AL
 Mov CX,Count
 Shr CX,1
 JB @Dispari
  Rep StoSW
  Leave
  Ret
 @Dispari:
  Rep StoSW
  StoSB
End;

Procedure FastMove(Var xi;vdi,count:word);assembler;
Asm
 push ds
 mov ax,es
 mov ds,ax
 mov si,di
 mov ax,0a000h
 mov es,ax
 mov di,vdi
 mov ax,count
 xor dx,dx
 mov bx,2d
 div bx
 mov cx,ax
 cld
 rep movsw
 cmp dx,00d
 je @fine
 movsb
 @fine:
 pop ds
End;


Procedure FastClearVideoMem(Offs,Count:Word);Assembler;
Asm
 Mov AX,0A000h
 Mov ES,AX
 Mov DI,Offs
 Cld
 Xor AX,AX
 Mov CX,Count
 Shr CX,1
 JB @Dispari
  Rep StoSW
  Leave
  Ret
 @Dispari:
  Rep StoSW
  StoSB
End;

Procedure FastVideoFill(Offs,Count:Word;Col:Byte);Assembler;
Asm
 Mov AX,0A000h
 Mov ES,AX
 Mov DI,Offs
 Mov AL,Col
 Mov AH,AL
 Cld
 Mov CX,Count
 Shr CX,1
 JB @Dispari
  Rep StoSW
  Leave
  Ret
 @Dispari:
  Rep StoSW
  StoSB
End;

Procedure FastVideoMove(OffsDest,Count:Word;OffsSource:Word);Assembler;
Asm
 Mov SI,OffsSource
 Mov DI,OffsDest
 Mov AX,0A000h
 Mov ES,AX
 Cld
 Mov CX,Count
 Shr CX,1
 JB @Dispari
  Rep MovSW
  Leave
  Ret
 @Dispari:
  Rep MovSW
  StoSB
End;

Procedure FastFill32Bit(X:Pointer;Count:Word;Val:Byte);Assembler;
Asm
 Les DI,X
 Mov BL,Val
 Mov AL,BL
 Mov AH,BL
 DB $66;Shl AX,16
 Mov AL,BL
 Mov AH,BL
 Cld
 Mov CX,Count
 Shr CX,1
 JB @Dispari
  Shr CX,1
  JB @Dispari2
   DB $66;Rep StoSW
   Leave
   Ret
  @Dispari2:
   StoSW
   DB $66;Rep StoSW
   Leave
   Ret
 @Dispari:
  StoSB
  Shr CX,1
  JB @Dispari3
   DB $66;Rep StoSW
   Leave
   Ret
  @Dispari3:
   StoSW
   DB $66;Rep StoSW
End;

Procedure FastMove32Bit(XSource,XDestin:Pointer;Count:Word);Assembler;
Asm
 Push DS
 Lds SI,XSource
 Les DI,XDestin
 Cld
 Mov CX,Count
 Shr CX,1
 JB @Dispari
  Shr CX,1
  JB @Dispari2
   DB $66;Rep MovSW
   Pop DS
   Leave
   Ret
  @Dispari2:
   MovSW
   DB $66;Rep MovSW
   Pop DS
   Leave
   Ret
 @Dispari:
  MovSB
  Shr CX,1
  JB @Dispari3
   DB $66;Rep MovSW
   Pop DS
   Leave
   Ret
  @Dispari3:
   MovSW
   DB $66;Rep MovSW
 Pop DS
End;


Procedure ClScreen;
Var I:Integer;
Begin
 For I:=0 To PageForScreen-1 Do
  Begin
   SetBlock(I);
   FastFill32Bit(VdePTR,65535,SfnCol);
  End;
End;

Procedure ClMemory;
Var I:Integer;
Begin
 For I:=0 To VgaModeInfo.NumberOfBanks-1 Do
  Begin
   SetBlock(I);
   FastFill32Bit(VdePTR,65535,0);
  End;
End;

Procedure FreeVideoMemory;
Begin
 If Not FreeXMS(VideoPage1) Then
  Errore('Error deleting virtual pages.');
 If Not FreeXMS(VideoPage2) Then
  Errore('Error deleting virtual pages.');
End;

Procedure RefreshON;Assembler;
asm
mov ah,12h
mov al,0h
mov bl,36h
int 10h
end;


Procedure RefreshOFF;Assembler;
asm
mov ah,12h
mov al,1h
mov bl,36h
int 10h
end;

{---------------------------------------------------------------------------}
{Insieme di funzioni per il trattamento dei colori.
{---------------------------------------------------------------------------}

Procedure SetColorOn(Col:Byte);
Begin
 ShadowColor[Col]:=False;
End;

Procedure SetColorOff(Col:Byte);
Begin
 ShadowColor[Col]:=True;
End;

Procedure SetRGBPal(Col,R,G,B:Byte);Assembler;
Asm
 Mov DX,$3C8
 Mov AL,Col
 Out DX,AL
 Inc DX
 Mov AL,R
 Out Dx,AL
 Mov AL,G
 Out Dx,AL
 Mov AL,B
 Out Dx,AL
End;

Procedure GetRGBPal(Col:Byte;Var R,G,B:Byte);Assembler;
Asm
 Mov DX,$3C7
 Mov AL,Col
 Out DX,AL
 Inc DX
 Inc DX
 In AL,DX
 Les DI,R
 Mov ES:Byte PTR [DI],AL
 In AL,DX
 Les DI,G
 Mov ES:Byte PTR [DI],AL
 In AL,DX
 Les DI,B
 Mov ES:Byte PTR [DI],AL
End;

Procedure SetRGB(Col,R,G,B:Byte);
Begin
 SetRGBPal(Col,R,G,B);
 RGB[Col].R:=R;
 RGB[Col].G:=G;
 RGB[Col].B:=B;
 If (BitsPerPixel=15) And (ColorMax='32K') Then
  Begin
   R:=R Shl 3;
   R:=R Shr 3;
   G:=G Shl 3;
   G:=G Shr 3;
   B:=B Shl 3;
   B:=B Shr 3;
   ColRGB[Col]:=0;
   ColRGB[Col]:=ColRGB[Col] Or (R Shl 10);
   ColRGB[Col]:=ColRGB[Col] Or (G Shl 5);
   ColRGB[Col]:=ColRGB[Col] Or (B);
  End Else
 If (BitsPerPixel=16) And (ColorMax='65K') Then
  Begin
   R:=R Shl 3;
   R:=R Shr 3;
   G:=G Shl 2;
   G:=G Shr 2;
   B:=B Shl 3;
   B:=B Shr 3;
   ColRGB[Col]:=0;
   ColRGB[Col]:=ColRGB[Col] Or (R Shl 11);
   ColRGB[Col]:=ColRGB[Col] Or (G Shl 5);
   ColRGB[Col]:=ColRGB[Col] Or (B);
  End;
 Col16M[Col].R:=B Shl 2;
 Col16M[Col].G:=G Shl 2;
 Col16M[Col].B:=R Shl 2;
End;

Procedure GetRGB(Col:Byte;Var R,G,B:Byte);
Var Rv,Gv,Bv:Byte;
Begin
 GetRGBPal(Col,Rv,Gv,Bv);
 RGB[Col].R:=Rv;
 RGB[Col].G:=Gv;
 RGB[Col].B:=Bv;
 If (BitsPerPixel=15) And (ColorMax='32K') Then
  Begin
   Rv:=Rv Shl 3;
   Rv:=Rv Shr 3;
   Gv:=Gv Shl 3;
   Gv:=Gv Shr 3;
   Bv:=Bv Shl 3;
   Bv:=Bv Shr 3;
   ColRGB[Col]:=0;
   ColRGB[Col]:=ColRGB[Col] Or (Rv Shl 10);
   ColRGB[Col]:=ColRGB[Col] Or (Gv Shl 5);
   ColRGB[Col]:=ColRGB[Col] Or (Bv);
  End;
 If (BitsPerPixel=16) And (ColorMax='65K') Then
  Begin
   R:=R Shl 3;
   R:=R Shr 3;
   G:=G Shl 2;
   G:=G Shr 2;
   B:=B Shl 3;
   B:=B Shr 3;
   ColRGB[Col]:=0;
   ColRGB[Col]:=ColRGB[Col] Or (R Shl 11);
   ColRGB[Col]:=ColRGB[Col] Or (G Shl 5);
   ColRGB[Col]:=ColRGB[Col] Or (B);
  End;
 Col16M[Col].R:=Bv Shl 2;
 Col16M[Col].G:=Gv Shl 2;
 Col16M[Col].B:=Rv Shl 2;
 R:=Rv;
 G:=Gv;
 B:=Bv;
End;


Procedure SetPaletteModeOn;Assembler;
Asm
 Mov PaletteMode,True
End;
Procedure SetPaletteModeOff;Assembler;
Asm
 Mov PaletteMode,False
End;

Procedure LoadPal(Name:String);
Var
 I:Byte;
 F:File;
 RGB:Array[0..767] Of Byte;
 W:Word;
Begin
 Assign(F,Name);
 ReSet(F,1);
 BlockRead(F,RGB,768,W);
 For I:=0 to 255 do SetRGB(I,RGB[(I*3)],RGB[(I*3)+1],RGB[(I*3)+2]);
 Close(f);
End;

Procedure SavePal(Name:String);
Var
 I:Byte;
 F:File;
 RGB:Array[0..767] Of Byte;
 W:Word;
Begin
 Assign(F,Name);
 ReWrite(F,1);
 For I:=0 to 255 do GetRGB(I,RGB[(I*3)],RGB[(I*3)+1],RGB[(I*3)+2]);
 BlockWrite(F,RGB,768,W);
 Close(f);
End;


Procedure Sostcol(xi,yi,xf,yf:word;col1,col2:byte);
{Procedure per la sostituzione di un colore in un area con un altro}
var
x,y:integer;
w:byte;
begin
for y:=yi to yf do
begin
for x:=xi to xf do
begin
w:=sfngetpixel256(x,y);
if w=col1 then putpixel(x,y,col2);
end;
end;
end;


Procedure Scambiacol(xi,yi,xf,yf:word;col1,col2:byte);
{Procedure per lo scambio di due colori in un area selezionata}
var
x,y:integer;
w:byte;
begin
for y:=yi to yf do
begin
for x:=xi to xf do
begin
w:=bufgetpixel256(x,y);
if w=col1 then putpixel(x,y,col2)
else if w=col2 then putpixel(x,y,col1);
end;
end;
end;


Procedure Addcol(r,g,b:word);
var
x:word;
begin
for x:=0 to 255 do
begin
 RGB[x].R:=RGB[x].R+r;
 RGB[x].G:=RGB[x].G+g;
 RGB[x].B:=RGB[x].B+b;
 if RGB[x].R>63 then RGB[x].R:=63;
 if RGB[x].G>63 then RGB[x].G:=63;
 if RGB[x].B>63 then RGB[x].B:=63;
 setrgb(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
end;



Procedure Dimcol(r,g,b:word);
var
x:word;
begin
for x:=0 to 255 do
begin
RGB[x].R:=RGB[x].R-r;
RGB[x].G:=RGB[x].G-g;
RGB[x].B:=RGB[x].B-b;
if RGB[x].R>70 then RGB[x].R:=0;
if RGB[x].G>70 then RGB[x].G:=0;
if RGB[x].B>70 then RGB[x].B:=0;
setrgb(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
end;

Procedure Schiarisci(qx:word);
Begin
 AddCol(qx,qx,qx);
End;

Procedure Oscura(qx:word);
Begin
 DimCol(qx,qx,qx);
End;

Procedure Satura(qx:word);
var
i,qq:word;

begin
for i:=0 to 255 do
begin
qq:=qx;
while qq>0 do
begin

if (RGB[i].R<63)and(RGB[i].B>1) then
begin
RGB[i].R:=RGB[i].R+1;
RGB[i].B:=RGB[i].B-1;
qq:=qq-1;
end
else
if (RGB[i].R<63)and(RGB[i].G>1) then
begin
RGB[i].R:=RGB[i].R+1;
RGB[i].G:=RGB[i].G-1;
qq:=qq-1;
end
else
if (RGB[i].G<63)and(RGB[i].B>1) then
begin
RGB[i].G:=RGB[i].G+1;
RGB[i].B:=RGB[i].B-1;
qq:=qq-1;
end
else qq:=qq-1;

end;
SetRGB(i,RGB[i].R,RGB[i].G,RGB[i].B);
end;
end;


Procedure Desatura(qx:word);
var
i,qq:word;
begin
for i:=0 to 255 do
begin
qq:=qx;
while qq>0 do
begin
if (RGB[i].R>RGB[i].G)and(RGB[i].R>RGB[i].B) then
begin
RGB[i].R:=RGB[i].R-1;
RGB[i].G:=RGB[i].G+1;
RGB[i].B:=RGB[i].B+1;
qq:=qq-1;
end
else
if (RGB[i].G>RGB[i].R)and(RGB[i].G>RGB[i].B) then
begin
RGB[i].R:=RGB[i].R+1;
RGB[i].G:=RGB[i].G-1;
RGB[i].B:=RGB[i].B+1;
qq:=qq-1;
end
else
if (RGB[i].B>RGB[i].G)and(RGB[i].B>RGB[i].R) then
begin
RGB[i].R:=RGB[i].R+1;
RGB[i].G:=RGB[i].G+1;
RGB[i].B:=RGB[i].B-1;
qq:=qq-1;
end
else
begin
qq:=RGB[i].R+RGB[i].G+RGB[i].B;
RGB[i].R:=qq div 3;
RGB[i].G:=qq div 3;
RGB[i].B:=qq div 3;
qq:=0;
end;
end;

SetRGB(i,RGB[i].R,RGB[i].G,RGB[i].B);
end;
end;

procedure Aggiungirosso(qx:word);
begin
addcol(qx,0,0);
end;


procedure aggiungiverde(qx:word);
begin
addcol(0,qx,0);
end;

procedure aggiungiblu(qx:word);
begin
addcol(0,0,qx);
end;

procedure aggiungiviola(qx:word);
begin
addcol(qx,0,qx);
end;

procedure aggiungigiallo(qx:word);
begin
addcol(qx,qx,0);
end;

procedure aggiungiazzurro(qx:word);
begin
addcol(0,qx,qx);
end;

procedure diminuiscirosso(qx:word);
begin
addcol(qx,0,0);
end;

procedure diminuisciverde(qx:word);
begin
addcol(0,qx,0);
end;

procedure diminuisciblu(qx:word);
begin
addcol(0,0,qx);
end;

procedure diminuisciviola(qx:word);
begin
addcol(qx,0,qx);
end;

procedure diminuiscigiallo(qx:word);
begin
addcol(qx,qx,0);
end;

procedure diminuisciazzurro(qx:word);
begin
addcol(0,qx,qx);
end;




procedure RendiGrigia;
var
x,Qrgb,Qrgb2:word;
begin
for x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
Qrgb2:=Qrgb div 3;
RGB[x].R:=Qrgb2;
RGB[x].G:=Qrgb2;
RGB[x].B:=Qrgb2;
setrgb(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
end;


procedure Rendirossa;
var
x,Qrgb,Qrgb2:word;
begin
for x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
if Qrgb<64 then
begin
RGB[x].R:=Qrgb;
RGB[x].G:=0;
RGB[x].B:=0;
end else
begin
RGB[x].R:=63;
Qrgb2:=(Qrgb-63) div 2;
RGB[x].G:=Qrgb2;
RGB[x].B:=Qrgb2;
end;
setrgb(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
end;

procedure Rendiverde;
var
x,Qrgb,Qrgb2:word;
begin
for x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
if Qrgb<64 then
begin
RGB[x].R:=0;
RGB[x].G:=Qrgb;
RGB[x].B:=0;
end else
begin
RGB[x].G:=63;
RGB[x].R:=Qrgb2;
Qrgb2:=(Qrgb-63) div 2;
RGB[x].B:=Qrgb2;
end;
setrgb(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
end;


procedure Rendiblu;
var
x,Qrgb,Qrgb2:word;
begin
for x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
if Qrgb<64 then
begin
RGB[x].B:=Qrgb;
RGB[x].G:=0;
RGB[x].R:=0;
end else
begin
Qrgb2:=(Qrgb-63) div 2;
RGB[x].B:=63;
RGB[x].G:=Qrgb2;
RGB[x].R:=Qrgb2;
end;
SetRGB(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
end;


Procedure RendiGialla;
Var
x,Qrgb,Qrgb2:word;
Begin
For x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
if Qrgb<128 then
begin
Qrgb2:=Qrgb div 2;
RGB[x].r:=Qrgb2;
RGB[x].g:=Qrgb2;
RGB[x].b:=0;
end
else
begin
Qrgb2:=Qrgb-128;
RGB[x].r:=63;
RGB[x].g:=63;
RGB[x].b:=Qrgb;
end;
SetRGB(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
End;

Procedure RendiAzzurra;
Var
x,Qrgb,Qrgb2:word;
begin
for x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
if Qrgb<128 then
begin
Qrgb2:=Qrgb div 2;
RGB[x].B:=Qrgb2;
RGB[x].G:=Qrgb2;
RGB[x].R:=0;
end else
begin
Qrgb2:=Qrgb-128;
RGB[x].B:=63;
RGB[x].G:=63;
RGB[x].R:=Qrgb;
end;
SetRGB(x,RGB[x].R,RGB[x].G,RGB[x].B);
end;
End;


Procedure RendiViola;
Var
x,Qrgb,Qrgb2:word;
Begin
for x:=0 to 255 do
begin
Qrgb:=RGB[x].R+RGB[x].G+RGB[x].B;
if Qrgb<128 then
begin
Qrgb2:=Qrgb div 2;
RGB[x].R:=Qrgb2;
RGB[x].B:=Qrgb2;
RGB[x].G:=0;
end else
begin
Qrgb2:=Qrgb-128;
RGB[x].R:=63;
RGB[x].B:=63;
RGB[x].G:=Qrgb;
end;
SetRGB(x,RGB[x].R,RGB[x].G,RGB[x].B);
End;
End;







Procedure PutVideoLine(Y:Integer);
Begin
 If Y>=0 Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     CLD
     Mov AX,0A000h
     Mov ES,AX
     Lea SI,VideoLine

     Mov CX,XMax
     Mov AX,Y
     Mul CX

     Mov DI,AX

     Mov AX,4f05h
     Xor BX,BX
     Int 10h

     XOR AX,AX
     Sub AX,DI
     CMP AX,0
     JE @Then2
     CMP AX,CX
     JB @Else2

     @Then2:
      Shr CX,1
      JB @Dispari
       Shr CX,1
      JB @Dispari2
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari2:
       MovSW
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari:
       MovSB
       Shr CX,1
      JB @Dispari3
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari3:
       MovSW
       DB $66;Rep MovSW
       JMP @EndIf5

      @Else2:
       Xor CX,CX
       Sub CX,DI
       Push DI
       Shr CX,1
       JB @Disparie
        Shr CX,1
       JB @Dispari2e
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Dispari2e:
        MovSW
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Disparie:
        MovSB
        Shr CX,1
       JB @Dispari3e
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Dispari3e:
        MovSW
        DB $66;Rep MovSW
       @EndIf3e:
       Inc DL
       Mov AX,4f05h
       Xor BX,BX

       Int 10h
       Pop CX
       Add CX,XMax
       Xor DI,DI
       Shr CX,1
       JB @Disparis
        Shr CX,1
       JB @Dispari2s
        DB $66;Rep MovSW
        JMP @EndIf5
       @Dispari2s:
        MovSW
        DB $66;Rep MovSW
        JMP @EndIf5
       @Disparis:
        MovSB
        Shr CX,1
       JB @Dispari3s
        DB $66;Rep MovSW
        JMP @EndIf5
       @Dispari3s:
        MovSW
        DB $66;Rep MovSW
      @EndIf5:
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     CLD
     Mov AX,DS
     Mov ES,AX
     Lea DI,Video16Ln
     Lea BX,Videoline
     Lea AX,Col16M
     Mov CX,XEnd;
     @Ciclo:
      Mov SI,AX
      Xor DH,DH
      Mov DL,Byte PTR [BX]
      Inc BX
      Shl DX,2
      Add SI,DX
      DB $66;MovSW
     Loop @Ciclo

     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov CX,XMax
     Shl CX,2

     Mov DI,AX
     Lea SI,Video16Ln
     Mov AX,0A000h
     Mov ES,AX

     Mov AX,4f05h
     Xor BX,BX
     Int 10h

     Mov BX,XMax
     Shl BX,2

     Xor CX,CX
     Sub CX,DI
     Push CX

     CMP CX,0
     JE @Then
     CMP CX,BX
     JB @Else1

     @Then:
       Mov CX,BX
       Shr CX,2
       DB $66;Rep MovSW
       JMP @Fine

     @Else1:
       Shr CX,2
       DB $66;Rep MovSW
       JMP @End1
        @End1:

       Inc DL
       Mov AX,4f05h
       Xor BX,BX
       Int 10h


       Xor DI,DI
       Mov CX,XMax
       Shl CX,2
       Pop BX
       Sub CX,BX

       Shr CX,2
       DB $66;Rep MovSW
      @Fine:

    End;
  End;
End;



Procedure PutVideoLineX(X,Y,Nx:Integer);
Begin
 If (Y>=0)And(X<XMax) Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     CLD
     Mov AX,0A000h
     Mov ES,AX
     Lea SI,VideoLine

     Mov BX,X
     Mov CX,BX
     Mov DX,XMax

     Xor AX,AX
     CMP BX,0
     JGE @EndIf1
      Sub AX,BX
      Add SI,AX
      Add NX,BX
      Xor CX,CX
      Xor BX,BX
     @EndIf1:

     Add BX,NX
     CMP BX,DX
     JNGE @EndIf2
      Mov BX,DX
      Sub BX,CX
      Mov NX,BX
     @EndIf2:

     Mov AX,Y
     Mul DX
     Add AX,CX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov DI,AX

     Mov AX,4f05h
     Xor BX,BX
     Int 10h

     XOR AX,AX
     Sub AX,DI
     CMP AX,0
     JE @Then2
     CMP AX,NX
     JB @Else2

     @Then2:
      Mov CX,NX
      Shr CX,1
      JB @Dispari
       Shr CX,1
      JB @Dispari2
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari2:
       MovSW
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari:
       MovSB
       Shr CX,1
      JB @Dispari3
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari3:
       MovSW
       DB $66;Rep MovSW
       JMP @EndIf5


      @Else2:
       Xor CX,CX
       Sub CX,DI
       Push DI

       Shr CX,1
       JB @Disparie
        Shr CX,1
       JB @Dispari2e
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Dispari2e:
        MovSW
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Disparie:
        MovSB
        Shr CX,1
       JB @Dispari3e
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Dispari3e:
        MovSW
        DB $66;Rep MovSW
       @EndIf3e:

       Inc DL
       Mov AX,4f05h
       Xor BX,BX
       Int 10h
       Pop CX
       Add CX,Nx
       Xor DI,DI

       Shr CX,1
       JB @Disparis
        Shr CX,1
       JB @Dispari2s
        DB $66;Rep MovSW
        JMP @EndIf5
       @Dispari2s:
        MovSW
        DB $66;Rep MovSW
        JMP @EndIf5
       @Disparis:
        MovSB
        Shr CX,1
       JB @Dispari3s
        DB $66;Rep MovSW
        JMP @EndIf5
       @Dispari3s:
        MovSW
        DB $66;Rep MovSW
      @EndIf5:
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     CLD
     Mov AX,DS
     Mov ES,AX
     Lea DI,Video16Ln

     XOR DX,DX
     CMP X,0
     JGE @EndIf01
      Sub DX,X
      Mov X,0;
     @EndIf01:

     Mov BX,NX
     Sub BX,DX
     Mov CX,BX
     Mov NX,BX
     ADD BX,X

      CMP BX,XEnd
      JNG @Salta
       Mov BX,XEnd
       Sub BX,X
       Mov NX,BX
      @Salta:

      Lea BX,Videoline
      Add BX,DX
      Lea AX,Col16M
      @Ciclo:
       Mov SI,AX
       Xor DH,DH
       Mov DL,Byte PTR [BX]
       Inc BX
       Shl DX,2
       Add SI,DX
       DB $66;MovSW
      Loop @Ciclo

      Mov AX,Y
      Shl AX,2
      Mov BX,X
      Shl BX,2
      Mul Word PTR XMax
      Add AX,BX
      Jnb @NoOverFlow1
       Inc DL
      @NoOverFlow1:

     Mov DI,AX
     Mov AX,0A000h
     Mov ES,AX
     Lea SI,Video16Ln

     Mov AX,4f05h
     Xor BX,BX
     Int 10h
     Shl Word PTR NX,2

     Xor CX,CX
     Sub CX,DI
     Push CX

     CMP CX,0
     JE @Then
     CMP CX,NX
     JB @Else1

     @Then:
      Mov CX,Nx
       Shr CX,2
       DB $66;Rep MovSW
       JMP @Fine

     @Else1:
       Shr CX,2
       DB $66;Rep MovSW
       JMP @End1
        @End1:

       Inc DL
       Mov AX,4f05h
       Xor BX,BX
       Int 10h

       Xor DI,DI
       Mov CX,Nx
       Pop BX
       Sub CX,BX

       Shr CX,2
       DB $66;Rep MovSW

      @Fine:
    End Else
   If (ColorMaxCode=Code32KMode)Or(ColorMaxCode=Code65KMode) Then
    Asm
     CLD
     Mov AX,DS
     Mov ES,AX
     Lea DI,Video16Ln
     XOR DX,DX
     CMP X,0
     JGE @EndIf01
      Sub DX,X
      Mov X,0;
     @EndIf01:
     Mov BX,NX
     Sub BX,DX
     Mov CX,BX
     Mov NX,BX
     ADD BX,X
      CMP BX,XEnd
      JNG @Salta
       Mov BX,XEnd
       Sub BX,X
       Mov NX,BX
      @Salta:
      Lea BX,Videoline
      Add BX,DX
      Lea AX,ColRGB
      @Ciclo:
       Mov SI,AX
       Xor DH,DH
       Mov DL,Byte PTR [BX]
       Inc BX
       Shl DX,1
       Add SI,DX
       MovSW
      Loop @Ciclo
      Mov AX,Y
      Shl AX,1
      Mov BX,X
      Shl BX,1
      Mul Word PTR XMax
      Add AX,BX
      Jnb @NoOverFlow1
       Inc DL
      @NoOverFlow1:
     Mov DI,AX
     Mov AX,0A000h
     Mov ES,AX
     Lea SI,Video16Ln
     Mov AX,4f05h
     Xor BX,BX
     Int 10h
     Shl Word PTR NX,1
     Xor CX,CX
     Sub CX,DI
     Push CX
     CMP CX,0
     JE @Then
     CMP CX,NX
     JB @Else1
     @Then:
      Mov CX,Nx
      Shr CX,1
      JB @Dispari
       Shr CX,1
      JB @Dispari2
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari2:
       MovSW
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari:
       MovSB
       Shr CX,1
      JB @Dispari3
       DB $66;Rep MovSW
       JMP @EndIf5
      @Dispari3:
       MovSW
       DB $66;Rep MovSW
       JMP @EndIf5
     @Else1:
       Shr CX,1
       JB @Disparie
        Shr CX,1
       JB @Dispari2e
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Dispari2e:
        MovSW
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Disparie:
        MovSB
        Shr CX,1
       JB @Dispari3e
        DB $66;Rep MovSW
        JMP @EndIf3e
       @Dispari3e:
        MovSW
        DB $66;Rep MovSW
       @EndIf3e:
       Inc DL
       Mov AX,4f05h
       Xor BX,BX
       Int 10h
       Xor DI,DI
       Mov CX,Nx
       Pop BX
       Sub CX,BX
       Shr CX,1
       JB @Disparis
        Shr CX,1
       JB @Dispari2s
        DB $66;Rep MovSW
        JMP @EndIf5
       @Dispari2s:
        MovSW
        DB $66;Rep MovSW
        JMP @EndIf5
       @Disparis:
        MovSB
        Shr CX,1
       JB @Dispari3s
        DB $66;Rep MovSW
        JMP @EndIf5
       @Dispari3s:
        MovSW
        DB $66;Rep MovSW
      @EndIf5:
    End;

 End;
End;


Procedure BufVideoLine(Y:Integer);
Var Locat:LongInt;
    I,I2,Nx2:Word;
Begin
 If Y>=0 Then
  Begin
   If ColorMax='256' Then
    Begin
     Locat:=Y*XMax;
     TransfertXMS(XMax);
     SetDestOffs(Locat);
     ToXMS(VideoLine[0],VideoPage2);
     MoveXMS;
    End Else
   If ColorMax='16M' Then
    Begin
     I2:=0;
     For I:=0 To XEnd Do
      Begin
       Video16Ln[I2]:=RGB[VideoLine[I]].B Shl 2;
       Asm Inc I2 End;
       Video16Ln[I2]:=RGB[VideoLine[I]].G Shl 2;
       Asm Inc I2 End;
       Video16Ln[I2]:=RGB[VideoLine[I]].R Shl 2;
       Asm Inc I2 End;
       Video16Ln[I2]:=0;
       Asm Inc I2 End;
      End;
     Nx2:=XMax Shl 2;
     Locat:=(Y*XMax) Shl 2;
     TransfertXMS(Nx2);
     SetDestOffs(Locat);
     ToXMS(Video16Ln[0],VideoPage2);
     MoveXMS;
    End;
  End;
End;

Procedure SfnVideoLine(Y:Integer);
Var Locat:LongInt;
    I,I2,Nx2:Word;
Begin
 If Y>=0 Then
  Begin
   If ColorMax='256' Then
    Begin
     Locat:=Y*XMax;
     TransfertXMS(XMax);
     SetDestOffs(Locat);
     ToXMS(VideoLine[0],VideoPage1);
     MoveXMS;
    End Else
   If ColorMax='16M' Then
    Begin
     I2:=0;
     For I:=0 To XEnd Do
      Begin
       Video16Ln[I2]:=RGB[VideoLine[I]].B Shl 2;
       Asm Inc I2 End;
       Video16Ln[I2]:=RGB[VideoLine[I]].G Shl 2;
       Asm Inc I2 End;
       Video16Ln[I2]:=RGB[VideoLine[I]].R Shl 2;
       Asm Inc I2 End;
       Video16Ln[I2]:=0;
       Asm Inc I2 End;
      End;
     Nx2:=XMax Shl 2;
     Locat:=(Y*XMax) Shl 2;
     TransfertXMS(Nx2);
     SetDestOffs(Locat);
     ToXMS(Video16Ln[0],VideoPage1);
     MoveXMS;
    End;
  End;
End;

Procedure BufVideoLineX(X,Y,Nx:Integer);
Begin
 If (Y>=0)And(X<XMax) Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     XOR AX,AX
     Mov CX,X
     Mov BX,NX
     Mov DX,XEnd
     CMP CX,0
     JGE @EndIf1
      Sub AX,CX
      Add BX,CX
      Xor CX,CX
     @EndIf1:
     Lea DI,VideoLine
     Add DI,AX
     Mov Word Ptr [XMSData.OffSource],DI

     Mov AX,CX
     Add AX,BX
     CMP AX,DX
     JNA @EndIf2
      Mov BX,DX
      Sub BX,CX
     @EndIf2:


     Mov Word PTR [XMSData.Transfer],BX
     Mov Word PTR [XMSData.Transfer+2],0
     Inc DX
     Mov AX,Y
     Mul DX
     Add AX,CX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov Word Ptr [XMSData.OffDest],AX
     Mov Word Ptr [XMSData.OffDest+2],DX
     Mov XMSData.Source,0000h
     Mov AX,VideoPage2
     Mov Word PTR XMSData.Dest,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     Mov AX,DS
     Mov ES,AX
     XOR AX,AX
     Mov BX,X
     CMP BX,0
     JGE @EndIf1
      Sub AX,BX
      Xor BX,BX
     @EndIf1:
     Push BX
     Mov CX,Nx
     Sub NX,AX
     Sub CX,AX
     Lea DI,Video16Ln
     Lea BX,Videoline
     Add BX,AX
     Lea AX,Col16M
     @Ciclo:
      Mov SI,AX
      Xor DH,DH
      Mov DL,Byte PTR [BX]
      Inc BX
      Shl DX,2
      Add SI,DX
      DB $66;MovSW
     Loop @Ciclo
     Pop BX

     Mov DX,XEnd
     Mov CX,NX
     Mov AX,BX
     Add AX,CX
     CMP AX,DX
     JBE @EndIf2
      Mov CX,DX
      Sub CX,BX
     @EndIf2:
     Shl CX,2
     Mov Word PTR [XMSData.Transfer],CX

     Mov AX,Y
     Shl AX,2
     Shl BX,2
     Inc DX
     Mul DX
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov Word Ptr [XMSData.OffDest],AX
     Mov Word Ptr [XMSData.OffDest+2],DX
     Mov Word PTR [XMSData.Transfer+2],0
     Mov XMSData.Source,0000h
     Mov AX,VideoPage2
     Mov Word PTR XMSData.Dest,AX
     Lea AX,Video16Ln
     Mov Word Ptr [XMSData.OffSource],AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If (ColorMaxCode=Code32KMode)Or(ColorMaxCode=Code65KMode) Then
    Asm
     Mov AX,DS
     Mov ES,AX
     XOR AX,AX
     Mov BX,X
     CMP BX,0
     JGE @EndIf1
      Sub AX,BX
      Xor BX,BX
     @EndIf1:
     Push BX
     Mov CX,Nx
     Sub NX,AX
     Sub CX,AX
     Lea DI,Video16Ln
     Lea BX,Videoline
     Add BX,AX
     Lea AX,ColRGB
     @Ciclo:
      Mov SI,AX
      Xor DH,DH
      Mov DL,Byte PTR [BX]
      Inc BX
      Shl DX,1
      Add SI,DX
      MovSW
     Loop @Ciclo
     Pop BX

     Mov DX,XEnd
     Mov CX,NX
     Mov AX,BX
     Add AX,CX
     CMP AX,DX
     JBE @EndIf2
      Mov CX,DX
      Sub CX,BX
     @EndIf2:
     Shl CX,1
     Mov Word PTR [XMSData.Transfer],CX
     Mov AX,Y
     Shl AX,1
     Shl BX,1
     Inc DX
     Mul DX
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov Word Ptr [XMSData.OffDest],AX
     Mov Word Ptr [XMSData.OffDest+2],DX
     Mov Word PTR [XMSData.Transfer+2],0
     Mov XMSData.Source,0000h
     Mov AX,VideoPage2
     Mov Word PTR XMSData.Dest,AX
     Lea AX,Video16Ln
     Mov Word Ptr [XMSData.OffSource],AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End;
  End;
End;



Procedure SfnVideoLineX(X,Y,Nx:Integer);
Begin
 If (Y>=0)And(X<XMax) Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     XOR AX,AX
     Mov CX,X
     Mov BX,NX
     Mov DX,XEnd
     CMP CX,0
     JGE @EndIf1
      Sub AX,CX
      Add BX,CX
      Xor CX,CX
     @EndIf1:
     Lea DI,VideoLine
     Add DI,AX
     Mov Word Ptr [XMSData.OffSource],DI

     Mov AX,CX
     Add AX,BX
     CMP AX,DX
     JNA @EndIf2
      Mov BX,DX
      Sub BX,CX
     @EndIf2:

     Mov Word PTR [XMSData.Transfer],BX
     Mov Word PTR [XMSData.Transfer+2],0
     Inc DX
     Mov AX,Y
     Mul DX
     Add AX,CX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov Word Ptr [XMSData.OffDest],AX
     Mov Word Ptr [XMSData.OffDest+2],DX
     Mov XMSData.Source,0000h
     Mov AX,VideoPage1
     Mov Word PTR XMSData.Dest,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     Mov AX,DS
     Mov ES,AX
     XOR AX,AX
     Mov BX,X
     CMP BX,0
     JGE @EndIf1
      Sub AX,BX
      Xor BX,BX
     @EndIf1:
     Push BX
     Mov CX,Nx
     Sub NX,AX
     Sub CX,AX
     Lea DI,Video16Ln
     Lea BX,Videoline
     Add BX,AX
     Lea AX,Col16M
     @Ciclo:
      Mov SI,AX
      Xor DH,DH
      Mov DL,Byte PTR [BX]
      Inc BX
      Shl DX,2
      Add SI,DX
      DB $66;MovSW
     Loop @Ciclo
     Pop BX

     Mov DX,XEnd
     Mov CX,NX
     Mov AX,BX
     Add AX,CX
     CMP AX,DX
     JBE @EndIf2
      Mov CX,DX
      Sub CX,BX
     @EndIf2:
     Shl CX,2
     Mov Word PTR [XMSData.Transfer],CX

     Mov AX,Y
     Shl AX,2
     Shl BX,2
     Inc DX
     Mul DX
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov Word Ptr [XMSData.OffDest],AX
     Mov Word Ptr [XMSData.OffDest+2],DX
     Mov Word PTR [XMSData.Transfer+2],0
     Mov XMSData.Source,0000h
     Mov AX,VideoPage1
     Mov Word PTR XMSData.Dest,AX
     Lea AX,Video16Ln
     Mov Word Ptr [XMSData.OffSource],AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else

   If (ColorMaxCode=Code32KMode)Or(ColorMaxCode=Code65KMode) Then
    Asm
     Mov AX,DS
     Mov ES,AX
     XOR AX,AX
     Mov BX,X
     CMP BX,0
     JGE @EndIf1
      Sub AX,BX
      Xor BX,BX
     @EndIf1:
     Push BX
     Mov CX,Nx
     Sub NX,AX
     Sub CX,AX
     Lea DI,Video16Ln
     Lea BX,Videoline
     Add BX,AX
     Lea AX,ColRGB
     @Ciclo:
      Mov SI,AX
      Xor DH,DH
      Mov DL,Byte PTR [BX]
      Inc BX
      Shl DX,1
      Add SI,DX
      MovSW
     Loop @Ciclo
     Pop BX

     Mov DX,XEnd
     Mov CX,NX
     Mov AX,BX
     Add AX,CX
     CMP AX,DX
     JBE @EndIf2
      Mov CX,DX
      Sub CX,BX
     @EndIf2:
     Shl CX,1
     Mov Word PTR [XMSData.Transfer],CX
     Mov AX,Y
     Shl AX,1
     Shl BX,1
     Inc DX
     Mul DX
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov Word Ptr [XMSData.OffDest],AX
     Mov Word Ptr [XMSData.OffDest+2],DX
     Mov Word PTR [XMSData.Transfer+2],0
     Mov XMSData.Source,0000h
     Mov AX,VideoPage1
     Mov Word PTR XMSData.Dest,AX
     Lea AX,Video16Ln
     Mov Word Ptr [XMSData.OffSource],AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End;
  End;
End;




Procedure RPointR(Xi,Yi,Xc,Yc:Integer;Angle:Double;Var NewX,NewY:Integer);Assembler;
Asm
 FINIT                     {  Reset del Coprocessore                   }
 FLD QWord PTR Angle       {  Caricamento nello Stack dell Angolo      }
 FMUL QWord PTR RadFat     {  Trasformazion dell'Angolo in Radianti    }
 DB $D9;DB $FB             {  Sin e Cos dell'Angolo                    }

 Mov AX,Xc                 {  Translazione delle coordinate verso      }
 Mov BX,Yc                 {  l'origine degli assi cartesioni          }
 Sub Xi,AX                 {                                           }
 Sub Yi,BX                 {                                           }

 FILD Word PTR Yi          {  Caricamento di Yi nello Stack            }
 FMUL ST,ST(2)             {  Esecuzione di Yi*Seno                    }
 FILD Word PTR Xi          {  Caricamento di Xi nello Stack            }
 FMUL ST,ST(2)             {  Esecuzione di Xi*Coseno                  }
 FSUB ST,ST(1)             {  Esecuzione di (Xi*Coseno)-(Yi*Seno)      }

 LES DI,NewX               {  Caricamento indirizzo di NewX in ES:DI   }
 FISTP ES:Word PTR [DI]    {  Caricamento in NewX del contenuto in ST  }
 Add ES:Word PTR [DI],AX   {  Translazione di NewX                     }

 FILD Word PTR Xi          {  Caricamento di Xi nello Stack            }
 FMUL ST,ST(3)             {  Esecuzione di Xi*Seno                    }
 FILD Word PTR Yi          {  Caricamento di Yi nello Stack            }
 FMUL ST,ST(3)             {  Esecuzione di Yi*Coseno                  }
 FADD ST,ST(1)             {  Esecuzione di (Xi*Seno)+(Yi*CoSeno)      }

 LES DI,NewY               {  Caricamento indirizzo di NewY in ES:DI   }
 FISTP ES:Word PTR [DI]    {  Caricamento in NewY del contenuto in ST  }
 Add ES:Word PTR [DI],BX   {  Translazione di NewY                     }

 FINIT                     {  Reset del Coprocessore                   }
End;

Procedure RPointL(Xi,Yi,Xc,Yc:Integer;Angle:Double;Var NewX,NewY:Integer);Assembler;
Asm
 FINIT                     {  Reset del Coprocessore                   }
 FLD QWord PTR Angle       {  Caricamento nello Stack dell Angolo      }
 FMUL QWord PTR RadFat     {  Trasformazion dell'Angolo in Radianti    }
 DB $D9;DB $FB             {  Sin e Cos dell'Angolo                    }

 Mov AX,Xc                 {  Translazione delle coordinate verso      }
 Mov BX,Yc                 {  l'origine degli assi cartesioni          }
 Sub Xi,AX                 {                                           }
 Sub Yi,BX                 {                                           }

 FILD Word PTR Yi          {  Caricamento di Yi nello Stack            }
 FMUL ST,ST(2)             {  Esecuzione di Yi*Seno                    }
 FILD Word PTR Xi          {  Caricamento di Xi nello Stack            }
 FMUL ST,ST(2)             {  Esecuzione di Xi*Coseno                  }
 FSUB ST,ST(1)             {  Esecuzione di (Xi*Coseno)-(Yi*Seno)      }

 LES DI,NewX               {  Caricamento indirizzo di NewX in ES:DI   }
 FISTP ES:Word PTR [DI]    {  Caricamento in NewX del contenuto in ST  }
 Add ES:Word PTR [DI],AX   {  Translazione di NewX                     }

 FILD Word PTR Xi          {  Caricamento di Xi nello Stack            }
 FMUL ST,ST(3)             {  Esecuzione di Xi*Seno                    }
 FILD Word PTR Yi          {  Caricamento di Yi nello Stack            }
 FMUL ST,ST(3)             {  Esecuzione di Yi*Coseno                  }
 FADD ST,ST(1)             {  Esecuzione di (Xi*Seno)+(Yi*CoSeno)      }
 FCHS                      {  Cambiamento di segno del precedente      }

 LES DI,NewY               {  Caricamento indirizzo di NewY in ES:DI   }
 FISTP ES:Word PTR [DI]    {  Caricamento in NewY del contenuto in ST  }
 Add ES:Word PTR [DI],BX   {  Translazione di NewY                     }

 FINIT                     {  Reset del Coprocessore                   }
End;


Procedure SetReferXY(X,Y:Integer);Assembler;
Asm
 Mov AX,X
 Mov XPos,AX
 Mov AX,Y
 Mov YPos,AX
End;

Procedure SetRotateGrads(Gradi:Double);
Begin
 RotateGrads:=Gradi;
End;


Procedure SetColor(Col:Byte);
Begin
 SysCol:=Col;
End;

Procedure SetSfnColor(Col:Byte);
Begin
 SfnCol:=Col;
End;

Procedure MoveABS(X,Y:Integer);
Begin
 XPos:=X;
 YPos:=Y;
End;

Procedure MoveREL(DX,DY:Integer);
Begin
 XPos:=XPos+Dx;
 YPos:=YPos+Dy;
End;

Procedure LineABS(X,Y:Integer);
Begin
 Line(X,Y,XPos,YPos,SysCol);
 XPos:=X;
 YPos:=Y;
End;

Procedure LineREL(DX,DY:Integer);
Begin
 Line(XPos+Dx,YPos+Dy,XPos,YPos,SysCol);
 XPos:=XPos+Dx;
 YPos:=YPos+Dy;
End;



Procedure PutRealPixel(X,Y:Integer;R,G,B,S:Byte);
Var Locat:LongInt;
    Blocco:Byte;
    Posiz:Word;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   If ColorMax='16M' Then
    Begin
     Locat:=(X+(Y*XMax));
     Blocco:=Locat Div 16384;
     SetBlock(Blocco);
     Posiz:=((Locat Mod 16384)*4);
     Mem[$A000:Posiz]:=B;
     Mem[$A000:Posiz+1]:=G;
     Mem[$A000:Posiz+2]:=R;
     Mem[$A000:Posiz+3]:=S;
    End;
  End;
End;

Procedure GetRealPixel(X,Y:Integer;Var R,G,B,S:Byte);
Var Locat:LongInt;
    Blocco:Byte;
    Posiz:Word;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   If ColorMax='16M' Then
    Begin
     Locat:=(X+(Y*XMax));
     Blocco:=Locat Div 16384;
     SetBlock(Blocco);
     Posiz:=((Locat Mod 16384)*4);
     B:=Mem[$A000:Posiz];
     G:=Mem[$A000:Posiz+1];
     R:=Mem[$A000:Posiz+2];
     S:=Mem[$A000:Posiz+3];
    End;
  End;
End;

Function GetPixel(X,Y:Integer):Byte;
Var Locat:LongInt;
    Blocco:Byte;
    Posiz:Word;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   If ColorMax='256' Then
    Begin
     Locat:=(X+(Y*XMax));
     Blocco:=Locat Div 65536;
     SetBlock(Blocco);
     GetPixel:=Mem[$A000:(Locat Mod 65536)];
    End Else
   If ColorMax='16M' Then
    Begin
     Locat:=(X+(Y*XMax));
     Blocco:=Locat Div 16384;
     SetBlock(Blocco);
     Posiz:=((Locat Mod 16384)*4);
     Pixel16M.B:=Mem[$A000:Posiz];
     Pixel16M.G:=Mem[$A000:Posiz+1];
     Pixel16M.R:=Mem[$A000:Posiz+2];
    End;
  End Else GetPixel:=0;
End;


Procedure PutPixel(X,Y:Integer;Color:Byte);
Begin
If Not ShadowColor[Color] Then
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     Mov AX,0A000h
     Mov ES,AX
     Mov AX,Y
     Mul Word PTR XMax
     Add AX,Word PTR X
     Jnb @NoOverFlow1
     Inc DL
     @NoOverFlow1:
     Mov DI,AX
     Mov AX,4f05h
     Xor BX,BX
     Int 10h
     Mov AL,Color
     StoSB
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     Mov AX,0A000h
     Mov ES,AX
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov DI,AX

     Mov AX,4f05h
     Xor BX,BX
     Int 10h

     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea SI,Col16M
     Add SI,CX
     MovSB
     MovSB
     MovSB
    End Else
   If (ColorMaxCode=Code32KMode) Or (ColorMaxCode=Code65KMode) Then
    Asm
     Mov AX,0A000h
     Mov ES,AX
     Mov AX,Y
     Shl AX,1
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,1
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov DI,AX
     Mov AX,4f05h
     Xor BX,BX
     Int 10h
     Xor CH,CH
     Mov CL,Color
     Shl CX,1
     Lea SI,ColRGB
     Add SI,CX
     MovSW
    End;
  End;
End;
End;

Procedure BufPixel(X,Y:Integer;Color:Byte);
Begin
If Not ShadowColor[Color] Then
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],1
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Mul Word PTR XMax
     Add AX,Word PTR X
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Lea AX,Color
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,SS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage2
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],4
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea AX,Col16M
     Add AX,CX
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage2
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If (ColorMaxCode=Code32KMode) Or (ColorMaxCode=Code65KMode) Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],2
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,1
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,1
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Xor CH,CH
     Mov CL,Color
     Shl CX,1
     Lea AX,ColRGB
     Add AX,CX
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage2
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
   End;

  End;
 End;
End;

Procedure SfnPixel(X,Y:Integer;Color:Byte);
Var Locat:LongInt;
Begin
If Not ShadowColor[Color] Then
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   If ColorMaxCode=Code256Mode Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],1
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Mul Word PTR XMax
     Add AX,Word PTR X
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Lea AX,Color
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,SS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage1
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If ColorMaxCode=Code16MMode32Bit Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],4
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX

     Mov XMSData.Source,0000h
     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea AX,Col16M
     Add AX,CX
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage1
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End Else
   If (ColorMaxCode=Code32KMode) Or (ColorMaxCode=Code65KMode) Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],2
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,1
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,1
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Xor CH,CH
     Mov CL,Color
     Shl CX,1
     Lea AX,ColRGB
     Add AX,CX
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage1
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
   End;
  End;
End;
End;


Procedure BufPixel16M(X,Y:Integer;Color:Byte);
Var Locat:LongInt;
    Col:Array[0..4] Of Byte;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],4
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov AX,DS
     Mov ES,AX
     LEA DI,Pixel16M
     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea SI,Col16M
     Add SI,CX
     MovSB
     MovSB
     MovSB
     Mov XMSData.Source,0000h
     Lea AX,Pixel16M
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage2
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End;
End;



Procedure SfnPixel16M(X,Y:Integer;Color:Byte);
Var Locat:LongInt;
    Col:Array[0..4] Of Byte;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],4
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov AX,DS
     Mov ES,AX
     LEA DI,Pixel16M
     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea SI,Col16M
     Add SI,CX
     MovSB
     MovSB
     MovSB
     Mov XMSData.Source,0000h
     Lea AX,Pixel16M
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage1
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]
    End;
End;


Function BufGetPixel256(X,Y:Integer):Byte;
Var Locat:LongInt;
    Color:Byte;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   Locat:=(X+(Y*XMax));
   XMSData.Transfer:=1;
   SetSourceOffs(Locat);
   FromXMS(VideoPage2,Color);
   MoveXMS;
   BufGetPixel256:=Color;
  End Else BufGetPixel256:=0;
End;

Function SfnGetPixel256(X,Y:Integer):Byte;
Var Locat:LongInt;
    Color:Byte;
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   Locat:=(X+(Y*XMax));
   XMSData.Transfer:=1;
   SetSourceOffs(Locat);
   FromXMS(VideoPage1,Color);
   MoveXMS;
   SfnGetPixel256:=Color;
  End Else SfnGetPixel256:=0;
End;


Procedure LineSetSpace(Spc:Integer);
Begin
 PixelStep:=Spc;
End;
Procedure LineSetLengTh(Stp:Integer);
Begin
 PixelLengTh:=Stp;
End;

Procedure Line(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Var
 X,Y,Dx_Step,Dy_Step:Real;
 I,Dx,Dy,Steps:Integer;
 NoPut,PutStep:Integer;
Begin
 Dx:=Abs(Xf-Xi);
 Dy:=Abs(Yf-Yi);
 Steps:=Trunc(Max(Dx,Dy))+1;
 Dx_Step:=Dx/Steps;
 Dy_Step:=Dy/Steps;
 If Xf<Xi Then Dx_Step:=-Dx_Step;
 If Yf<Yi Then Dy_Step:=-Dy_Step;
 X:=Xi;
 Y:=Yi;
 NoPut:=PixelStep;
 PutStep:=PixelLengTh;
 For I:=1 To Steps Do
  Begin
   If PixelStep=0 Then PutPixel(Round(X),Round(Y),Col) Else
   If PutStep>0 Then
    Begin
     PutPixel(Round(X),Round(Y),Col);
     Asm Dec PutStep End;
    End Else
    Begin
     If NoPut>0 Then Asm Dec NoPut End Else
      Begin
       PutStep:=PixelLengTh;
       NoPut:=PixelStep;
      End;
    End;
   X:=X+Dx_Step;
   Y:=Y+Dy_Step;
  End;
 PutPixel(Round(X),Round(Y),Col);
End;

Procedure BufLine(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Var
 X,Y,Dx_Step,Dy_Step:Real;
 I,Dx,Dy,Steps:Integer;
 NoPut,PutStep:Integer;
Begin
 Dx:=Abs(Xf-Xi);
 Dy:=Abs(Yf-Yi);
 Steps:=Trunc(Max(Dx,Dy))+1;
 Dx_Step:=Dx/Steps;
 Dy_Step:=Dy/Steps;
 If Xf<Xi Then Dx_Step:=-Dx_Step;
 If Yf<Yi Then Dy_Step:=-Dy_Step;
 X:=Xi;
 Y:=Yi;
 NoPut:=PixelStep;
 PutStep:=PixelLengTh;
 For I:=1 To Steps Do
  Begin
   If PixelStep=0 Then BufPixel(Round(X),Round(Y),Col) Else
   If PutStep>0 Then
    Begin
     BufPixel(Round(X),Round(Y),Col);
     Asm Dec PutStep End;
    End Else
    Begin
     If NoPut>0 Then Asm Dec NoPut End Else
      Begin
       PutStep:=PixelLengTh;
       NoPut:=PixelStep;
      End;
    End;
   X:=X+Dx_Step;
   Y:=Y+Dy_Step;
  End;
 BufPixel(Round(X),Round(Y),Col);
End;


Procedure SfnLine(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Var
 X,Y,Dx_Step,Dy_Step:Real;
 I,Dx,Dy,Steps:Integer;
 NoPut,PutStep:Integer;
Begin
 Dx:=Abs(Xf-Xi);
 Dy:=Abs(Yf-Yi);
 Steps:=Trunc(Max(Dx,Dy))+1;
 Dx_Step:=Dx/Steps;
 Dy_Step:=Dy/Steps;
 If Xf<Xi Then Dx_Step:=-Dx_Step;
 If Yf<Yi Then Dy_Step:=-Dy_Step;
 X:=Xi;
 Y:=Yi;
 NoPut:=PixelStep;
 PutStep:=PixelLengTh;
 For I:=1 To Steps Do
  Begin
   If PixelStep=0 Then SfnPixel(Round(X),Round(Y),Col) Else
   If PutStep>0 Then
    Begin
     SfnPixel(Round(X),Round(Y),Col);
     Asm Dec PutStep End;
    End Else
    Begin
     If NoPut>0 Then Asm Dec NoPut End Else
      Begin
       PutStep:=PixelLengTh;
       NoPut:=PixelStep;
      End;
    End;
   X:=X+Dx_Step;
   Y:=Y+Dy_Step;
  End;
 SfnPixel(Round(X),Round(Y),Col);
End;



Procedure Quadrate(Xi,Yi,Lato:Integer;Col:byte);
Begin
 Line(Xi,Yi,Xi+Lato,Yi,Col);
 Line(Xi,Yi,Xi,Yi+Lato,Col);
 Line(Xi+Lato,Yi,Xi+Lato,Yi+Lato,Col);
 Line(Xi,Yi+Lato,Xi+Lato,Yi+Lato,Col);
End;
Procedure BufQuadrate(Xi,Yi,Lato:Integer;Col:byte);
Begin
 BufLine(Xi,Yi,Xi+Lato,Yi,Col);
 BufLine(Xi,Yi,Xi,Yi+Lato,Col);
 BufLine(Xi+Lato,Yi,Xi+Lato,Yi+Lato,Col);
 BufLine(Xi,Yi+Lato,Xi+Lato,Yi+Lato,Col);
End;
Procedure SfnQuadrate(Xi,Yi,Lato:Integer;Col:byte);
Begin
 SfnLine(Xi,Yi,Xi+Lato,Yi,Col);
 SfnLine(Xi,Yi,Xi,Yi+Lato,Col);
 SfnLine(Xi+Lato,Yi,Xi+Lato,Yi+Lato,Col);
 SfnLine(Xi,Yi+Lato,Xi+Lato,Yi+Lato,Col);
End;

Procedure Triangle(X1,Y1,X2,Y2,X3,Y3:Integer;Col:Byte);
Begin
 Line(X1,Y1,X2,Y2,Col);
 Line(X2,Y2,X3,Y3,Col);
 Line(X1,Y1,X3,Y3,Col);
End;
Procedure BufTriangle(X1,Y1,X2,Y2,X3,Y3:Integer;Col:Byte);
Begin
 BufLine(X1,Y1,X2,Y2,Col);
 BufLine(X2,Y2,X3,Y3,Col);
 BufLine(X1,Y1,X3,Y3,Col);
End;
Procedure SfnTriangle(X1,Y1,X2,Y2,X3,Y3:Integer;Col:Byte);
Begin
 SfnLine(X1,Y1,X2,Y2,Col);
 SfnLine(X2,Y2,X3,Y3,Col);
 SfnLine(X1,Y1,X3,Y3,Col);
End;


Procedure Rectangle(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Begin
 Line(Xi,Yi,Xf,Yi,Col);
 Line(Xi,Yi,Xi,Yf,Col);
 Line(Xi,Yf,Xf,Yf,Col);
 Line(Xf,Yi,Xf,Yf,Col);
End;
Procedure BufRectangle(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Begin
 BufLine(Xi,Yi,Xf,Yi,Col);
 BufLine(Xi,Yi,Xi,Yf,Col);
 BufLine(Xi,Yf,Xf,Yf,Col);
 BufLine(Xf,Yi,Xf,Yf,Col);
End;
Procedure SfnRectangle(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Begin
 SfnLine(Xi,Yi,Xf,Yi,Col);
 SfnLine(Xi,Yi,Xi,Yf,Col);
 SfnLine(Xi,Yf,Xf,Yf,Col);
 SfnLine(Xf,Yi,Xf,Yf,Col);
End;

Procedure PutArea(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Var
 X,Y:Word;
Begin
 For Y:=Yi To Yf Do
  For X:=Xi To Xf Do PutPixel(X,Y,Col);
End;
Procedure BufArea(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Var
 X,Y:Word;
Begin
 For Y:=Yi To Yf Do
  For X:=Xi To Xf Do BufPixel(X,Y,Col);
End;
Procedure SfnArea(Xi,Yi,Xf,Yf:Integer;Col:Byte);
Var
 X,Y:Word;
Begin
 For Y:=Yi To Yf Do
  For X:=Xi To Xf Do SfnPixel(X,Y,Col);
End;


Procedure AddRealPixel(X,Y:Integer;R,G,B:Byte);
Var R2,G2,B2,H:Byte;
Begin
 GetRealPixel(X,Y,R2,G2,B2,H);
 If R+R2<256 Then R:=R+R2 Else R:=255;
 If G+G2<256 Then G:=G+G2 Else G:=255;
 If B+B2<256 Then B:=B+B2 Else B:=255;
 PutRealPixel(X,Y,R,G,B,H);
End;

Procedure SubRealPixel(X,Y:Integer;R,G,B:Byte);
Var R2,G2,B2,H:Byte;
Begin
 GetRealPixel(X,Y,R2,G2,B2,H);
 If R-R2>0 Then R:=R-R2 Else R:=0;
 If G-G2>0 Then G:=G-G2 Else G:=0;
 If B-B2>0 Then B:=B-B2 Else B:=0;
 PutRealPixel(X,Y,R,G,B,H);
End;

Procedure Circle(Xi,Yi,Raggio:Integer;Col:Byte);
Var Gr,Ga:Double;
    X,Y,Xa,Ya,Xs,Ys:Integer;
    NoPut,PutStep:Integer;
Begin
 If Raggio>0 Then
  Begin
   Gr:=0;
   Ga:=CirclePrecision / Raggio;
   Asm
    Mov AX,PixelLengTh
    Mov PUtStep,AX
    Mov AX,PixelStep
    Mov NoPut,AX
   End;
   While Gr<90 Do
    Begin
     Asm
      FINIT
      FILD Word PTR Raggio
      FLD QWord PTR GR
      FMUL QWord PTR RadFat
      DB $D9;DB $FB
      FMUL ST,ST(2)
      FISTP Word PTR X
      FMUL ST,ST(1)
      FISTP Word PTR Y
      Mov AX,Xi
      Mov Xa,AX
      Mov Xs,AX
      Mov AX,X
      Add Xa,AX
      Sub Xs,AX
      Mov AX,Yi
      Mov Ya,AX
      Mov Ys,AX
      Mov AX,Y
      Add Ya,AX
      Sub Ys,AX
      Dec Xa
      Inc Xs
     End;
     If PixelStep=0 Then
      Begin
       PutPixel(Xa,Ya,Col);
       PutPixel(Xa,Ys,Col);
       PutPixel(Xs,Ya,Col);
       PutPixel(Xs,Ys,Col);
      End Else
     If PutStep>0 Then
      Begin
       PutPixel(Xa,Ya,Col);
       PutPixel(Xa,Ys,Col);
       PutPixel(Xs,Ya,Col);
       PutPixel(Xs,Ys,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
     Gr:=Gr+Ga;
    End;
  End;
End;


Procedure BufCircle(Xi,Yi,Raggio:Integer;Col:Byte);
Var Gr,Ga:Real;
    X,Y,Xa,Ya,Xs,Ys:Integer;
    NoPut,PutStep:Integer;
Begin
 If Raggio>0 Then
  Begin
   Gr:=0;
   Ga:=CirclePrecision / Raggio;
   Asm
    Mov AX,PixelLengTh
    Mov PUtStep,AX
    Mov AX,PixelStep
    Mov NoPut,AX
   End;
   While Gr<90 Do
    Begin
     Asm
      FINIT
      FILD Word PTR Raggio
      FLD QWord PTR GR
      FMUL QWord PTR RadFat
      DB $D9;DB $FB
      FMUL ST,ST(2)
      FISTP Word PTR X
      FMUL ST,ST(1)
      FISTP Word PTR Y
      Mov AX,Xi
      Mov Xa,AX
      Mov Xs,AX
      Mov AX,X
      Add Xa,AX
      Sub Xs,AX
      Mov AX,Yi
      Mov Ya,AX
      Mov Ys,AX
      Mov AX,Y
      Add Ya,AX
      Sub Ys,AX
      Dec Xa
      Inc Xs
     End;
     If PixelStep=0 Then
      Begin
       BufPixel(Xa,Ya,Col);
       BufPixel(Xa,Ys,Col);
       BufPixel(Xs,Ya,Col);
       BufPixel(Xs,Ys,Col);
      End Else
     If PutStep>0 Then
      Begin
       BufPixel(Xa,Ya,Col);
       BufPixel(Xa,Ys,Col);
       BufPixel(Xs,Ya,Col);
       BufPixel(Xs,Ys,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
     Gr:=Gr+Ga;
    End;
  End;
End;

Procedure SfnCircle(Xi,Yi,Raggio:Integer;Col:Byte);
Var Gr,Ga:Real;
    X,Y,Xa,Ya,Xs,Ys:Integer;
    NoPut,PutStep:Integer;
Begin
 If Raggio>0 Then
  Begin
   Gr:=0;
   Ga:=CirclePrecision / Raggio;
   Asm
    Mov AX,PixelLengTh
    Mov PUtStep,AX
    Mov AX,PixelStep
    Mov NoPut,AX
   End;
   While Gr<90 Do
    Begin
     Asm
      FINIT
      FILD Word PTR Raggio
      FLD QWord PTR GR
      FMUL QWord PTR RadFat
      DB $D9;DB $FB
      FMUL ST,ST(2)
      FISTP Word PTR X
      FMUL ST,ST(1)
      FISTP Word PTR Y
      Mov AX,Xi
      Mov Xa,AX
      Mov Xs,AX
      Mov AX,X
      Add Xa,AX
      Sub Xs,AX
      Mov AX,Yi
      Mov Ya,AX
      Mov Ys,AX
      Mov AX,Y
      Add Ya,AX
      Sub Ys,AX
      Dec Xa
      Inc Xs
     End;
     If PixelStep=0 Then
      Begin
       SfnPixel(Xa,Ya,Col);
       SfnPixel(Xa,Ys,Col);
       SfnPixel(Xs,Ya,Col);
       SfnPixel(Xs,Ys,Col);
      End Else
     If PutStep>0 Then
      Begin
       SfnPixel(Xa,Ya,Col);
       SfnPixel(Xa,Ys,Col);
       SfnPixel(Xs,Ya,Col);
       SfnPixel(Xs,Ys,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
     Gr:=Gr+Ga;
    End;
  End;
End;

Procedure RealCircle(Xi,Yi,Raggio:Integer;R,G,B:Byte);
Var Gr,Ga:Real;
    X,Y:Integer;
    H:Byte;
    NoPut,PutStep:Integer;
Begin
 If Raggio>0 Then
  Begin
   Gr:=0;
   Ga:=CirclePrecision / Raggio;
   Asm
    Mov AX,PixelLengTh
    Mov PUtStep,AX
    Mov AX,PixelStep
    Mov NoPut,AX
   End;
   While Gr<90 Do
    Begin
     X:=Round((Raggio*CoSeno(Gr)));
     Y:=Round((Raggio*Seno(Gr)));
     If PixelStep=0 Then
      Begin
       PutRealPixel(Xi+X,Yi+Y,R,G,B,H);
       PutRealPixel(Xi+X,Yi-Y,R,G,B,H);
       PutRealPixel(Xi-X,Yi+Y,R,G,B,H);
       PutRealPixel(Xi-X,Yi-Y,R,G,B,H);
      End Else
     If PutStep>0 Then
      Begin
       PutRealPixel(Xi+X,Yi+Y,R,G,B,H);
       PutRealPixel(Xi+X,Yi-Y,R,G,B,H);
       PutRealPixel(Xi-X,Yi+Y,R,G,B,H);
       PutRealPixel(Xi-X,Yi-Y,R,G,B,H);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Begin
         PutStep:=PixelLengTh;
         NoPut:=PixelStep;
        End;
      End;
     Gr:=Gr+Ga;
    End;
  End;
End;


Procedure SetCirclePrecision(Pr:Byte);
Begin
 CirclePrecision:=255-Pr;
End;

Procedure Ellipse(X,Y,Dx,Dy:Integer;Col:Byte);
Var
 Xr,Yr,X2,J:Integer;
 NoPut,PutStep:Integer;
Begin
 Asm
  Mov AX,PixelLengTh
  Mov PUtStep,AX
  Mov AX,PixelStep
  Mov NoPut,AX
  Dec Dy
 End;
 X2:=Dx;
 For Yr:=0 To Dy Do
  Begin
   Xr:=Trunc(Dx/Dy*Sqrt(Sqr(Dy)-Sqr(Yr-0.5)));
   For J:=Xr To X2 Do
    Begin
     If PixelStep=0 Then
      Begin
       PutPixel(X+J,Y+Yr,Col);
       PutPixel(X-J,Y+Yr,Col);
       PutPixel(X+J,Y-Yr,Col);
       PutPixel(X-J,Y-Yr,Col);
      End Else
     If PutStep>0 Then
      Begin
       PutPixel(X+J,Y+Yr,Col);
       PutPixel(X-J,Y+Yr,Col);
       PutPixel(X+J,Y-Yr,Col);
       PutPixel(X-J,Y-Yr,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
    End;
   X2:=Xr;
  End;
 Asm Inc Dy End;
 For J:=0 To Xr Do
  Begin
     If PixelStep=0 Then
      Begin
       PutPixel(X+J,Y+Dy,Col);
       PutPixel(X-J,Y+Dy,Col);
       PutPixel(X+J,Y-Dy,Col);
       PutPixel(X-J,Y-Dy,Col);
      End Else
     If PutStep>0 Then
      Begin
       PutPixel(X+J,Y+Dy,Col);
       PutPixel(X-J,Y+Dy,Col);
       PutPixel(X+J,Y-Dy,Col);
       PutPixel(X-J,Y-Dy,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
  End;
End;


Procedure BufEllipse(X,Y,Dx,Dy:Integer;Col:Byte);
Var
 Xr,Yr,X2,J:Integer;
 NoPut,PutStep:Integer;
Begin
 Asm
  Mov AX,PixelLengTh
  Mov PUtStep,AX
  Mov AX,PixelStep
  Mov NoPut,AX
  Dec Dy
 End;
 X2:=Dx;
 For Yr:=0 To Dy Do
  Begin
   Xr:=Trunc(Dx/Dy*Sqrt(Sqr(Dy)-Sqr(Yr-0.5)));
   For J:=Xr To X2 Do
    Begin
     If PixelStep=0 Then
      Begin
       BufPixel(X+J,Y+Yr,Col);
       BufPixel(X-J,Y+Yr,Col);
       BufPixel(X+J,Y-Yr,Col);
       BufPixel(X-J,Y-Yr,Col);
      End Else
     If PutStep>0 Then
      Begin
       BufPixel(X+J,Y+Yr,Col);
       BufPixel(X-J,Y+Yr,Col);
       BufPixel(X+J,Y-Yr,Col);
       BufPixel(X-J,Y-Yr,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
    End;
   X2:=Xr;
  End;
 Asm Inc Dy End;
 For J:=0 To Xr Do
  Begin
     If PixelStep=0 Then
      Begin
       BufPixel(X+J,Y+Dy,Col);
       BufPixel(X-J,Y+Dy,Col);
       BufPixel(X+J,Y-Dy,Col);
       BufPixel(X-J,Y-Dy,Col);
      End Else
     If PutStep>0 Then
      Begin
       BufPixel(X+J,Y+Dy,Col);
       BufPixel(X-J,Y+Dy,Col);
       BufPixel(X+J,Y-Dy,Col);
       BufPixel(X-J,Y-Dy,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
  End;
End;

Procedure SfnEllipse(X,Y,Dx,Dy:Integer;Col:Byte);
Var
 Xr,Yr,X2,J:Integer;
 NoPut,PutStep:Integer;
Begin
 Asm
  Mov AX,PixelLengTh
  Mov PUtStep,AX
  Mov AX,PixelStep
  Mov NoPut,AX
  Dec Dy
 End;
 X2:=Dx;
 For Yr:=0 To Dy Do
  Begin
   Xr:=Trunc(Dx/Dy*Sqrt(Sqr(Dy)-Sqr(Yr-0.5)));
   For J:=Xr To X2 Do
    Begin
     If PixelStep=0 Then
      Begin
       SfnPixel(X+J,Y+Yr,Col);
       SfnPixel(X-J,Y+Yr,Col);
       SfnPixel(X+J,Y-Yr,Col);
       SfnPixel(X-J,Y-Yr,Col);
      End Else
     If PutStep>0 Then
      Begin
       SfnPixel(X+J,Y+Yr,Col);
       SfnPixel(X-J,Y+Yr,Col);
       SfnPixel(X+J,Y-Yr,Col);
       SfnPixel(X-J,Y-Yr,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
    End;
   X2:=Xr;
  End;
 Asm Inc Dy End;
 For J:=0 To Xr Do
  Begin
     If PixelStep=0 Then
      Begin
       SfnPixel(X+J,Y+Dy,Col);
       SfnPixel(X-J,Y+Dy,Col);
       SfnPixel(X+J,Y-Dy,Col);
       SfnPixel(X-J,Y-Dy,Col);
      End Else
     If PutStep>0 Then
      Begin
       SfnPixel(X+J,Y+Dy,Col);
       SfnPixel(X-J,Y+Dy,Col);
       SfnPixel(X+J,Y-Dy,Col);
       SfnPixel(X-J,Y-Dy,Col);
       Asm Dec PutStep End;
      End Else
      Begin
       If NoPut>0 Then Asm Dec NoPut End Else
        Asm
         Mov AX,PixelLengTh
         Mov PUtStep,AX
         Mov AX,PixelStep
         Mov NoPut,AX
        End;
      End;
  End;
End;


Procedure Fill(X,Y:Integer;Col:Byte);
Var Xs,Xd,Ys,Yd:Integer;
    Xcs,Xcd,Ycs,Ycd:Integer;
    Sf:Byte;
Begin
 Sf:=GetPixel(X,Y);
 Asm
  Mov AX,X
  Mov Xs,AX
 End;
 If GetPixel(X+1,Y)=Sf Then Xd:=X+1;
 Repeat
  Xcs:=GetPixel(Xs,Y);
  If Xcs=Sf Then
   Begin
    Asm
     Mov AX,Y
     Mov Ys,AX
    End;
    If GetPixel(Xs,Y+1)=Sf Then Yd:=Y+1;
    Repeat
     Ycs:=GetPixel(Xs,Ys);
     If Ycs=Sf Then
      Begin
       PutPixel(Xs,Ys,Col);
       Asm Dec Ys End;
      End;
     Ycd:=GetPixel(Xs,Yd);
     If Ycd=Sf Then
      Begin
       PutPixel(Xs,Yd,Col);
       Asm Inc Yd End;
      End;
    Until ((Ycs<>Sf)Or(Ys<Ystart))And((Ycd<>Sf)Or(Yd>YEnd));
    PutPixel(Xs,Y,Col);
    Asm Dec Xs End;
   End;

  Xcd:=GetPixel(Xd,Y);
  If Xcd=Sf Then
   Begin
    Asm
     Mov AX,Y
     Mov Ys,AX
    End;
    If GetPixel(Xd,Y+1)=Sf Then Yd:=Y+1;
    Repeat
     Ycs:=GetPixel(Xd,Ys);
     If Ycs=Sf Then
      Begin
       PutPixel(Xd,Ys,Col);
       Asm Dec Ys End;
      End;
     Ycd:=GetPixel(Xd,Yd);
     If Ycd=Sf Then
      Begin
       PutPixel(Xd,Yd,Col);
       Asm Inc Yd End;
      End;
    Until ((Ycs<>Sf)Or(Ys<Ystart))And((Ycd<>Sf)Or(Yd>YEnd));
    PutPixel(Xd,Y,Col);
    Asm Inc Xd End;
   End;

 Until ((Xcs<>Sf)Or(Xs<XStart))And((Xcd<>Sf)Or(Xd>XEnd));
End;

Procedure Flood(X,Y:Integer;Col,Sfn:Byte);
Var Xs,Xd,Ys,Yd:Integer;
    Xcs,Xcd,Ycs,Ycd:Integer;
    Sf:Byte;
Begin
 Asm
  Mov AL,Sfn
  Mov Sf,AL
  Mov AX,X
  Mov Xs,AX
 End;
 If GetPixel(X+1,Y)<>Sf Then Xd:=X+1;
 Repeat
  Xcs:=GetPixel(Xs,Y);
  If Xcs<>Sf Then
   Begin
    Asm
     Mov AX,Y
     Mov Ys,AX
    End;
    If GetPixel(Xs,Y+1)<>Sf Then Yd:=Y+1;
    Repeat
     Ycs:=GetPixel(Xs,Ys);
     If Ycs<>Sf Then
      Begin
       PutPixel(Xs,Ys,Col);
       Asm Dec Ys End;
      End;
     Ycd:=GetPixel(Xs,Yd);
     If Ycd<>Sf Then
      Begin
       PutPixel(Xs,Yd,Col);
       Asm Inc Yd End;
      End;
    Until ((Ycs=Sf)Or(Ys<Ystart))And((Ycd=Sf)Or(Yd>YEnd));
    PutPixel(Xs,Y,Col);
    Asm Dec Xs End;
   End;
  Xcd:=GetPixel(Xd,Y);
  If Xcd<>Sf Then
   Begin
    Asm
     Mov AX,Y
     Mov Ys,AX
    End;
    If GetPixel(Xd,Y+1)<>Sf Then Yd:=Y+1;
    Repeat
     Ycs:=GetPixel(Xd,Ys);
     If Ycs<>Sf Then
      Begin
       PutPixel(Xd,Ys,Col);
       Asm Dec Ys End;
      End;
     Ycd:=GetPixel(Xd,Yd);
     If Ycd<>Sf Then
      Begin
       PutPixel(Xd,Yd,Col);
       Asm Inc Yd End;
      End;
    Until ((Ycs=Sf)Or(Ys<Ystart))And((Ycd=Sf)Or(Yd>YEnd));
    PutPixel(Xd,Y,Col);
    Asm Inc Xd End;
   End;
 Until ((Xcs=Sf)Or(Xs<XStart))And((Xcd=Sf)Or(Xd<XEnd));
End;


Procedure SetDoubleBuffer;Assembler;
Asm
 Mov AX,Word PTR [VirtualPageSize]
 Mov Word PTR [XMS_DBL.Transfer],AX
 Mov AX,Word PTR [VirtualPageSize+2]
 Mov Word PTR [XMS_DBL.Transfer+2],AX
 Mov AX,VideoPage1
 Mov XMS_DBL.Source,AX
 Mov Word PTR [XMS_DBL.OffSource],0
 Mov Word PTR [XMS_DBL.OffSource+2],0
 Mov AX,VideoPage2
 Mov XMS_DBL.Dest,AX
 Mov Word PTR [XMS_DBL.OffDest],0
 Mov Word PTR [XMS_DBL.OffDest+2],0

 Mov Word PTR [XMS_L.Source],0
 Mov AX,0A000h
 Mov Word PTR [XMS_L.OffSource+2],AX
 Mov AX,VideoPage1
 Mov Word PTR [XMS_L.Dest],AX

 Mov AX,VideoPage2
 Mov Word PTR [XMS_V.Source],AX
 Mov Word PTR [XMS_V.Dest],0
 Mov AX,0A000h
 Mov Word PTR [XMS_V.OffDest+2],AX
End;

Procedure LScreen;Assembler;
Asm
 Lea SI,XMS_L
 Mov Word PTR [XMS_L.Transfer],0
 Mov Word PTR [XMS_L.Transfer+2],1
 Mov Word PTR [XMS_L.OffDest],0
 Mov Word PTR [XMS_L.OffDest+2],0
 Mov Word PTR [XMS_L.OffSource],0
 XOR CX,CX
 Dec CX
 Push CX
 Inc CX
 Mov CL,PageForScreen
 @Ciclo:
  Mov AX,4f05h
  Xor BX,BX
  XOR DH,DH
  Pop DX
  Inc DX
  Push DX
  Int 10h
  Mov AH,0Bh
  Call [XMS_Point]
  Inc Word PTR [XMS_L.OffDest+2]
 Loop @Ciclo
 Pop CX
 Lea SI,XMS_DBL
 Mov AH,0Bh
 Call [XMS_Point]
End;


Procedure VScreen;Assembler;
Asm
 Lea SI,XMS_V
 Mov Word PTR [XMS_V.Transfer],0
 Mov Word PTR [XMS_V.Transfer+2],1
 Mov Word PTR [XMS_V.OffSource],0
 Mov Word PTR [XMS_V.OffSource+2],0
 Mov Word PTR [XMS_V.OffDest],0
 XOR CX,CX
 Dec CX
 Push CX
 Inc CX
 Mov CL,PageForScreen
 @Ciclo:
  Mov AX,4f05h
  Xor BX,BX
  XOR DH,DH
  Pop DX
  Inc DX
  Push DX
  Int 10h
  Mov AH,0Bh
  Call [XMS_Point]
  Inc Word PTR [XMS_V.OffSource+2]
 Loop @Ciclo
 Pop CX
 Lea SI,XMS_DBL
 Mov AH,0Bh
 Call [XMS_Point]
End;



Procedure SizeOfImage(Var SizeX,SizeY:Integer;Var IM:Image);
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 MoveXMS;
 SizeX:=Header[10]+(Header[9] Shl 8);
 SizeY:=Header[12]+(Header[11] Shl 8);
End;


Procedure PutPixelRotate(X,Y:Integer;Color:Byte);
Begin
If Not ShadowColor[Color] Then
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   Asm
    FINIT                     {  Reset del Coprocessore                   }
    FLD QWord PTR RotateGrads {  Caricamento nello Stack dell Angolo      }
    FMUL QWord PTR RadFat     {  Trasformazion dell'Angolo in Radianti    }
    DB $D9;DB $FB             {  Sin e Cos dell'Angolo                    }

    Mov AX,XPos               {  Translazione delle coordinate verso      }
    Mov BX,YPos               {  l'origine degli assi cartesioni          }
    Sub X,AX                  {                                           }
    Sub Y,BX                  {                                           }

    FILD Word PTR Y           {  Caricamento di Yi nello Stack            }
    FMUL ST,ST(2)             {  Esecuzione di Yi*Seno                    }
    FILD Word PTR X           {  Caricamento di Xi nello Stack            }
    FMUL ST,ST(2)             {  Esecuzione di Xi*Coseno                  }
    FSUB ST,ST(1)             {  Esecuzione di (Xi*Coseno)-(Yi*Seno)      }

    LEA DI,RotateX            {  Caricamento indirizzo di NewX in ES:DI   }
    FISTP Word PTR [DI]       {  Caricamento in NewX del contenuto in ST  }
    Add Word PTR [DI],AX      {  Translazione di NewX                     }

    FILD Word PTR X           {  Caricamento di Xi nello Stack            }
    FMUL ST,ST(3)             {  Esecuzione di Xi*Seno                    }
    FILD Word PTR Y           {  Caricamento di Yi nello Stack            }
    FMUL ST,ST(3)             {  Esecuzione di Yi*Coseno                  }
    FADD ST,ST(1)             {  Esecuzione di (Xi*Seno)+(Yi*CoSeno)      }

    LEA DI,RotateY            {  Caricamento indirizzo di NewY in ES:DI   }
    FISTP Word PTR [DI]       {  Caricamento in NewY del contenuto in ST  }
    Add Word PTR [DI],BX      {  Translazione di NewY                     }

    FINIT                     {  Reset del Coprocessore                   }

    Mov AX,RotateX
    Mov X,AX
    Mov AX,RotateY
    Mov Y,AX
   End;

   If ColorMaxCode=Code256Mode Then
    Asm
     Mov AX,0A000h
     Mov ES,AX
     Mov AX,Y
     Mul Word PTR XMax
     Add AX,Word PTR X
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov DI,AX

     Mov AX,4f05h
     Xor BX,BX
     Int 10h

     Mov AL,Color
     StoSB
    End Else
   If ColorMax='16M' Then
    Asm
     Mov AX,0A000h
     Mov ES,AX
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Mov DI,AX

     Mov AX,4f05h
     Xor BX,BX
     Int 10h

     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea SI,Col16M
     Add SI,CX
     MovSB
     MovSB
     MovSB
    End;
  End;
End;
End;

Procedure BufPixelRotate(X,Y:Integer;Color:Byte);
Begin
If Not ShadowColor[Color] Then
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   Asm
    FINIT                     {  Reset del Coprocessore                   }
    FLD QWord PTR RotateGrads {  Caricamento nello Stack dell Angolo      }
    FMUL QWord PTR RadFat     {  Trasformazion dell'Angolo in Radianti    }
    DB $D9;DB $FB             {  Sin e Cos dell'Angolo                    }

    Mov AX,XPos               {  Translazione delle coordinate verso      }
    Mov BX,YPos               {  l'origine degli assi cartesioni          }
    Sub X,AX                  {                                           }
    Sub Y,BX                  {                                           }

    FILD Word PTR Y           {  Caricamento di Yi nello Stack            }
    FMUL ST,ST(2)             {  Esecuzione di Yi*Seno                    }
    FILD Word PTR X           {  Caricamento di Xi nello Stack            }
    FMUL ST,ST(2)             {  Esecuzione di Xi*Coseno                  }
    FSUB ST,ST(1)             {  Esecuzione di (Xi*Coseno)-(Yi*Seno)      }

    LEA DI,RotateX            {  Caricamento indirizzo di NewX in ES:DI   }
    FISTP Word PTR [DI]       {  Caricamento in NewX del contenuto in ST  }
    Add Word PTR [DI],AX      {  Translazione di NewX                     }

    FILD Word PTR X           {  Caricamento di Xi nello Stack            }
    FMUL ST,ST(3)             {  Esecuzione di Xi*Seno                    }
    FILD Word PTR Y           {  Caricamento di Yi nello Stack            }
    FMUL ST,ST(3)             {  Esecuzione di Yi*Coseno                  }
    FADD ST,ST(1)             {  Esecuzione di (Xi*Seno)+(Yi*CoSeno)      }

    LEA DI,RotateY            {  Caricamento indirizzo di NewY in ES:DI   }
    FISTP Word PTR [DI]       {  Caricamento in NewY del contenuto in ST  }
    Add Word PTR [DI],BX      {  Translazione di NewY                     }

    FINIT                     {  Reset del Coprocessore                   }

    Mov AX,RotateX
    Mov X,AX
    Mov AX,RotateY
    Mov Y,AX
   End;

   If ColorMaxCode=Code256Mode Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],1
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Mul Word PTR XMax
     Add AX,Word PTR X
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Lea AX,Color
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,SS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage2
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]

 {    Inc Word PTR [DI]
     Mov AH,0Bh
     Call [XMS_Point]}
    End Else
   If ColorMax='16M' Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],4
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX

     Mov XMSData.Source,0000h
     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea AX,Col16M
     Add AX,CX
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage2
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]

    End;
  End;
End;
End;


Procedure SfnPixelRotate(X,Y:Integer;Color:Byte);
Var Locat:LongInt;
Begin
If Not ShadowColor[Color] Then
Begin
 If (Y>=0) And ((X>=0) And (X<XMax)) Then
  Begin
   Asm
    FINIT                     {  Reset del Coprocessore                   }
    FLD QWord PTR RotateGrads {  Caricamento nello Stack dell Angolo      }
    FMUL QWord PTR RadFat     {  Trasformazion dell'Angolo in Radianti    }
    DB $D9;DB $FB             {  Sin e Cos dell'Angolo                    }

    Mov AX,XPos               {  Translazione delle coordinate verso      }
    Mov BX,YPos               {  l'origine degli assi cartesioni          }
    Sub X,AX                  {                                           }
    Sub Y,BX                  {                                           }

    FILD Word PTR Y           {  Caricamento di Yi nello Stack            }
    FMUL ST,ST(2)             {  Esecuzione di Yi*Seno                    }
    FILD Word PTR X           {  Caricamento di Xi nello Stack            }
    FMUL ST,ST(2)             {  Esecuzione di Xi*Coseno                  }
    FSUB ST,ST(1)             {  Esecuzione di (Xi*Coseno)-(Yi*Seno)      }

    LEA DI,RotateX            {  Caricamento indirizzo di NewX in ES:DI   }
    FISTP Word PTR [DI]       {  Caricamento in NewX del contenuto in ST  }
    Add Word PTR [DI],AX      {  Translazione di NewX                     }

    FILD Word PTR X           {  Caricamento di Xi nello Stack            }
    FMUL ST,ST(3)             {  Esecuzione di Xi*Seno                    }
    FILD Word PTR Y           {  Caricamento di Yi nello Stack            }
    FMUL ST,ST(3)             {  Esecuzione di Yi*Coseno                  }
    FADD ST,ST(1)             {  Esecuzione di (Xi*Seno)+(Yi*CoSeno)      }

    LEA DI,RotateY            {  Caricamento indirizzo di NewY in ES:DI   }
    FISTP Word PTR [DI]       {  Caricamento in NewY del contenuto in ST  }
    Add Word PTR [DI],BX      {  Translazione di NewY                     }

    FINIT                     {  Reset del Coprocessore                   }

    Mov AX,RotateX
    Mov X,AX
    Mov AX,RotateY
    Mov Y,AX
   End;

   If ColorMaxCode=Code256Mode Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],1
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Mul Word PTR XMax
     Add AX,Word PTR X
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Lea AX,Color
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,SS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage1
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]

    End Else
   If ColorMax='16M' Then
    Asm
     Lea DI,XMSData.Transfer
     Mov Word PTR [DI],4
     Mov Word PTR [DI+2],0
     Mov AX,Y
     Shl AX,2
     Mul Word PTR XMax
     Mov BX,X
     Shl BX,2
     Add AX,BX
     Jnb @NoOverFlow1
      Inc DL
     @NoOverFlow1:
     Lea DI,XMSData.OffDest
     Mov Word PTR [DI],AX
     Mov Word PTR [DI+2],DX
     Mov XMSData.Source,0000h
     Xor CH,CH
     Mov CL,Color
     Shl CX,2
     Lea AX,Col16M
     Add AX,CX
     Mov Word Ptr XMSData.OffSource,AX
     Mov AX,DS
     Mov Word Ptr [XMSData.OffSource+2],AX
     Mov AX,VideoPage1
     Mov Word [XMSData.Dest],AX
     Lea SI,XMSData
     Mov AH,0Bh
     Call [XMS_Point]

    End;
  End;
End;
End;


Procedure PutIMGRotate(Xi,Yi:Integer;Var IM:Image;Gr:Double);
Var
 DimX,DimY,NCod:Word;
 I,J,X,Y,Xf,Z:Integer;
 W:Word;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 MoveXMS;
 NCod:=Header[14]+(Header[13] Shl 8);
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XPos:=(DimX Div 2)+Xi;
 YPos:=(DimY Div 2)+Yi;
 RotateGrads:=Gr;
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=NCod;
 MoveXMS;
 X:=Xi;
 Y:=Yi;
 Xf:=Xi+DimX;
 J:=0;
 W:=16+NCod;
 While Y<Yi+DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     Asm Add J,2 End;
    End Else
    Begin
     XMSData.OffSource:=W;
     FromXMS(IM,ColrLine[0]);
     XMSData.Transfer:=CodeLine[J];
     MoveXMS;
     W:=W+CodeLine[J];
     For Z:=0 To CodeLine[J]-1 Do
      Begin
       PutPixelRotate(Z+X,Y,ColrLine[Z]);
      End;
     X:=X+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=Xf Then
    Asm
     Mov AX,Xi
     Mov X,AX
     Inc Y
    End;
  End;
End;


Procedure BufIMGRotate(Xi,Yi:Integer;Var IM:Image;Gr:Double);
Var
 DimX,DimY,NCod:Word;
 I,J,X,Y,Xf,Z:Integer;
 W:Word;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 MoveXMS;
 NCod:=Header[14]+(Header[13] Shl 8);
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XPos:=(DimX Div 2)+Xi;
 YPos:=(DimY Div 2)+Yi;
 RotateGrads:=Gr;
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=NCod;
 MoveXMS;
 X:=Xi;
 Y:=Yi;
 Xf:=Xi+DimX;
 J:=0;
 W:=16+NCod;
 While Y<Yi+DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     Asm Add J,2 End;
    End Else
    Begin
     XMSData.OffSource:=W;
     FromXMS(IM,ColrLine[0]);
     XMSData.Transfer:=CodeLine[J];
     MoveXMS;
     W:=W+CodeLine[J];
     For Z:=0 To CodeLine[J]-1 Do
      Begin
       BufPixelRotate(Z+X,Y,ColrLine[Z]);
      End;
     X:=X+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=Xf Then
    Asm
     Mov AX,Xi
     Mov X,AX
     Inc Y
    End;
  End;
End;

Procedure SfnIMGRotate(Xi,Yi:Integer;Var IM:Image;Gr:Double);
Var
 DimX,DimY,NCod:Word;
 I,J,X,Y,Xf,Z:Integer;
 W:Word;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 MoveXMS;
 NCod:=Header[14]+(Header[13] Shl 8);
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XPos:=(DimX Div 2)+Xi;
 YPos:=(DimY Div 2)+Yi;
 RotateGrads:=Gr;
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=NCod;
 MoveXMS;
 X:=Xi;
 Y:=Yi;
 Xf:=Xi+DimX;
 J:=0;
 W:=16+NCod;
 While Y<Yi+DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     Asm Add J,2 End;
    End Else
    Begin
     XMSData.OffSource:=W;
     FromXMS(IM,ColrLine[0]);
     XMSData.Transfer:=CodeLine[J];
     MoveXMS;
     W:=W+CodeLine[J];
     For Z:=0 To CodeLine[J]-1 Do
      Begin
       SfnPixelRotate(Z+X,Y,ColrLine[Z]);
      End;
     X:=X+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=Xf Then
    Asm
     Mov AX,Xi
     Mov X,AX
     Inc Y
    End;
  End;
End;

Procedure PutIMG256(Xi,Yi:Integer;Var IM:Image);
Var
 DimX,DimY,NCod:Word;
 X,Y,J:Integer;
 W:Word;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 MoveXMS;
 NCod:=Header[14]+(Header[13] Shl 8);
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=NCod;
 MoveXMS;
 X:=0;
 Y:=0;
 J:=0;
 W:=16+NCod;
 While Y<DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     J:=J+2;
    End Else
    Begin
     If (Xi+X+CodeLine[J])>0 Then
      Begin
       XMSData.OffSource:=W;
       FromXMS(IM,VideoLine[0]);
       XMSData.Transfer:=CodeLine[J];
       MoveXMS;
       PutVideoLineX(X+Xi,Y+Yi,CodeLine[J]);
      End;
     X:=X+CodeLine[J];
     W:=W+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=DimX Then
    Begin
     X:=0;
     Asm Inc Y End;
    End;
  End;
End;
{
Procedure BufIMG256(Xi,Yi:Integer;Var IM:Image);
Var
 DimX,DimY,NCod:Word;
 X,Y,J:Integer;
 W:Word;

 I:Integer;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 MoveXMS;
 NCod:=Header[14]+(Header[13] Shl 8);
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=NCod;
 MoveXMS;
 X:=0;
 Y:=0;
 J:=0;
 W:=16+NCod;
 While Y<DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     J:=J+2;
    End Else
    Begin
     If (Xi+X+CodeLine[J])>0 Then
      Begin
       XMSData.OffSource:=W;
       For I:=0 To 2000 Do VideoLine[I]:=0;
       FromXMS(IM,VideoLine[0]);
       XMSData.Transfer:=CodeLine[J];
       MoveXMS;
       BufVideoLineX(X+Xi,Y+Yi,CodeLine[J]);
      End;
     X:=X+CodeLine[J];
     W:=W+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=DimX Then
    Asm
     Mov X,0
     Inc Y
    End;
  End;
End;
}
Procedure BufIMG256(Xi,Yi:Integer;Var IM:Image);
Var
 DimX,DimY:Word;
 X,Y,J:Integer;
 W:Word;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 Asm
  Lea SI,XMSData
  Mov AH,0Bh
  Call [XMS_Point]
 End;
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=Header[14]+(Header[13] Shl 8);
 Asm
  Lea SI,XMSData
  Mov AH,0Bh
  Call [XMS_Point]
  Mov X,0
  Mov Y,0
  Mov J,0
  Mov AX,16
  Add AX,Word PTR XMSData.Transfer
  Mov W,AX
 End;
 While Y<DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     J:=J+2;
    End Else
    Begin
     If (Xi+X+CodeLine[J])>0 Then
      Begin
       XMSData.OffSource:=W;
       FromXMS(IM,VideoLine[0]);
       XMSData.Transfer:=CodeLine[J];
       Asm
        Lea SI,XMSData
        Mov AH,0Bh
        Call [XMS_Point]
       End;
       BufVideoLineX(X+Xi,Y+Yi,CodeLine[J]);
      End;
     X:=X+CodeLine[J];
     W:=W+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=DimX Then
    Asm
     Mov X,0
     Inc Y
    End;
  End;
End;

Procedure SfnIMG256(Xi,Yi:Integer;Var IM:Image);
Var
 DimX,DimY:Word;
 X,Y,J:Integer;
 W:Word;
Begin
 XMSData.OffSource:=0;
 FromXMS(IM,Header[0]);
 XMSData.Transfer:=16;
 Asm
  Lea SI,XMSData
  Mov AH,0Bh
  Call [XMS_Point]
 End;
 DimX:=Header[10]+(Header[9] Shl 8);
 DimY:=Header[12]+(Header[11] Shl 8);
 XMSData.OffSource:=16;
 FromXMS(IM,CodeLine[0]);
 XMSData.Transfer:=Header[14]+(Header[13] Shl 8);
 Asm
  Lea SI,XMSData
  Mov AH,0Bh
  Call [XMS_Point]
  Mov X,0
  Mov Y,0
  Mov J,0
  Mov AX,16
  Add AX,Word PTR XMSData.Transfer
  Mov W,AX
 End;
 While Y<DimY Do
  Begin
   If CodeLine[J]=255 Then
    Begin
     X:=X+CodeLine[J+1];
     J:=J+2;
    End Else
    Begin
     If (Xi+X+CodeLine[J])>0 Then
      Begin
       XMSData.OffSource:=W;
       FromXMS(IM,VideoLine[0]);
       XMSData.Transfer:=CodeLine[J];
       Asm
        Lea SI,XMSData
        Mov AH,0Bh
        Call [XMS_Point]
       End;
       SfnVideoLineX(X+Xi,Y+Yi,CodeLine[J]);
      End;
     X:=X+CodeLine[J];
     W:=W+CodeLine[J];
     Asm Inc J End;
    End;
   If X>=DimX Then
    Asm
     Mov X,0
     Inc Y
    End;
  End;
End;



Procedure GetImage256(Xi,Yi,Xf,Yf:Integer;Var IM:Image);
Var F:File;
Begin
 SaveImage256('Virtual.TMP',Xi,Yi,Xf,Yf);
 LoadImage256('Virtual.TMP',IM);
 AssiGn(F,'Virtual.TMP');
 Erase(F);
End;

Procedure DeleteImage(Var IM:Image);
Begin
 FreeXMS(IM);
End;




Procedure SaveImage256(Nome:String;Xi,Yi,Xf,Yf:Integer);
Var Size,App:LongInt;
    I,J:Integer;
    SizeW:Word;
    K,Z:Integer;
    C,N:Byte;
    Icod,Icol:Word;
    F:File;
    W:Word;
    Header:Array[0..15] Of Byte;
    Cod:Array[0..8128] Of Byte;
    Col:Array[0..4095] Of Byte;
Begin
 Header[0]:=Ord('C');
 Header[1]:=Ord('G');
 Header[2]:=Ord('F');
 Header[3]:=Ord('v');
 Header[4]:=Ord('1');
 Header[5]:=Ord('.');
 Header[6]:=Ord('0');
 Header[7]:=Ord('0');
 Header[8]:=27;
 Header[9]:=(Xf-Xi+1) Div 256;
 Header[10]:=(Xf-Xi+1) Mod 256;
 Header[11]:=(Yf-Yi+1) Div 256;
 Header[12]:=(Yf-Yi+1) Mod 256;
 Size:=0;
 Icod:=0;
 For J:=Yi To Yf Do
  Begin
   For I:=Xi To Xf Do
    Begin
     VideoLine[I-Xi]:=SfnGetPixel256(I,J);
    End;
   Icol:=0;
   K:=0;
   While K<=Abs(Xf-Xi) Do
    Begin
     C:=0;
     While ((VideoLine[K]<>0)And(C<254))And(K<=Abs(Xf-Xi)) Do
      Begin
       C:=C+1;
       K:=K+1;
      End;
     If C>0 Then
      Begin
       Cod[ICod]:=C;
       ICod:=ICod+1;
       ICol:=ICol+C;
      End;
     N:=0;
     While ((VideoLine[K]=0)And(N<255))And(K<=Abs(Xf-Xi)) Do
      Begin
       N:=N+1;
       K:=K+1;
      End;
     If N>0 Then
      Begin
       Cod[ICod]:=255;
       ICod:=ICod+1;
       Cod[ICod]:=N;
       ICod:=ICod+1;
      End;
    End;
    App:=ICol;
    Size:=Size+App;
  End;

 App:=ICod;
 Size:=Size+App;
 Size:=Size Div 1024;
 If ((Size Mod 1024)<>0)Or(Size=0) Then Size:=Size+1;
 Header[13]:=ICod Div 256;
 Header[14]:=ICod Mod 256;
 Header[15]:=27;
 SizeW:=Size;

 Assign(F,Nome);
 ReWrite(F,1);
 BlockWrite(F,Header[0],16,W);
 BlockWrite(F,Cod[0],ICod,W);
 Icod:=0;
 For J:=Yi To Yf Do
  Begin
   For I:=Xi To Xf Do
    Begin
     VideoLine[I-Xi]:=SfnGetPixel256(I,J);
    End;
   Icol:=0;
   K:=0;
   While K<=Abs(Xf-Xi) Do
    Begin
     C:=0;
     While ((VideoLine[K]<>0)And(C<254))And(K<=Abs(Xf-Xi)) Do
      Begin
       C:=C+1;
       K:=K+1;
      End;
     If C>0 Then
      Begin
       Cod[ICod]:=C;
       For Z:=0 To C-1 Do Col[ICol+Z]:=VideoLine[K-C+Z];
       ICod:=ICod+1;
       ICol:=ICol+C;
      End;
     N:=0;
     While ((VideoLine[K]=0)And(N<>255))And(K<=Abs(Xf-Xi)) Do
      Begin
       N:=N+1;
       K:=K+1;
      End;
     If N>0 Then
      Begin
       Cod[ICod]:=255;
       ICod:=ICod+1;
       Cod[ICod]:=N;
       ICod:=ICod+1;
      End;
    End;
   BlockWrite(F,Col[0],ICol,W);
  End;

 Close(F);
End;

Procedure LoadImage256(Nome:String;Var IM:Image);
Var
 F:File;
 R,S:Word;
 KByte,Size:LongInt;
 Buf:Array [0..2047] Of Byte;
Begin
 Assign(F,Nome);
 Reset(F,1);
 KByte:=FileSize(F);
 Size:=KByte;
 KByte:=KByte Div 1024;
 If ((KByte Mod 1024)<>0)Or(KByte=0) Then KByte:=KByte+1;

 GetXMS(IM,KByte);
 XMSData.OffDest:=0;
 ToXMS(Buf[0],IM);
 While Not Eof(F) Do
  Begin
   If Size>2048 Then S:=2048 Else S:=Size;
   BlockRead(F,Buf[0],2048,R);
   Size:=Size-2048;
   XMSData.Transfer:=S;
   MoveXMS;
   XMSData.OffDest:=XMSData.OffDest+S;
  End;
 Close(F);
End;

Procedure LoadBMP(Name:String;Xi,Yi:Integer);
Var
 F:File;
 Head:Array[1..1078] Of Byte;
 DimX,DimY,Pal,W,I:Integer;
 X,Y,Xf,Yf:Integer;
 Col:Byte;
Begin
 Assign(F,Name);
 Reset(F,1);
 BlockRead(F,Head,1078,W);
 DimX:=(Head[20]*256)+Head[19];
 DimY:=(Head[24]*256)+Head[23];
 Pal:=54;
 For I:=0 To 255 Do
  Begin
   Col16M[I].B:=Head[Pal+1];
   Col16M[I].G:=Head[Pal+2];
   Col16M[I].R:=Head[Pal+3];
   RGB[I].B:=Head[Pal+1] Shr 2;
   RGB[I].G:=Head[Pal+2] Shr 2;
   RGB[I].R:=Head[Pal+3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
   Pal:=Pal+4;
  End;
 Xf:=Xi + DimX-1;
 Yf:=Yi + DimY-1;
 For Y:=Yf DownTo Yi Do
  Begin
   BlockRead(F,VideoLine,DimX,W);
   I:=0;
   For X:=Xi To Xf Do
    Begin
     Col:=VideoLine[I];
     PutPixel(X,Y,Col);
     I:=I+1;
    End;
  End;
 Close(F);
End;

Procedure PutBMP(Name:String;Xi,Yi:Integer);
Var
 F:File;
 Head:Array[1..1078] Of Byte;
 DimX,DimY,Pal,W,I:Integer;
 X,Y,Xf,Yf:Integer;
 Col:Byte;
Begin
 Assign(F,Name);
 Reset(F,1);
 BlockRead(F,Head,1078,W);
 DimX:=(Head[20]*256)+Head[19];
 DimY:=(Head[24]*256)+Head[23];
 Pal:=54;
 For I:=0 To 255 Do
  Begin
   Col16M[I].B:=Head[Pal+1];
   Col16M[I].G:=Head[Pal+2];
   Col16M[I].R:=Head[Pal+3];
   RGB[I].B:=Head[Pal+1] Shr 2;
   RGB[I].G:=Head[Pal+2] Shr 2;
   RGB[I].R:=Head[Pal+3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
   Pal:=Pal+4;
  End;
 Xf:=Xi + DimX-1;
 Yf:=Yi + DimY-1;
 For Y:=Yf DownTo Yi Do
  Begin
   BlockRead(F,VideoLine,DimX,W);
   PutVideoLineX(Xi,Y,Xf-Xi);
  End;
 Close(F);
End;

Procedure BufBMP(Name:String;Xi,Yi:Integer);
Var
 F:File;
 Head:Array[1..1078] Of Byte;
 DimX,DimY,Pal,W,I:Integer;
 X,Y,Xf,Yf:Integer;
 Col:Byte;
Begin
 Assign(F,Name);
 Reset(F,1);
 BlockRead(F,Head,1078,W);
 DimX:=(Head[20]*256)+Head[19];
 DimY:=(Head[24]*256)+Head[23];
 Pal:=54;
 For I:=0 To 255 Do
  Begin
   Col16M[I].B:=Head[Pal+1];
   Col16M[I].G:=Head[Pal+2];
   Col16M[I].R:=Head[Pal+3];
   RGB[I].B:=Head[Pal+1] Shr 2;
   RGB[I].G:=Head[Pal+2] Shr 2;
   RGB[I].R:=Head[Pal+3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
   Pal:=Pal+4;
  End;
 Xf:=Xi + DimX-1;
 Yf:=Yi + DimY-1;
 For Y:=Yf DownTo Yi Do
  Begin
   BlockRead(F,VideoLine,DimX,W);
   BufVideoLineX(Xi,Y,Xf-Xi);
  End;
 Close(F);
End;

Procedure SfnBMP(Name:String;Xi,Yi:Integer);
Var
 F:File;
 Head:Array[1..1078] Of Byte;
 DimX,DimY,Pal,W,I:Integer;
 X,Y,Xf,Yf:Integer;
 Col:Byte;
Begin
 Assign(F,Name);
 Reset(F,1);
 BlockRead(F,Head,1078,W);
 DimX:=(Head[20]*256)+Head[19];
 DimY:=(Head[24]*256)+Head[23];
 Pal:=54;
 For I:=0 To 255 Do
  Begin
   Col16M[I].B:=Head[Pal+1];
   Col16M[I].G:=Head[Pal+2];
   Col16M[I].R:=Head[Pal+3];
   RGB[I].B:=Head[Pal+1] Shr 2;
   RGB[I].G:=Head[Pal+2] Shr 2;
   RGB[I].R:=Head[Pal+3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
   Pal:=Pal+4;
  End;
 Xf:=Xi + DimX-1;
 Yf:=Yi + DimY-1;
 For Y:=Yf DownTo Yi Do
  Begin
   BlockRead(F,VideoLine,DimX,W);
   SfnVideoLineX(Xi,Y,Xf-Xi);
  End;
 Close(F);
End;


Procedure LoadPcx(Name:String;X,Y:Integer);
Var
 F:file;
 Head:Array[1..128] Of Byte;
 Col:Array[1..3] Of Byte;
 R:Word;
 FSize:LongInt;
 Cod,Color:Byte;
 I,I2,J,Ic:Word;
 abX,abY,aaX,aaY,DimX,DimY:Word;
 Bytes:Word;
begin
 Bytes:=65000;
 Assign(F,Name);
 Reset(F,1);
 FSize:=FileSize(F);
 BlockRead(F,Head,128,R);
 aaX:=(Head[6] Shl 8)+Head[5];
 aaY:=(Head[8] Shl 8)+Head[7];
 abX:=(Head[10] Shl 8)+Head[9];
 abY:=(Head[12] Shl 8)+Head[11];
 DimX:=(abX-aaX);
 DimY:=(abY-aaY)-1;
 Seek(F,FSize-768);
 For I:=0 To 255 Do
  Begin
   BlockRead(F,Col,3,R);
   RGB[I].R:=Col[1] Shr 2;
   RGB[I].G:=Col[2] Shr 2;
   RGB[I].B:=Col[3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
  End;
 Seek(F,128);
 BlockRead(F,VideoBuffer^,Bytes,R);
 Asm Mov I,1 End;
 For J:=Y To Y+DimY Do
  Begin
   Asm Mov Ic,0 End;
   While Ic<=DimX Do
    Begin
     Cod:=VideoBuffer^[I];
     If I=Bytes Then
      Begin
       BlockRead(F,VideoBuffer^,Bytes,R);
       I:=0;
      End;
     Asm Inc I End;
     If (Cod And 192)=192 Then
      Begin
       Cod:=Cod And 63;
       Color:=VideoBuffer^[I];
       If I=Bytes Then
        Begin
         BlockRead(F,VideoBuffer^,Bytes,R);
         I:=0;
        End;
       Asm Inc I End;
       For I2:=1 To Cod Do PutPixel(X+Ic+I2,J,Color);
       Ic:=Ic+Cod;
      End Else
      Begin
       Asm Inc Ic End;
       PutPixel(X+Ic,J,Cod);
      End;
    End;
  End;
 Close(F);
End;


Procedure PutPCX(Name:String;X,Y:Integer);
Var
 F:file;
 Head:Array[1..128] Of Byte;
 Col:Array[1..3] Of Byte;
 R:Word;
 FSize:LongInt;
 Cod,Color:Byte;
 I,I2,J,Ic:Word;
 abX,abY,aaX,aaY,DimX,DimY:Word;
 Bytes:Word;
Begin
 Bytes:=65000;
 Assign(F,Name);
 Reset(F,1);
 FSize:=FileSize(F);
 BlockRead(F,Head,128,R);
 aaX:=(Head[6] Shl 8)+Head[5];
 aaY:=(Head[8] Shl 8)+Head[7];
 abX:=(Head[10] Shl 8)+Head[9];
 abY:=(Head[12] Shl 8)+Head[11];
 DimX:=(abX-aaX);
 DimY:=(abY-aaY)-1;
 Seek(F,FSize-768);
 For I:=0 To 255 Do
  Begin
   BlockRead(F,Col,3,R);
   RGB[I].R:=Col[1] Shr 2;
   RGB[I].G:=Col[2] Shr 2;
   RGB[I].B:=Col[3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
  End;
 Seek(F,128);
 BlockRead(F,VideoBuffer^,Bytes,R);
 Asm Mov I,1 End;
 For J:=0 To DimY Do
  Begin
   Asm Mov Ic,0 End;
   While Ic<=DimX Do
    Begin
     Cod:=VideoBuffer^[I];
     If I=Bytes Then
      Begin
       BlockRead(F,VideoBuffer^,Bytes,R);
       I:=0;
      End;
     Asm Inc I End;
     If (Cod And 192)=192 Then
      Begin
       Cod:=Cod And 63;
       Color:=VideoBuffer^[I];
       If I=Bytes Then
        Begin
         BlockRead(F,VideoBuffer^,Bytes,R);
         I:=0;
        End;
       Asm Inc I End;
       For I2:=1 To Cod Do VideoLine[Ic+I2]:=Color;
       Ic:=Ic+Cod;
      End Else
      Begin
       Asm Inc Ic End;
       VideoLine[Ic]:=Cod;
      End;
    End;
   PutVideoLineX(X,J+Y,DimX);
  End;
 Close(F);
End;

Procedure BufPCX(Name:String;X,Y:Integer);
Var
 F:file;
 Head:Array[1..128] Of Byte;
 Col:Array[1..3] Of Byte;
 R:Word;
 FSize:LongInt;
 Cod,Color:Byte;
 I,I2,J,Ic:Word;
 abX,abY,aaX,aaY,DimX,DimY:Word;
 Bytes:Word;
Begin
 Bytes:=65000;
 Assign(F,Name);
 Reset(F,1);
 FSize:=FileSize(F);
 BlockRead(F,Head,128,R);
 aaX:=(Head[6] Shl 8)+Head[5];
 aaY:=(Head[8] Shl 8)+Head[7];
 abX:=(Head[10] Shl 8)+Head[9];
 abY:=(Head[12] Shl 8)+Head[11];
 DimX:=(abX-aaX);
 DimY:=(abY-aaY)-1;
 Seek(F,FSize-768);
 For I:=0 To 255 Do
  Begin
   BlockRead(F,Col,3,R);
   RGB[I].R:=Col[1] Shr 2;
   RGB[I].G:=Col[2] Shr 2;
   RGB[I].B:=Col[3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
  End;
 Seek(F,128);
 BlockRead(F,VideoBuffer^,Bytes,R);
 Asm Mov I,1 End;
 For J:=0 To DimY Do
  Begin
   Asm Mov Ic,0 End;
   While Ic<=DimX Do
    Begin
     Cod:=VideoBuffer^[I];
     If I=Bytes Then
      Begin
       BlockRead(F,VideoBuffer^,Bytes,R);
       I:=0;
      End;
     Asm Inc I End;
     If (Cod And 192)=192 Then
      Begin
       Cod:=Cod And 63;
       Color:=VideoBuffer^[I];
       If I=Bytes Then
        Begin
         BlockRead(F,VideoBuffer^,Bytes,R);
         I:=0;
        End;
       Asm Inc I End;
       For I2:=1 To Cod Do VideoLine[Ic+I2]:=Color;
       Ic:=Ic+Cod;
      End Else
      Begin
       Asm Inc Ic End;
       VideoLine[Ic]:=Cod;
      End;
    End;
   BufVideoLineX(X,J+Y,DimX);
  End;
 Close(F);
End;

Procedure SfnPCX(Name:String;X,Y:Integer);
Var
 F:file;
 Head:Array[1..128] Of Byte;
 Col:Array[1..3] Of Byte;
 R:Word;
 FSize:LongInt;
 Cod,Color:Byte;
 I,I2,J,Ic:Word;
 abX,abY,aaX,aaY,DimX,DimY:Word;
 Bytes:Word;
Begin
 Bytes:=65000;
 Assign(F,Name);
 Reset(F,1);
 FSize:=FileSize(F);
 BlockRead(F,Head,128,R);
 aaX:=(Head[6] Shl 8)+Head[5];
 aaY:=(Head[8] Shl 8)+Head[7];
 abX:=(Head[10] Shl 8)+Head[9];
 abY:=(Head[12] Shl 8)+Head[11];
 DimX:=(abX-aaX);
 DimY:=(abY-aaY)-1;
 Seek(F,FSize-768);
 For I:=0 To 255 Do
  Begin
   BlockRead(F,Col,3,R);
   RGB[I].R:=Col[1] Shr 2;
   RGB[I].G:=Col[2] Shr 2;
   RGB[I].B:=Col[3] Shr 2;
   SetRGB(I,RGB[I].R,RGB[I].G,RGB[I].B);
  End;
 Seek(F,128);
 BlockRead(F,VideoBuffer^,Bytes,R);
 Asm Mov I,1 End;
 For J:=0 To DimY Do
  Begin
   Asm Mov Ic,0 End;
   While Ic<=DimX Do
    Begin
     Cod:=VideoBuffer^[I];
     If I=Bytes Then
      Begin
       BlockRead(F,VideoBuffer^,Bytes,R);
       I:=0;
      End;
     Asm Inc I End;
     If (Cod And 192)=192 Then
      Begin
       Cod:=Cod And 63;
       Color:=VideoBuffer^[I];
       If I=Bytes Then
        Begin
         BlockRead(F,VideoBuffer^,Bytes,R);
         I:=0;
        End;
       Asm Inc I End;
       For I2:=1 To Cod Do VideoLine[Ic+I2]:=Color;
       Ic:=Ic+Cod;
      End Else
      Begin
       Asm Inc Ic End;
       VideoLine[Ic]:=Cod;
      End;
    End;
   SfnVideoLineX(X,J+Y,DimX);
  End;
 Close(F);
End;




Procedure FliOpen(Name:String;X,Y:Integer;Fli:Byte);
Begin
 FliN:=Fli;
 Assign(FliVideo[FliN].FliFile,Name);
 Reset(FliVideo[FliN].FliFile,1);
 BlockRead(FliVideo[FliN].FliFile,FliVideo[FliN].FliHead,128,FliRead);
 FliVideo[FliN].FliFrames:=(FliVideo[FliN].FliHead[8] Shl 8)+FliVideo[FliN].FliHead[7];
 FliVideo[FliN].FliX:=(FliVideo[FliN].FliHead[10] Shl 8)+FliVideo[FliN].FliHead[9];
 FliVideo[FliN].FliY:=(FliVideo[FliN].FliHead[12] Shl 8)+FliVideo[FliN].FliHead[11];
 FliVideo[FliN].FliDelay:=(FliVideo[FliN].FliHead[18] Shl 8)+FliVideo[FliN].FliHead[17];
 FliVideo[FliN].FliPlay:=0;
 GetMem(FliBuf,65535);
 FliVideo[FliN].FliStartX:=X;
 FliVideo[FliN].FliStartY:=Y;
 FliVideo[FliN].FliLoop:=False;
 FliVideo[FliN].FliStart:=FilePos(FliVideo[FliN].FliFile);
End;

Procedure FliClose(FLiN:Byte);
Begin
 Close(FliVideo[FliN].FliFile);
End;

Procedure FliLoadFrame;
Var FliBlock:Word;
Begin
 BlockRead(FliVideo[FliN].FliFile,FliBlock,2,FliRead);
 BlockRead(FliVideo[FliN].FliFile,FliBuf^,FliBlock-2,FliRead);
End;

Procedure FliView(N:Byte);
Var I:Word;
    FliColorCode,FliImageCode:Byte;
    NByte:Byte;
    Col,ICol,NCol,Code:Byte;
    Nul,X,Y,Yi,Yf:Integer;
Begin
 FliN:=N;

 For I:=0 To 255 Do
  Begin
   SetRGB(I,FLIVideo[FliN].FliRGB[I].R,FLIVideo[FliN].FliRGB[I].G,FLIVideo[FliN].FliRGB[I].B);
  End;


 If FliVideo[FliN].FliPlay<FliVideo[FliN].FliFrames Then
  Begin
   FliLoadFrame;
   FliColorCode:=FliBuf^[5];
   Asm Mov I,15d End;

   If (FliColorCode=1)And(FliBuf^[19]=11) Then
    Begin
     Asm Add I,6 End;
     NByte:=FliBuf^[I];
     Asm
      Add I,2
      Mov Col,0
     End;
     For ICol:=1 To NByte Do
      Begin
       Col:=Col+FliBuf^[I];
       Asm Inc I End;
       NCol:=FliBuf^[I];
       Asm Inc I End;
       While NCol>0 Do
        Begin
         Asm Dec NCol End;
         FLIVideo[FliN].FliRGB[Col].R:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[Col].G:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[Col].B:=FliBuf^[I];
         Asm Inc I End;
         SetRGB(Col,FLIVideo[FliN].FliRGB[Col].R
          ,FLIVideo[FliN].FliRGB[Col].G,FLIVideo[FliN].FliRGB[Col].B);
         Asm Inc Col End;
        End;
      End;
      Asm
       Inc I
       Dec FliColorCode
      End;
    End Else


   If FliColorCode=2 Then
    Begin
     Asm Add I,6 End;
     If (FliBuf^[I+1]=0)And(FliBuf^[I+2]=0) Then
      Begin
       Asm Add I,4 End;
       For ICol:=0 To 255 Do
        Begin
         FLIVideo[FliN].FliRGB[ICol].R:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[ICol].G:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[ICol].B:=FliBuf^[I];
         Asm Inc I End;
         SetRGB(ICol,FLIVideo[FliN].FliRGB[ICol].R
          ,FLIVideo[FliN].FliRGB[ICol].G,FLIVideo[FliN].FliRGB[ICol].B);
        End;
      End Else
      Begin
       NByte:=FliBuf^[I];
       Asm
        Add I,2
        Mov Col,0
       End;
       For ICol:=1 To NByte Do
        Begin
         Col:=Col+FliBuf^[I];
         Asm Inc I End;
         NCol:=FliBuf^[I];
         Asm Inc I End;
         While NCol>0 Do
          Begin
           Asm Dec NCol End;
           FLIVideo[FliN].FliRGB[Col].R:=FliBuf^[I];
           Asm Inc I End;
           FLIVideo[FliN].FliRGB[Col].G:=FliBuf^[I];
           Asm Inc I End;
           FLIVideo[FliN].FliRGB[Col].B:=FliBuf^[I];
           Asm Inc I End;
           SetRGB(Col,FLIVideo[FliN].FliRGB[Col].R
            ,FLIVideo[FliN].FliRGB[Col].G,FLIVideo[FliN].FliRGB[Col].B);
           Asm Inc Col End;
          End;
        End;
        Asm Inc I End;
      End;
    End;


   If FliColorCode<>0 Then
    Begin
     Asm Add I,4 End;
     FliImageCode:=FliBuf^[I];
     Asm Add I,2 End;

     If FliImageCode=16 Then
      Begin
       Asm
        Mov AX,I
        Dec AX
        Mov X,AX
       End;
       For Y:=0 To FliVideo[FliN].FliY-1 Do
        Begin
         FastMove32Bit(@FliBuf^[X],@VideoLine[0],FliVideo[FliN].FliX);
         X:=X+FliVideo[FliN].FliX;
         PutVideoLineX(FliVideo[FliN].FliStartX,FliVideo[FliN].FliStartY+Y,FliVideo[FliN].FliX);
        End;
       Asm Add I,64000 End;
      End Else


     If FliImageCode=15 Then
      Begin
       For ICol:=1 To FliVideo[FliN].FliY Do
        Begin
         NByte:=FliBuf^[I];
         Asm
          Mov X,0
          Inc I
         End;
         While NByte>0 Do
          Begin
           Code:=FliBuf^[I];
           Asm
            Inc I
            Dec NByte
           End;
           If Code<128 Then
            Begin
             FastFill32Bit(@VideoLine[X],Code,FliBuf^[I]);
             Asm
              Inc I
              Mov AL,Code
              Xor AH,AH
              Add X,AX
             End;
            End Else
            Begin
             FastMove32Bit(@FliBuf^[I],@VideoLine[X],256-Code);
             Asm
              Xor AX,AX
              Inc AH
              Mov BL,Code
              Xor BH,BH
              Sub AX,BX
              Add I,AX
              Add X,Ax
             End;
            End;
          End;
         PutVideoLineX(FliVideo[FliN].FliStartX,FliVideo[FliN].FliStartY+ICol-1,FliVideo[FliN].FliX);
        End;
      End Else


     If FliImageCode=12 Then
      Begin
       Yi:=FliBuf^[I];
       Asm Add I,2 End;
       Yf:=FliBuf^[I]+Yi;
       Asm
        Dec Yf
        Add I,2
       End;
       For Y:=Yi To Yf Do
        Begin
         NByte:=FliBuf^[I];
         Asm
          Inc I
          Mov Nul,0
         End;
         While NByte>0 Do
          Begin
           Nul:=Nul+FliBuf^[I];
           Asm Inc I End;
           Code:=FliBuf^[I];
           Asm
            Inc I
            Dec NByte
           End;
           If Code>128 Then
            Begin
             FastFill32Bit(@VideoLine[0],256-Code,FliBuf^[I]);
             PutVideoLineX(FliVideo[FliN].FliStartX+Nul,FliVideo[FliN].FliStartY+Y,256-Code);
             Asm
              Inc I
              Xor AX,AX
              Inc AH
              Xor BH,BH
              Mov BL,Code
              Sub AX,BX
              Add Nul,AX
             End;
            End Else
            Begin
             FastMove32Bit(@FliBuf^[I],@VideoLine[0],Code);
             PutVideoLineX(FliVideo[FliN].FliStartX+Nul,FliVideo[FliN].FliStartY+Y,Code);
             Asm
              Xor AH,AH
              Mov AL,Code
              Add I,AX
              Add Nul,AX
             End;
            End
          End;
        End;
      End;

    End;

   Inc(FliVideo[FliN].FliPlay)
  End Else
  Begin
   Seek(FliVideo[FliN].FliFile,FliVideo[FliN].FliStart);
   FliVideo[FliN].FliPlay:=0;
  End;
 Delay(FLIVideo[FliN].FliDelay Shl 2);
End;


Procedure SfnFliView(N:Byte);
Var I:Word;
    FliColorCode,FliImageCode:Byte;
    NByte:Byte;
    Col,ICol,NCol,Code:Byte;
    Nul,X,Y,Yi,Yf:Integer;
Begin
 FliN:=N;

 For I:=0 To 255 Do
  Begin
   SetRGB(I,FLIVideo[FliN].FliRGB[I].R,FLIVideo[FliN].FliRGB[I].G,FLIVideo[FliN].FliRGB[I].B);
  End;


 If FliVideo[FliN].FliPlay<FliVideo[FliN].FliFrames Then
  Begin
   FliLoadFrame;
   FliColorCode:=FliBuf^[5];
   Asm Mov I,15d End;

   If (FliColorCode=1)And(FliBuf^[19]=11) Then
    Begin
     Asm Add I,6 End;
     NByte:=FliBuf^[I];
     Asm
      Add I,2
      Mov Col,0
     End;
     For ICol:=1 To NByte Do
      Begin
       Col:=Col+FliBuf^[I];
       Asm Inc I End;
       NCol:=FliBuf^[I];
       Asm Inc I End;
       While NCol>0 Do
        Begin
         Asm Dec NCol End;
         FLIVideo[FliN].FliRGB[Col].R:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[Col].G:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[Col].B:=FliBuf^[I];
         Asm Inc I End;
         SetRGB(Col,FLIVideo[FliN].FliRGB[Col].R
          ,FLIVideo[FliN].FliRGB[Col].G,FLIVideo[FliN].FliRGB[Col].B);
         Asm Inc Col End;
        End;
      End;
      Asm
       Inc I
       Dec FliColorCode
      End;
    End Else


   If FliColorCode=2 Then
    Begin
     Asm Add I,6 End;
     If (FliBuf^[I+1]=0)And(FliBuf^[I+2]=0) Then
      Begin
       Asm Add I,4 End;
       For ICol:=0 To 255 Do
        Begin
         FLIVideo[FliN].FliRGB[ICol].R:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[ICol].G:=FliBuf^[I];
         Asm Inc I End;
         FLIVideo[FliN].FliRGB[ICol].B:=FliBuf^[I];
         Asm Inc I End;
         SetRGB(ICol,FLIVideo[FliN].FliRGB[ICol].R
          ,FLIVideo[FliN].FliRGB[ICol].G,FLIVideo[FliN].FliRGB[ICol].B);
        End;
      End Else
      Begin
       NByte:=FliBuf^[I];
       Asm
        Add I,2
        Mov Col,0
       End;
       For ICol:=1 To NByte Do
        Begin
         Col:=Col+FliBuf^[I];
         Asm Inc I End;
         NCol:=FliBuf^[I];
         Asm Inc I End;
         While NCol>0 Do
          Begin
           Asm Dec NCol End;
           FLIVideo[FliN].FliRGB[Col].R:=FliBuf^[I];
           Asm Inc I End;
           FLIVideo[FliN].FliRGB[Col].G:=FliBuf^[I];
           Asm Inc I End;
           FLIVideo[FliN].FliRGB[Col].B:=FliBuf^[I];
           Asm Inc I End;
           SetRGB(Col,FLIVideo[FliN].FliRGB[Col].R
            ,FLIVideo[FliN].FliRGB[Col].G,FLIVideo[FliN].FliRGB[Col].B);
           Asm Inc Col End;
          End;
        End;
        Asm Inc I End;
      End;
    End;


   If FliColorCode<>0 Then
    Begin
     Asm Add I,4 End;
     FliImageCode:=FliBuf^[I];
     Asm Add I,2 End;

     If FliImageCode=16 Then
      Begin
       Asm
        Mov AX,I
        Dec AX
        Mov X,AX
       End;
       For Y:=0 To FliVideo[FliN].FliY-1 Do
        Begin
         FastMove32Bit(@FliBuf^[X],@VideoLine[0],FliVideo[FliN].FliX);
         X:=X+FliVideo[FliN].FliX;
         SfnVideoLineX(FliVideo[FliN].FliStartX,FliVideo[FliN].FliStartY+Y,FliVideo[FliN].FliX);
        End;
       Asm Add I,64000 End;
      End Else


     If FliImageCode=15 Then
      Begin
       For ICol:=1 To FliVideo[FliN].FliY Do
        Begin
         NByte:=FliBuf^[I];
         Asm
          Mov X,0
          Inc I
         End;
         While NByte>0 Do
          Begin
           Code:=FliBuf^[I];
           Asm
            Inc I
            Dec NByte
           End;
           If Code<128 Then
            Begin
             FastFill32Bit(@VideoLine[X],Code,FliBuf^[I]);
             Asm
              Inc I
              Mov AL,Code
              Xor AH,AH
              Add X,AX
             End;
            End Else
            Begin
             FastMove32Bit(@FliBuf^[I],@VideoLine[X],256-Code);
             Asm
              Xor AX,AX
              Inc AH
              Mov BL,Code
              Xor BH,BH
              Sub AX,BX
              Add I,AX
              Add X,Ax
             End;
            End;
          End;
         SfnVideoLineX(FliVideo[FliN].FliStartX,FliVideo[FliN].FliStartY+ICol-1,FliVideo[FliN].FliX);
        End;
      End Else


     If FliImageCode=12 Then
      Begin
       Yi:=FliBuf^[I];
       Asm Add I,2 End;
       Yf:=FliBuf^[I]+Yi;
       Asm
        Dec Yf
        Add I,2
       End;
       For Y:=Yi To Yf Do
        Begin
         NByte:=FliBuf^[I];
         Asm
          Inc I
          Mov Nul,0
         End;
         While NByte>0 Do
          Begin
           Nul:=Nul+FliBuf^[I];
           Asm Inc I End;
           Code:=FliBuf^[I];
           Asm
            Inc I
            Dec NByte
           End;
           If Code>128 Then
            Begin
             FastFill32Bit(@VideoLine[0],256-Code,FliBuf^[I]);
             SfnVideoLineX(FliVideo[FliN].FliStartX+Nul,FliVideo[FliN].FliStartY+Y,256-Code);
             Asm
              Inc I
              Xor AX,AX
              Inc AH
              Xor BH,BH
              Mov BL,Code
              Sub AX,BX
              Add Nul,AX
             End;
            End Else
            Begin
             FastMove32Bit(@FliBuf^[I],@VideoLine[0],Code);
             SfnVideoLineX(FliVideo[FliN].FliStartX+Nul,FliVideo[FliN].FliStartY+Y,Code);
             Asm
              Xor AH,AH
              Mov AL,Code
              Add I,AX
              Add Nul,AX
             End;
            End
          End;
        End;
      End;

    End;

   Inc(FliVideo[FliN].FliPlay)
  End Else
  Begin
   Seek(FliVideo[FliN].FliFile,FliVideo[FliN].FliStart);
   FliVideo[FliN].FliPlay:=0;
  End;
 If NoFliDelay Then Delay(FLIVideo[FliN].FliDelay Shl 2);
End;


{Insieme dell funzioni per la gestione del mouse.}
{----------------------------------------------------------------------------}


Procedure SetXCor(XMin,XMax:Word);Assembler;
Asm
 mov ax,0007h
 mov cx,xmin
 mov dx,xmax
 int 33h
End;


Procedure SetYcor(ymin,ymax:word);Assembler;
Asm
 mov ax,0008h
 mov cx,ymin
 mov dx,ymax
 int 33h
End;


Procedure InitMouse;Assembler;
Asm
 Mov AX,0000h
 Int 33h
 Cmp AX,00h
  Je @Error
  Mov [Ms.Esiste],True
  Mov Word Ptr [Ms.NButtons],BX
  Ret
 @Error:
  Mov [Ms.Esiste],False
End;


Procedure MouseON;Assembler;
Asm
 mov ax,0001h
 int 33h
end;

Procedure MouseOFF;Assembler;
asm
 mov ax,0002h
 int 33h
end;

Procedure MStat;Assembler;
Asm
 Mov Ax,0003h
 int 33h
 mov ms.Button,bx
 mov ms.x,cx
 mov ms.y,dx
End;



Procedure SetVel(xcor,ycor,bs:word);Assembler;
asm
 mov ax,00A1h
 mov bx,xcor
 mov cx,ycor
 mov dx,bs
 int 33h
end;

Procedure SetMouseXY(X,Y:Word);Assembler;
Asm
 MOV	AX,0004h
 MOV	CX,x
 MOV	DX,y
 INT	33h
End;

{Insieme di funzioni per l'utilizzo delle schede sonore compatibili
 SOUNDBLASTER.}
{---------------------------------------------------------------------------}

{$F+}
Procedure NewInt;
Begin
 Asm
  Cli
  Mov DX,DSPBaseAddr
  Add DX,0Eh
  In AL,DX
 End;
 FullBuffer:=True;
 Asm
  Mov AL,$20
  Out $20,AL
  Sti
 End;
End;
{$F-}



Procedure PICReset;Assembler;
Asm
 Mov AL,$20
 Out $20,AL
End;



Procedure SetIRQ(IRQ:Byte);Assembler;
Asm
 Mov CL,IRQ
 Mov BL,1
 Sal BL,CL
 In AL,$21
 Or AL,BL
 Out $21,AL
End;

Procedure ReSetIRQ(IRQ:Byte);Assembler;
Asm
 Mov CL,IRQ
 Mov BL,1
 Sal BL,CL
 Not BL
 In AL,$21
 And AL,BL
 Out $21,AL
End;

Function DSPReset:Boolean;Assembler;
Asm
 Mov DX,DSPBaseAddr
 Add DL,06h
 Mov AL,01h
 Out DX,AL
 @Temp:
  Dec AL
  Jnz @Temp
 Out DX,AL
 Sub CX,CX
 @Temp2:
  Mov DX,DSPBaseAddr
  Add DL,0Eh
  In AL,DX
  Or AL,AL
  Jns @RePull
  Sub DX,04h
  In AL,DX
  Cmp AL,0AAh
  Je @NoError
 @RePull:
  Loop @Temp2
  Mov AL,False
 Jmp @Return
 @NoError:
  Mov AL,True
 @Return:
End;

Function DSPRead:Byte;Assembler;
Asm
 Mov DX,DSPBaseAddr
 Add DL,0Eh
 Xor CX,CX
 @RePull:
  Inc CX
  Cmp CX,00h
  Je @Error
  In AL,DX
  Or AL,AL
 Jns @RePull
 Sub DX,04h
 In AL,DX
 Mov DSPErr,False
 Jmp @Return
 @Error:
 Mov DSPErr,True
 @Return:
End;

Procedure DSPWrite(Data:Byte);Assembler;
Asm
 Mov DX,DSPBaseAddr
 Add DL,0Ch
 Xor CX,CX
 @RePull:
  Inc CX
  Cmp CX,00h
  Je @Error
  In AL,DX
  Or AL,AL
 Js @RePull
 Mov AL,Data
 Out DX,AL
 Mov DSPErr,False
 Jmp @Return
 @Error:
 Mov DSPErr,True
 @Return:
End;

Procedure DSPPlay(Data:Byte);
Begin
 DSPWrite($10);
 DSPWrite(Data);
End;

Function DSPRec:Byte;
Begin
 DSPWrite($20);
 DSPRec:=DSPRead;
End;

Procedure DSPDetectBase;
Begin
 DSPBaseAddr:=$210;
 While Not DSPReset And (DSPBaseAddr<$270) Do DSPBaseAddr:=DSPBaseAddr+$10;
 If DSPBaseAddr=$270 Then DSPBaseAddr:=0;
End;


Procedure DSPSetRate(Rate:Word);
Var Time:Word;
    Chan:Byte;
Begin
 DSPWrite($40);
 If MonoMode Then Chan:=1 Else Chan:=2;
 Time:=Hi(65536-Trunc(256000000/(Chan*Rate)));
 DSPWrite(Time);
End;




Procedure DSPDMARecord(Rate:Word;Data:Word);
Begin
 DSPSetRate(Rate);
 DSPWrite($24);
 DSPWrite(Lo(Data));
 DSPWrite(Hi(Data));
End;

Procedure DSPDMAPlay(Rate:Word;Data:Word);
Begin
 DSPSetRate(Rate);
 DSPWrite($14);
 DSPWrite(Lo(Data));
 DSPWrite(Hi(Data));
End;


Procedure DMASetLine(DM:Byte);
Begin
 Case DMA Of
  0:Begin
     DMARegPage:=$87;
     DMARegAddr:=0;
     DMARegLengTh:=1;
    End;
  1:Begin
     DMARegPage:=$83;
     DMARegAddr:=2;
     DMARegLengTh:=3;
    End;
  2:Begin
     DMARegPage:=$81;
     DMARegAddr:=4;
     DMARegLengTh:=5;
    End;
  3:Begin
     DMARegPage:=$82;
     DMARegAddr:=6;
     DMARegLengTh:=7;
    End;
 End;
End;

Procedure DMABusyAddresses;
Var
 Addr20:LongInt;
Begin
 Addr20:=Seg(DSPBuf1^);
 Addr20:=Addr20 Shl 4;
 Addr20:=Addr20+Ofs(DSPBuf1^);
 DMAPage1:=Byte(Addr20 Div 65536);
 DMAOffs1:=(Hi(Addr20)*256)+Lo(Addr20);
 Addr20:=Seg(DSPBuf2^);
 Addr20:=Addr20 Shl 4;
 Addr20:=Addr20+Ofs(DSPBuf2^);
 DMAPage2:=Byte(Addr20 Div 65536);
 DMAOffs2:=(Hi(Addr20)*256)+Lo(Addr20);
End;

Procedure DMAInit;Assembler;
Asm
{               Punto 1                       }
{     Settare la Maschera del DMA.            }
 Mov AL,4
 Add AL,[DMA]
 Out 0AH,AL
{               Punto 2                       }
{        Resettare il puntatore.              }
 Xor AL,AL
 Out 0CH,AL
{               Punto 3                       }
{Selezionare la modalit di trasferimento.    }
 Mov AL,48H
 Add AL,[DMA]
 Out 0Bh,AL
{               Punto 4                       }
{Indicare al DMA Indirizzo e Lunghezza.       }
 Mov AX,DMAOffs
 Mov DX,DMARegAddr
 Out DX,AL
 Mov AL,AH
 Out DX,AL
 Inc DL
 Mov CX,DMAData
 Mov AL,CL
 Out DX,AL
 Mov AL,CH
 Out DX,AL
{               Punto 5                       }
{  Inizializzazion della pagina.              }
 Mov DX,DMARegPage
 Mov AL,DMAPage
 Out DX,AL
{               Punto 6                       }
{ Attivazione del trasferimento.              }
 Mov AL,DMA
 Out 0AH,AL
End;

Procedure DMAReInit;Assembler;
Asm
{               Punto 1                       }
{     Settare la Maschera del DMA.            }
 Mov AL,DMA
 Add AL,4
 Out 0AH,AL
{               Punto 4                       }
{Indicare al DMA Indirizzo e Lunghezza.       }
 Mov AX,DMAOffs
 Mov DX,DMARegAddr
 Out DX,AL
 Mov AL,AH
 Out DX,AL
 Inc DL
 Mov CX,DMAData
 Mov AL,CL
 Out DX,AL
 Mov AL,CH
 Out DX,AL
{               Punto 5                       }
{  Inizializzazion della pagina.              }
 Mov DX,DMARegPage
 Mov AL,DMAPage
 Out DX,AL
{               Punto 6                       }
{ Attivazione del trasferimento.              }
 Mov AL,DMA
 Out 0AH,AL
End;

Procedure DMAInitPlay(P:Buffer;Data:Word);
Var
 DMAPage:Word;
 DMAOfs:Longint;
Begin
 DMAPage:=Word(Ofs(P^) SHR 4);
 DMAPage:=Seg(P^)+DMAPage;
 DMAPage:=Word(Hi(DMAPage) SHR 4);
 DMAOfs:=(Seg(P^) AND $0FFF) SHL 4;
 DMAOfs:=DMAOfs + Ofs(P^);
 DMAOfs:=DMAOfs mod $10000;
 Port[$0A]:=DMA+4;
 Port[$0C]:=0;
 Port[$0B] := $48+DMA;
 Port[(DMA SHL 1)]:= byte (DMAOfs AND $00FF);
 Port[(DMA SHL 1)]:= byte (DMAOfs SHR 8);
 Case DMA of
  0 : Port[$87]:=Byte(DMAPage);
  1 : Port[$83]:=Byte(DMAPage);
  2 : Port[$81]:=Byte(DMAPage);
  3 : Port[$82]:=Byte(DMAPage);
 End;
 Port[(DMA SHL 1)+1]:=Lo(Data);
 Port[(DMA SHL 1)+1]:=Hi(Data);
 Port[$0A]:=DMA;
End;

Procedure DMAInitRecord(P:Buffer;Data:Word);
Var
 DMAPage:Word;
 DMAOfs:Longint;
Begin
 DMAPage:=Word(Ofs(P^) SHR 4);
 DMAPage:=Seg(P^)+DMAPage;
 DMAPage:=Word(Hi(DMAPage) SHR 4);
 DMAOfs:=(Seg(P^) AND $0FFF) SHL 4;
 DMAOfs:=DMAOfs + Ofs(P^);
 DMAOfs:=DMAOfs mod $10000;
 Port[$0A]:=DMA+4;
 Port[$0C]:=0;
 Port[$0B] := $44+DMA;
 Port[(DMA SHL 1)]:= byte (DMAOfs AND $00FF);
 Port[(DMA SHL 1)]:= byte (DMAOfs SHR 8);
 Case DMA of
  0 : Port[$87]:=Byte(DMAPage);
  1 : Port[$83]:=Byte(DMAPage);
  2 : Port[$81]:=Byte(DMAPage);
  3 : Port[$82]:=Byte(DMAPage);
 End;
 Port[(DMA SHL 1)+1]:=Lo(Data);
 Port[(DMA SHL 1)+1]:=Hi(Data);
 Port[$0A]:=DMA;
End;


Procedure DMAStop;
Begin
 Port[$0A]:=4+DMA;
 Port[$0C]:=0;
 Port[$0A]:=0;
End;

Function DMACount:Word;Assembler;
Asm
 Mov DX,0Ch
 Mov AL,$FF
 Out DX,AL
 @Redo:
  Mov DX,DMARegLengTh
  In AL,DX
  Mov BL,AL
  In AL,DX
  Mov BH,AL
  In AL,DX
  Mov AH,AL
  In AL,DX
  XCHG AH,AL
  Sub BX,AX
  CMP BX,40H
  JG @Redo
  CMP BX,0FFC0H
  JL @Redo
End;


Function DMAEnd:Boolean;
Var Data:Byte;
Begin
 Data:=Port[$0D0];
 Asm And Data,00001111b End;
 If Data>0 Then
  Begin
   DMAEnd:=True;
   DMAControl:=0;
  End Else
  Begin
   If DMACount=65535 Then DMAControl:=DMAControl+1;
   DMAEnd:=(DMACount=65535)And(DMAControl>2);
  End;
End;

Procedure InitBlaster(B:Word;I,D:Byte;Sz:Word);
Begin
 DSPBaseAddr:=B;
 IRQ:=I;
 DMA:=D;
 BufferSize:=Sz;
 DSPReset;
 SBSpeakerOn;
 SBSetInt;
 SBCreateBuffer(BufferSize);
 FullBuffer:=True;
 MonoMode:=True;
 FullBuffer:=True;
 DMASetLine(DMA);
 DMABusyAddresses;
 DMAControl:=0;
End;

Procedure CloseBlaster;
Begin
 DMAStop;
 DSPReset;
 SBSpeakerOff;
 SBResetInt;
End;



Procedure SBSpeakerOn;
Begin
 DSPWrite($D1);
End;

Procedure SBSpeakerOff;
Begin
 DSPWrite($D3);
End;

Procedure BufSwap(Var P1,P2:Buffer);
Var App:Buffer;
    AW:Word;
    AB:Byte;
Begin
 App:=P1;
 P1:=P2;
 P2:=App;
 AW:=DataLoad1;
 DataLoad1:=DataLoad2;
 DataLoad2:=Aw;
 VocBuffer1:=True;
 AB:=DMAPage1;
 DMAPage1:=DMAPage2;
 DMAPage2:=AB;
 AW:=DMAOffs1;
 DMAOffs1:=DMAOffs2;
 DMAOffs2:=AW;
End;

Procedure SBPlay(P:Buffer);
Begin
 FullBuffer:=False;
 SetIRQ(IRQ);
 DMAInitPlay(P,BufferSize);
 DSPDMAPlay(SampleRate,BufferSize);
End;

Procedure SBRecord(P:Buffer);
Begin
 FullBuffer:=False;
 SetIRQ(IRQ);
 DMAInitRecord(P,BufferSize);
 DSPDMARecord(SampleRate,BufferSize);
End;



Procedure SBCreateBuffer(Size:Word);
Begin
 GetMEM(DSPBuf1,Size);
 GetMEM(DSPBuf2,Size);
 FullBuffer:=False;
 BufferSize:=Size;
End;

Procedure SBDeleteBuffer(Size:Word);
Begin
 FreeMEM(DSPBuf1,Size);
 FreeMEM(DSPBuf2,Size);
 FullBuffer:=False;
End;

Procedure SBSetRate(Rate:Word);
Begin
 SampleRate:=Rate;
End;



Procedure SBSetInt;
Begin
 GetIntVec(IRQ+8,OldInt);
 SetIntVec(IRQ+8,@NewInt);
 FullBuffer:=False;
End;

Procedure SBResetInt;
Begin
 SetIntVec(IRQ,OldInt);
End;


Function VocTimeConst(Rate:Word):Byte;
Begin
 VocTimeConst:=Trunc(256-(1000000 Div Rate));
End;

Function VocBusyRate(Time:Word):Word;
Begin
 VocBusyRate:=Trunc(1000000 / (256-Time));
End;

Procedure VocOpen(Name:String);
Var VOCHead:Array[1..32] Of Byte;
Begin
 Assign(DSPFile,Name);
 ReSet(DSPFile,1);
 BlockRead(DSPFile,VOCHead,32,DSPReadFile);
 If (VOCHead[27]=1) Then SampleRate:=VocBusyRate(VOCHead[31]);
 VocFirstBlock:=True;
 VocSize:=FileSize(DSPFile);
 VocPos:=FilePos(DSPFile);
 VocEnd:=False;
End;

Procedure VocLoadBuf1;
Begin
 BlockRead(DSPFile,DSPBuf1^,BufferSize,DSPReadFile);
 DataLoad1:=DSPReadFile;
 VocPos:=FilePos(DSPFile);
 VocBuffer1:=False;
End;

Procedure VocLoadBuf2;
Begin
 BlockRead(DSPFile,DSPBuf2^,BufferSize,DSPReadFile);
 DataLoad2:=DSPReadFile;
 VocPos:=FilePos(DSPFile);
End;

Procedure VocClose;
Begin
 Close(DSPFile);
End;

Procedure VocPlay;
Var DEnd:Boolean;
Begin
 DEnd:=DMAEnd;
 If VocFirstBlock Then
  Begin
   VocLoadBuf1;
   If VocPos<VocSize Then VocLoadBuf2;
   VocFirstBlock:=False;
   SetIRQ(IRQ);
   DMAPage:=DMAPage1;
   DMAOffs:=DMAOffs1;
   DMAData:=DataLoad1;
   DMAInit;
   DSPDMAPlay(SampleRate,DataLoad1);
   BufSwap(DSPBuf1,DSPBuf2);
   DMAPage:=DMAPage1;
   DMAOffs:=DMAOffs1;
   DMAData:=DataLoad1;
  End Else
 If DEnd And Not Eof(DSPFile) Then
  Begin
   DMAReInit;
   DSPDMAPlay(SampleRate,DataLoad1);
   If VocPos<VocSize Then VocLoadBuf2;
   BufSwap(DSPBuf1,DSPBuf2);
   DMAPage:=DMAPage1;
   DMAOffs:=DMAOffs1;
   DMAData:=DataLoad1;
   VocBuffer1:=True;
  End Else
 If DEnd And Eof(DSPFile) And VocBuffer1 Then
  Begin
   DMAReInit;
   DSPDMAPlay(SampleRate,DataLoad1);
   VocBuffer1:=False;
  End Else
 If (DEnd And Eof(DSPFile) And  Not VocBuffer1)And VocLoop Then
  Begin
   Seek(DSPFile,31);
   VocFirstBlock:=True;
   VocPos:=FilePos(DSPFile);
  End Else VocEnd:=True;
End;


Procedure LoadVoc(Voc:String);
Var App:Boolean;
Begin
 VocOpen(Voc);
 App:=VocLoop;
 VocSetNoLoop;
 VocEnd:=False;
 Repeat
  VocPlay;
 Until VocEnd;
 VocClose;
 VocLoop:=App;
End;



Procedure VocSetLoop;
Begin
 VocLoop:=True;
End;

Procedure VocSetNoLoop;
Begin
 VocLoop:=False;
End;


{---------------------------------------------------------------------------}

Procedure FMSetRight;Assembler;
Asm
 Mov FMRight,True
 Mov AX,DSPBaseAddr
 Mov FMRightPort,AX
End;
Procedure FMSetNoRight;Assembler;
Asm
 Mov FMRight,False
End;
Procedure FMSetLeft;Assembler;
Asm
 Mov FMLeft,True
 Mov AX,DSPBaseAddr
 Mov FMLeftPort,AX
 Add DX,2
End;
Procedure FMSetNoLeft;Assembler;
Asm
 Mov FMLeft,True;
End;
Procedure FMRightCommand(C:Byte);Assembler;
Asm
 Mov DX,FMRightPort
 Mov AL,C
 Out DX,AL
 Mov CX,06h
 @Ciclo:
  In AL,DX
 Loop @Ciclo
End;
Procedure FMLeftCommand(C:Byte);Assembler;
Asm
 Mov DX,FMLeftPort
 Mov AL,C
 Out DX,AL
 Mov CX,06h
 @Ciclo:
  In AL,DX
 Loop @Ciclo
End;
Procedure FMRightData(C:Byte);Assembler;
Asm
 Mov DX,FMRightPort
 Mov AL,C
 Inc DX
 Out DX,AL
 Dec DX
 Mov CX,24h
 @Ciclo:
  In AL,DX
 Loop @Ciclo
End;
Procedure FMLeftData(C:Byte);Assembler;
Asm
 Mov DX,FMLeftPort
 Mov AL,C
 Inc DX
 Out DX,AL
 Dec DX
 Mov CX,24h
 @Ciclo:
  In AL,DX
 Loop @Ciclo
End;
Function FMGetRightState:Byte;Assembler;
Asm
 Mov DX,FMRightPort
 In AL,DX
End;
Function FMGetLeftState:Byte;Assembler;
Asm
 Mov DX,FMLeftPort
 In AL,DX
End;

Procedure FMSetBoth;Assembler;
Asm
 Mov FMBoth,True;
 Mov AX,0388h
 Mov FMBothPort,AX
End;
Procedure FMSetNoBoth;Assembler;
Asm
 Mov FMBoth,False
End;

Procedure FMBothCommand(C:Byte);Assembler;
Asm
 Mov DX,FMBothPort
 Mov AL,C
 Out DX,AL
 Mov CX,06h
 @Ciclo:
  In AL,DX
 Loop @Ciclo
End;

Procedure FMBothData(C:Byte);Assembler;
Asm
 Mov DX,FMBothPort
 Mov AL,C
 Inc DX
 Out DX,AL
 Dec DX
 Mov CX,24h
 @Ciclo:
  In AL,DX
 Loop @Ciclo
End;

Function FMGetBothState:Byte;Assembler;
Asm
 Mov DX,FMBothPort
 In AL,DX
End;

Function FMDetect:Boolean;
 Var Status1,Status2:Byte;
Begin
 FMSetBoth;
 FMBothCommand($04);
 FMBothData($60);
 FMBothCommand($04);
 FMBothData($80);
 Status1:=FMGetBothState;
 FMBothCommand($02);
 FMBothData($FF);
 FMBothCommand($04);
 FMBothData($21);
 Delay(100);
 Status2:=FMGetBothState;
 FMSetBoth;
 FMBothCommand($04);
 FMBothData($60);
 FMBothCommand($04);
 FMBothData($80);
 Asm
  Mov AL,0E0h
  And Status1,AL
  And Status2,AL
 End;
 If (Status1=0)And(Status2=$C0) Then FMDetect:=True Else FMDetect:=False;
End;

Procedure FMReset;
 Var I:Byte;
Begin
 For I:=0 To 255 Do
  Begin
   FMBothCommand(I);
   FMBothData(0);
  End;
 FMBothCommand($01);
 FMBothData(32);
End;

Procedure FMBothCD(Com,Dat:Byte);
Begin
 FMBothCommand(Com);
 FMBothData(Dat);
End;

Procedure FMBothOn;
Begin
 FMBothCommand($B0);
 FMBothData($31);
End;

Procedure FMBothOff;
Begin
 FMBothCommand($B0);
 FMBothData($11);
End;


Function FMFreqCod(F:Real):Word;
Begin
 If (F>=0)And(F<=785) Then FMFreqCod:=Round(F*1.30952) Else FMFreqCod:=0;
End;

Procedure FMSound(F:Real;O:Byte);
 Var Fr:Word;
     Cw:Byte;
Begin
 If (O>=1)And(O<=8) Then O:=O-1;
 If F<0 Then F:=0 Else If F>780 Then F:=780;
 Cw:=$20;
 Fr:=FMFreqCod(F);
 FMBothCD($A0,Lo(Fr));
 Fr:=Hi(Fr);
 Cw:=Cw+(O*4)+Fr;
 FMBothCD($B0,Cw);
End;

{Funzioni per la grafica tridimensionale:}

Procedure Load3DS(Name:String;Var Obj3D:Object3D);
Const
 Main3DS=$4D4D;
 Edit3DS=$3D3D;
 Keyf3DS=$B000;
 OBJDesc=$4000;
 VertOBJ=$4100;
 VertLst=$4110;
 FaceLst=$4120;
Var F:File;
    R:Word;
    ID_Chunk:Word;
    Ln_Chunk:LongInt;
    ObjName:String;
    C:Char;
    I:Integer;

    J:Integer;
Begin
 Obj3D.ObjectName:='';
 Assign(F,Name);
 Reset(F,1);
 BlockRead(F,ID_Chunk,2,R);
 BlockRead(F,Ln_Chunk,4,R);
 Seek(F,FilePos(F));

 If ID_Chunk=Main3DS Then
  Begin
   J:=-20;
   While Not Eof(F) Do
    Begin
     BlockRead(F,ID_Chunk,2,R);
     BlockRead(F,Ln_Chunk,4,R);

     If ID_Chunk=Edit3DS Then
      Begin
      End Else
     If ID_Chunk=ObjDesc Then
      Begin
       Asm Mov Byte PTR ObjName,0 End;
       BlockRead(F,C,1,R);
       While C<>#0 Do
        Begin
         ObjName:=ObjName+C;
         BlockRead(F,C,1,R);
        End;
       Obj3D.ObjectName:=ObjName;
      End Else
     If ID_Chunk=VertOBJ Then
      Begin
      End Else
     If ID_Chunk=VertLST Then
      Begin
       BlockRead(F,Obj3D.NVertex,2,R);
       For I:=1 To Obj3d.NVertex Do BlockRead(F,Obj3D.LocalVertex[I],12,R);
      End Else
     If ID_Chunk=FaceLST Then
      Begin
       BlockRead(F,Obj3d.NPoly,2,R);
       For I:=1 To Obj3d.NPoly Do
        Begin
         BlockRead(F,Obj3D.ObjectPoly[I],6,R);
         Obj3D.ObjectPoly[I].V1:=Obj3D.ObjectPoly[I].V1+1;
         Obj3D.ObjectPoly[I].V2:=Obj3D.ObjectPoly[I].V2+1;
         Obj3D.ObjectPoly[I].V3:=Obj3D.ObjectPoly[I].V3+1;
         Seek(F,FilePos(F)+2);
        End;
      End Else
     If ID_Chunk=Keyf3DS Then
      Begin
      End Else Seek(F,FilePos(F)+Ln_Chunk-6);
    End;
  End;
 Close(F);
End;


Procedure OBJ3D_SetWorldPos(X,Y,Z:Integer;Var Obj3D:Object3D);
Begin
 Obj3D.WorldPos.X:=X;
 Obj3D.WorldPos.Y:=Y;
 Obj3D.WorldPos.Z:=Z;
End;

Procedure OBJ3D_SetLocalPos(X,Y,Z:Integer;Var Obj3D:Object3D);
Begin
 Obj3D.LocalPos.X:=X;
 Obj3D.LocalPos.Y:=Y;
 Obj3D.LocalPos.Z:=Z;
End;




Procedure OBJ3D_Move(X,Y,Z:Integer;Var Obj3D:Object3D);
Begin
 Obj3D.WorldPos.X:=Obj3D.WorldPos.X+X;
 Obj3D.WorldPos.Y:=Obj3D.WorldPos.Y+Y;
 Obj3D.WorldPos.Z:=Obj3D.WorldPos.Z+Z;
 Obj3D.LocalPos.X:=Obj3D.LocalPos.X+X;
 Obj3D.LocalPos.Y:=Obj3D.LocalPos.Y+Y;
 Obj3D.LocalPos.Z:=Obj3D.LocalPos.Z+Z;
End;

Procedure OBJ3D_ReDim(Scala:Single;Var Obj3D:Object3D);
Var I:Integer;
Begin
 With Obj3D Do
  Begin
   For I:=1 To NVertex Do
    Begin
     LocalVertex[I].X:=LocalVertex[I].X*Scala;
     LocalVertex[I].Y:=LocalVertex[I].Y*Scala;
     LocalVertex[I].Z:=LocalVertex[I].Z*Scala;
    End;
  End;
End;

Procedure OBJ3D_RotateX(Angolo:Integer;Var Obj3D:Object3D);
Var I:Integer;
    Yr,Zr:Single;
Begin
 With Obj3D Do
  Begin
   For I:=1 To NVertex Do
    Begin
     LocalVertex[I].Y:=LocalVertex[I].Y+LocalPos.Y;
     LocalVertex[I].Z:=LocalVertex[I].Z+LocalPos.Z;
     Yr:=LocalVertex[I].Y * CosTbl[Angolo] + LocalVertex[I].Z * SinTbl[Angolo];
     Zr:=LocalVertex[I].Y * -SinTbl[Angolo] + LocalVertex[I].Z * CosTbl[Angolo];
     LocalVertex[I].Y:=Yr-LocalPos.Y;
     LocalVertex[I].Z:=Zr-LocalPos.Z;
    End;
  End;
End;

Procedure OBJ3D_RotateY(Angolo:Integer;Var Obj3D:Object3D);
Var I:Integer;
    Xr,Zr:Single;
Begin
 With Obj3D Do
  Begin
   For I:=1 To NVertex Do
    Begin
     LocalVertex[I].X:=LocalVertex[I].X+LocalPos.X;
     LocalVertex[I].Z:=LocalVertex[I].Z+LocalPos.Z;
     Xr:=LocalVertex[I].X * CosTbl[Angolo] + LocalVertex[I].Z * -SinTbl[Angolo];
     Zr:=LocalVertex[I].X * SinTbl[Angolo] + LocalVertex[I].Z * CosTbl[Angolo];
     LocalVertex[I].X:=Xr-LocalPos.X;
     LocalVertex[I].Z:=Zr-LocalPos.Z;
    End;
  End;
End;

Procedure OBJ3D_RotateZ(Angolo:Integer;Var Obj3D:Object3D);
Var I:Integer;
    Xr,Yr:Single;
Begin
 With Obj3D Do
  Begin
   For I:=1 To NVertex Do
    Begin
     LocalVertex[I].X:=LocalVertex[I].X+LocalPos.X;
     LocalVertex[I].Y:=LocalVertex[I].Y+LocalPos.Y;
     Xr:=LocalVertex[I].X * CosTbl[Angolo] - LocalVertex[I].Y * SinTbl[Angolo];
     Yr:=LocalVertex[I].X * SinTbl[Angolo] + LocalVertex[I].Y * CosTbl[Angolo];
     LocalVertex[I].X:=Xr-LocalPos.X;
     LocalVertex[I].Y:=Yr-LocalPos.Y;
    End;
  End;
End;



Procedure OBJ3D_Rotate(AngoloX,AngoloY,AngoloZ:Integer;Var Obj3D:Object3D);
Begin
 If AngoloX<>0 Then OBJ3D_RotateX(AngoloX,Obj3D);
 If AngoloY<>0 Then OBJ3D_RotateY(AngoloY,Obj3D);
 If AngoloZ<>0 Then OBJ3D_RotateZ(AngoloZ,Obj3D);
End;


Procedure OBJ3D_Transform(Var Obj3D:Object3D);
Var I:Integer;
Begin
 With Obj3D Do
  Begin
   For I:=1 To NVertex Do
    Begin
     GlobalVertex[I].X:=LocalVertex[I].X+WorldPos.X;
     GlobalVertex[I].Y:=LocalVertex[I].Y+WorldPos.Y;
     GlobalVertex[I].Z:=LocalVertex[I].Z+WorldPos.Z;
    End;
  End;
End;

Var ViewCode:Byte;

Procedure SetParallelView;
Begin
 ViewCode:=ViewParallel;
End;

Procedure SetProspectView;
Begin
 ViewCode:=ViewProspect;
End;




Procedure OBJ3D_PutVertex(Var Obj3D:Object3D);
Var I:Integer;
    Xp,Yp:Integer;
Begin
 If ViewCode=ViewParallel Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NVertex Do
      Begin
       Xp:=Round(GlobalVertex[I].X);
       Yp:=Round(GlobalVertex[I].Y);
       PutPixel(XCentre+Xp,YCentre-Yp,250);
      End;
    End;
  End Else
 If ViewCode=ViewProspect Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NVertex Do
      Begin
       {
       ObjDist:=GlobalVertex[I].Z;
       Xp:=Round(GlobalVertex[I].X * (ObjDist/GlobalVertex[I].Z));
       Yp:=Round(GlobalVertex[I].Y * (ObjDist/GlobalVertex[I].Z)*AspectRatio);
       BufPixel(XCentre+Xp,YCentre-Yp,250);}
      End;
    End;
  End;
End;

Procedure OBJ3D_BufVertex(Var Obj3D:Object3D);
Var I:Integer;
    Xp,Yp:Integer;
Begin
 If ViewCode=ViewParallel Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NVertex Do
      Begin
       Xp:=Round(GlobalVertex[I].X);
       Yp:=Round(GlobalVertex[I].Y);
       BufPixel(XCentre+Xp,YCentre-Yp,250);
      End;
    End;
  End Else
 If ViewCode=ViewProspect Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NVertex Do
      Begin
       {
       ObjDist:=GlobalVertex[I].Z;
       Xp:=Round(GlobalVertex[I].X * (ObjDist/GlobalVertex[I].Z));
       Yp:=Round(GlobalVertex[I].Y * (ObjDist/GlobalVertex[I].Z)*AspectRatio);
       BufPixel(XCentre+Xp,YCentre-Yp,250);}
      End;
    End;
  End;
End;


Procedure OBJ3D_SfnVertex(Var Obj3D:Object3D);
Var I:Integer;
    Xp,Yp:Integer;
Begin
 If ViewCode=ViewParallel Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NVertex Do
      Begin
       Xp:=Round(GlobalVertex[I].X);
       Yp:=Round(GlobalVertex[I].Y);
       SfnPixel(XCentre+Xp,YCentre-Yp,250);
      End;
    End;
  End Else
 If ViewCode=ViewProspect Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NVertex Do
      Begin
       {
       ObjDist:=GlobalVertex[I].Z;
       Xp:=Round(GlobalVertex[I].X * (ObjDist/GlobalVertex[I].Z));
       Yp:=Round(GlobalVertex[I].Y * (ObjDist/GlobalVertex[I].Z)*AspectRatio);
       BufPixel(XCentre+Xp,YCentre-Yp,250);}
      End;
    End;
  End;
End;


Procedure OBJ3D_PutInWireFrame(Var Obj3D:Object3D);
Var I:Integer;
    Xp1,Yp1,Xp2,Yp2,Xp3,Yp3:Integer;
Begin
 If ViewCode=ViewParallel Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NPoly Do
      Begin
       Xp1:=Round(GlobalVertex[ObjectPoly[I].V1].X);
       Yp1:=Round(GlobalVertex[ObjectPoly[I].V1].Y);
       Xp2:=Round(GlobalVertex[ObjectPoly[I].V2].X);
       Yp2:=Round(GlobalVertex[ObjectPoly[I].V2].Y);
       Xp3:=Round(GlobalVertex[ObjectPoly[I].V3].X);
       Yp3:=Round(GlobalVertex[ObjectPoly[I].V3].Y);
       BufTriangle(XCentre+Xp1,YCentre-Yp1,XCentre+Xp2
        ,YCentre-Yp2,XCentre+Xp3,YCentre-Yp3,250);
      End;
    End;
  End Else
 If ViewCode=ViewProspect Then
  Begin
  End;
End;

Procedure OBJ3D_BufInWireFrame(Var Obj3D:Object3D);
Var I:Integer;
    Xp1,Yp1,Xp2,Yp2,Xp3,Yp3:Integer;
Begin
 If ViewCode=ViewParallel Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NPoly Do
      Begin
       Xp1:=Round(GlobalVertex[ObjectPoly[I].V1].X);
       Yp1:=Round(GlobalVertex[ObjectPoly[I].V1].Y);
       Xp2:=Round(GlobalVertex[ObjectPoly[I].V2].X);
       Yp2:=Round(GlobalVertex[ObjectPoly[I].V2].Y);
       Xp3:=Round(GlobalVertex[ObjectPoly[I].V3].X);
       Yp3:=Round(GlobalVertex[ObjectPoly[I].V3].Y);
       BufTriangle(XCentre+Xp1,YCentre-Yp1,XCentre+Xp2
        ,YCentre-Yp2,XCentre+Xp3,YCentre-Yp3,250);
      End;
    End;
  End Else
 If ViewCode=ViewProspect Then
  Begin
  End;
End;

Procedure OBJ3D_SfnInWireFrame(Var Obj3D:Object3D);
Var I:Integer;
    Xp1,Yp1,Xp2,Yp2,Xp3,Yp3:Integer;
Begin
 If ViewCode=ViewParallel Then
  Begin
   With Obj3D Do
    Begin
     For I:=1 To NPoly Do
      Begin
       Xp1:=Round(GlobalVertex[ObjectPoly[I].V1].X);
       Yp1:=Round(GlobalVertex[ObjectPoly[I].V1].Y);
       Xp2:=Round(GlobalVertex[ObjectPoly[I].V2].X);
       Yp2:=Round(GlobalVertex[ObjectPoly[I].V2].Y);
       Xp3:=Round(GlobalVertex[ObjectPoly[I].V3].X);
       Yp3:=Round(GlobalVertex[ObjectPoly[I].V3].Y);
       SfnTriangle(XCentre+Xp1,YCentre-Yp1,XCentre+Xp2
        ,YCentre-Yp2,XCentre+Xp3,YCentre-Yp3,250);
      End;
    End;
  End Else
 If ViewCode=ViewProspect Then
  Begin
  End;
End;


Begin
 WriteLn('CGRAPH interfaccia grafica di Giovanni Ceglia.');
 WriteLn;
 WriteLn('Controllo dei Driver esterni neccessari...');
 WriteLn('Controllo per il Driver VESA...');
 GetVesa;
 If NoVesa Then Errore('E'' richiesto un VESA Driver.');
 WriteLn('Driver Vesa v',VgaInfoBlock.VesaVers Div 100,'.',VgaInfoBlock.VesaVers Mod 100);
 WriteLn('Memoria Video in Byte ',VgaInfoBlock.TotalMem*65536);
 WriteLn('Controllo per il Driver XMS...');
 XMS_Exist:=False;
 XMS_Error:=False;
 XMS_Free:=0;
 HMA_Exist:=False;
 XMS_MaxBlk:=0;
 XMS_Point:=Nil;
 InitXMS;
 If Not XMS_Exist Then Errore('E'' richiesto Driver XMS v2.0 o superiore.');
 XMSVerM:=Hi(XMSGetVer);
 XMSVerE:=Lo(XMSGetVer);
 If XMSVerM<2 Then Errore('E'' richiesto Driver XMS v2.0 o superiore.');
 WriteLn('Trovato Driver XMS v',XMSVerM,'.',XMSVerE);
 TransfertXMS(1);
 XMSInfoMem;
 WriteLn('Numero massimo di blocchi allocabili:',XMS_MaxBlk);
 WriteLn('Massima memoria XMS libera          :',XMS_Free);
 InitMouse;
 If Ms.Esiste Then
  Begin
   WriteLn('Trovato un Mouse con un Driver caricato.');
   WriteLn('Il Mouse  un mouse a ',Ms.NButtons,' tasti.');
  End Else
  Begin
   WriteLn('Non presente nel sistema alcuna unita di puntamento tipo MOUSE.');
  End;

 PixelStep:=0;
 PixelLengTh:=1;
 ChrDim(1,1);
 Font:=Nil;
 SetCirclePrecision(200);

 PIGreco:=3.1415926535897932385;
 GradFat:=180/PiGreco;
 RadFat:=PiGreco/180;

 VirtualDim:=FALSE;
 CreateSinCosTable;
 PaletteMode:=False;
 NoFliDelay:=True;
End.